10 '**************************************************************************
20 'Chapter 11, Example 1: Random Number Generators & their Tests
30 'COMPUTATIONAL PHYSICS: An Introduction
40 'by R. C. Verma, P. K. Ahluwalia and K. C. Sharma
50 '   * * * *   
60 '**************************************************************************
70 '
80  GOSUB 15000                                                   'show header
90  FLAG = 0                                                         'set flag
100 '
110 DIM X(5000), NR(100), VA(15, 15)                 'set dimensions of arrays
120 '
130 GOSUB 1000                 'introduce the problem & make different choices
140 '
150 CLS
160 LOCATE 22, 1: BEEP: PRINT "press any key to continue"
170 IF INKEY$ = "" THEN 170
180 '
190 CLS
200 BEEP: LOCATE 22, 1: PRINT SPACE$(75)
210 LOCATE 22, 1: INPUT "Do you want to generate another set? Y/N "; ANS$
220  IF LEFT$(ANS$, 1) = "Y" OR LEFT$(ANS$, 1) = "y" THEN 240
225  IF LEFT$(ANS$, 1) = "N" OR LEFT$(ANS$, 1) = "n" THEN 245
230  BEEP: GOTO 200
235 '
240 FLAG = 1: GOTO 130                                            'change flag
245 '
250 END
260 '
1000 '************************************************************************
1010 'subroutine to introduce the problem & to make different choices
1020 'input variables:  TYP%
1030 'output variables: NRAN%
1040 'global variables: none
1050 'local variables: ANS$
1060 '************************************************************************
1070 '
1080 IF FLAG <> 0 THEN 1130    'if not first time, jump over following message
1085 LOCATE 2, 1: PRINT "This program generates random numbers & "
1090 LOCATE 3, 5: PRINT "tests quality of the numbers."
1095 LOCATE 4, 1: PRINT "----------------------------------------"
1100 '
1105 BEEP: LOCATE 22, 1: PRINT "press any key to continue"
1110  IF INKEY$ = "" THEN 1110
1120 '
1130 GOSUB 10000                   'to choose the type of Random No. Generator
1135 CLS
1150 PRINT : BEEP
1160 LOCATE 7, 1: INPUT " Give no. of random numbers <= 5000 = "; NRAN%
1170  IF NRAN% > 0 AND NRAN% <= 5000 THEN 1200
1180  BEEP: LOCATE 7, 1: PRINT SPACE$(75): GOTO 1160
1190 '
1200 CLS
1210 ON TYP% GOSUB 9000, 6000, 8000, 7000     'generate set of random numbers
1220 '
1225 PRINT : PRINT "press any key to continue"
1230  IF INKEY$ = "" THEN 1230
1235 '
1240 GOSUB 11000                              'choose type of test random nos.
1245 ON TEST% GOSUB 2000, 3000, 4000, 5000        'perform test of random nos.
1250 PRINT
1260 BEEP: INPUT "Do you want to perform any test again?  Y/N "; ANS$
1280  IF LEFT$(ANS$, 1) = "Y" OR LEFT$(ANS$, 1) = "y" THEN 1295
1285  IF LEFT$(ANS$, 1) = "N" OR LEFT$(ANS$, 1) = "n" THEN 1300
1290  GOTO 1260
1295  CLS : GOTO 1240
1300 '
1310 RETURN
1320 '
2000 '************************************************************************
2010 'subroutine for uniformity test
2020 'input variables: X(I%), NRAN%, CLASS%,
2030 'output variables: CHI, NR(J%)
2040 'global variables: none
2050 'local variables: EXPECT, H, SUM
2060 '************************************************************************
2070 '
2080 PRINT : PRINT "Give no. of classes  < "; NRAN%
2090 INPUT CLASS%
2100  IF CLASS% > 0 AND CLASS% <= NRAN% THEN 2120
2110  BEEP: PRINT "Try again!": GOTO 2090
2120    PRINT
2130 EXPECT = NRAN% / CLASS%                'expected random no. in each class
2140 H = 1 / CLASS%                                     'find width of a class
2150 '
2160 FOR J% = 1 TO CLASS%: NR(J%) = 0: NEXT J%           'initialize the class
2170 '
2180 FOR I% = 1 TO NRAN%
2190    FOR J% = 1 TO CLASS%             'loop to count the nos. in each class
2200      IF X(I%) > (J% - 1) * H AND X(I%) <= J% * H THEN NR(J%) = NR(J%) + 1
2210    NEXT J%
2220 NEXT I%
2230 '
2240 SUM = 0
2250 '
2260 FOR J% = 1 TO CLASS%
2270   SUM = SUM + (EXPECT - NR(J%)) ^ 2               'chi-square test begins
2280   PRINT "no of random nos. falling in "; J%; "th interval = "; NR(J%)
2290 NEXT J%
2300 '
2310 CHI = SUM / NRAN%                                       'find chi-squared
2320 PRINT
2330 PRINT "chi-squared = "; CHI: PRINT
2340 '
2350 RETURN
2360 '
3000 '************************************************************************
3010 'subroutine for  autocorrelation test
3020 'input variables: NRAN%, X(I%), KK%
3030 'output variables: CORR
3040 'global variables: none
3050 'local variables: SUM1, SUM2, SUMK, SUMIK, AVX, AVX2, AVXK, AVXIK, NLEFT%
3060 '************************************************************************
3070 '
3080 SUM1 = 0: SUM2 = 0
3090 '
3100 FOR I% = 1 TO NRAN%                                     'find <x> & <x*x>
3110  SUM1 = SUM1 + X(I%)
3120  SUM2 = SUM2 + X(I%) * X(I%)
3130 NEXT I%
3140 '
3150 AVX = SUM1 / NRAN%
3160 AVX2 = SUM2 / NRAN%
3170 PRINT " <x> = "; AVX; "  < x x > = "; AVX2: PRINT
3180 '
3190 PRINT "Give no of term < "; NRAN%; " for correlation"
3200 INPUT KK%
3210  IF KK% > 0 AND KK% <= NRAN% AND INT(KK%) = KK% THEN 3230
3220  BEEP: PRINT "Try again!": GOTO 3200
3230     PRINT                                 'find <x(i)*x(i+k)> & <x(i+k) >
3240  SUMK = 0: SUMIK = 0
3250  NLEFT% = NRAN% - KK%
3260 '
3270 FOR I% = 1 TO NLEFT%
3280   SUMIK = SUMIK + X(I%) * X(I% + KK%)
3290   SUMK = SUMK + X(I% + KK%)
3300 NEXT I%
3310 '
3320  AVXK = SUMK / NLEFT%: AVXIK = SUMIK / NLEFT%
3330  CORR = (AVXIK - AVX * AVXK) / (AVX2 - AVX * AVX)'find autocorrelation fn.
3340  PRINT "c("; KK%; ") = "; CORR,
3350 '
3360 RETURN
3370 '
4000 '************************************************************************
4010 'subroutine for periodicity test
4020 'input variables: X(I%), NRAN%
4030 'output variables: none
4040 'global variables: none
4050 'local variables: P, A, X0, X1,Y1, XD, XGRAPH, YGRAPH
4060 '************************************************************************
4070 PRINT
4080 INPUT " probability for forward step = "; P
4090   IF P <= 1 AND P >= 0 THEN 4110
4100   BEEP: PRINT "please give probability 0 < p < 1": GOTO 4080
4110   CLS
4120 A = 1                                                          'step size
4130 X0 = 0                                                  'initial position
4140 X1 = 1: Y1 = 100                                        'origin for graph
4150 XD = X0                                         'restore initial position
4160 '
4170  FOR I% = 1 TO NRAN%                           'loop over number of steps
4180    IF X(I%) < P THEN XD = XD + A                            'step forward
4190    IF X(I%) >= P THEN XD = XD - A                          'step backward
4200    LOCATE 20, 2
4210    PRINT " step = "; I; ", random no. = "; X(I%); ",  distance = "; XD
4220    YGRAPH = -XD + 100: XGRAPH = I% + 1
4230    IF I% = 1 THEN PSET (XGRAPH, YGRAPH) ELSE LINE -(XGRAPH, YGRAPH)
4240  NEXT I%
4250 '
4260 RETURN
4270 '
5000 '************************************************************************
5010 'subroutine for correlation test using decay law
5020 'input variables: X(I%),  NRAN%,
5030 'output variables: FRAC, DEC
5040 'global variables: none
5050 'local variables: SCL%, VA(I%,J%), DECAY%, XG, YG, LOGF
5060 '************************************************************************
5070 '
5080 SCL% = 15                                       'lattice points (row,col)
5090 CLS
5100 '
5110 FOR I% = 1 TO SCL%
5120   FOR J% = 1 TO SCL%                                    'draw the lattice
5130     LOCATE I%, J%: PRINT "+"
5140     VA(I%, J%) = 1
5150   NEXT J%
5160 NEXT I%
5170 '
5180 RANDOMIZE TIMER
5190 DECAY% = 0
5200 '
5210  FOR I% = 1 TO NRAN% STEP 2                    'hitting the lattice sites
5220   XG = X(I%) * SCL%: YG = X(I% + 1) * SCL%
5230   IF VA(XG, YG) = 0 THEN 5250
5240   VA(XG, YG) = 0: DECAY% = DECAY% + 1: LOCATE XG, YG: PRINT "o"
5250 NEXT I%
5260 '
5270 LOCATE 18, 1: PRINT "press any key to continue"
5280 IF INKEY$ = "" THEN 5280
5290 '
5300 FRAC = 1 - DECAY% / (SCL% * SCL%)      'find fraction of surviving nuclei
5310 LOGF = LOG(FRAC)
5320  DEC = NRAN% / LOGF                                  'find decay constant
5330 LOCATE 20, 1: PRINT "fraction survived = "; FRAC
5340 LOCATE 22, 1: PRINT "decay constant = "; DEC
5350 '
5360 RETURN
5370 '
6000 '************************************************************************
6010 'subroutine for random number generator : modulo method
6020 '                               or multiplicative congruential  generator
6030 'input variables: NRAN%, AZ, CZ, MZ, SEED
6040 'output variables: X(I%)
6050 'global variables: none
6060 'local variables: DIC, SEED
6070 '************************************************************************
6080 '
6090 CLS : PRINT
6100 INPUT "Enter magic numbers: a,c,m = "; AZ, CZ, MZ
6110  IF AZ > 0 AND CZ > 0 AND MZ > 0 THEN 6130
6120  BEEP: PRINT "Give +ve values for numbers a,c,m": GOTO 6100
6130    PRINT
6140 INPUT "Give seed  = "; SEED
6150  IF SEED > 0 THEN 6170
6160  BEEP: PRINT "Give +ve value for seed": GOTO 6140
6170 PRINT
6180 '
6190 X(1) = SEED / MZ: X(1) = X(1) - INT(X(1))                 'find first no.
6200 PRINT X(1);
6210 '
6220 FOR I% = 2 TO NRAN%
6230  DIC = (SEED * AZ + CZ) / MZ
6240  X(I%) = DIC - INT(DIC)                             'find next random no.
6250  SEED = CINT(X(I%) * MZ)                                  'find next seed
6260  PRINT X(I%);
6270 NEXT I%
6280  PRINT
6290 '
6300 RETURN
6310 '
7000 '************************************************************************
7010 'subroutine for true random number generator from PC keyboard
7020 'input variables: NRAN%
7030 'output variables: X(I%)
7040 'global variables: none
7050 'local variables: COUNTER%
7060 '************************************************************************
7070 '
7080 CLS : PRINT
7090 PRINT : PRINT "start pressing the keys on the key-board !": PRINT
7100 '
7110 COUNTER% = 1
7120 IF COUNTER% = NRAN% + 1 THEN 7260
7130 '
7140 FOR I% = 1 TO 100
7150   IF INKEY$ = "" THEN 7200            'check for input from the key-board
7160   X(COUNTER%) = I% / 100                                  'get random no.
7170   PRINT X(COUNTER%),
7180   COUNTER% = COUNTER% + 1                              'increment counter
7190   GOTO 7120                                                  'start again
7200 NEXT I%
7210 '
7220 IF COUNTER% <= NRAN% THEN 7140
7230                                 'start again if no random no. is obtained
7240 PRINT
7250 '
7260 RETURN
7270 '
8000 '************************************************************************
8010 'subroutine for generating random numbers by RND command
8020 'input variables: NRAN%
8030 'output variables: X(I%)
8040 'global variables: none
8050 'local variables:  none
8060 '************************************************************************
8070 '
8080 CLS : PRINT
8090 RANDOMIZE TIMER                                        'get a random seed
8100 '
8110 FOR I% = 1 TO NRAN%
8120  X(I%) = RND                                         'get next random no.
8130  PRINT X(I%);
8140 NEXT I%
8150  PRINT
8160 '
8170 RETURN
8180 '
9000 '************************************************************************
9010 'subroutine for mid square random number generator
9020 'input variables:  NRAN%
9030 'output variables: X(I%)
9040 'global variables: none
9050 'local variables:  SD, z#
9060 '************************************************************************
9070 '
9080 CLS : PRINT
9090 INPUT "Give 4 digit seed "; SD
9100  IF SD > 1000 AND SD < 10000 AND INT(SD) = SD THEN 9120
9110  BEEP: PRINT "Try again!": GOTO 9090
9120 PRINT
9130 '
9140 FOR I% = 1 TO NRAN%
9150   z = SD * SD                                         'square the seed
9160   z = INT(z / 100)                             'remove the last 2 digits
9170   SD = z - INT(z / 10000) * 10000            'remove the first 2 digits
9180   X(I%) = SD / 10000                         'convert it to less than 1
9190   PRINT X(I%);
9200 NEXT I%
9210    PRINT
9220 '
9230 RETURN
9240 '
9250 '
10000 '***********************************************************************
10010 'subroutine to choose type of random number generator
10020 'input variables:  none
10030 'output variables: TYP%
10040 'global variables: none
10050 'local variables:  none
10060 '***********************************************************************
10070 CLS
10080 PRINT : PRINT
10090 PRINT "Please choose the type of Random No. Generator": PRINT
10100 PRINT "1.  Mid Square Method ": PRINT
10110 PRINT "2.  Multiplicative Congruential Generator": PRINT
10120 PRINT "3.  BASIC RND command": PRINT
10130 PRINT "4.  True Random No. Generator": PRINT
10140 '
10150 BEEP: LOCATE 22, 10: INPUT "Press 1/2/3/4 for your choice"; TYP%
10160    IF TYP% = 1 OR TYP% = 2 OR TYP% = 3 OR TYP% = 4 THEN 10170
10165    LOCATE 22, 10: PRINT SPACE$(65): BEEP: GOTO 10150
10170 '
10180 RETURN
10190 '
11000 '***********************************************************************
11010 'subroutine to choose test of random numbers
11020 'input variables:  none
11030 'output variables: TEST%
11040 'global variables: none
11050 'local variables:  none
11060 '***********************************************************************
11070 CLS
11080 PRINT : PRINT : PRINT
11090 PRINT "Please choose the type of Random No. Generator": PRINT
11100 PRINT "1.  Uniformity test ": PRINT
11110 PRINT "2.  Autocorrelation test": PRINT
11120 PRINT "3.  Periodicity test : random walk method ": PRINT
11130 PRINT "4.  Correlation test: decay law method ": PRINT
11140 '
11150 BEEP: LOCATE 22, 10: INPUT "Press 1/2/3/4 for your choice"; TEST%
11160  IF TEST% = 1 OR TEST% = 2 OR TEST% = 3 OR TEST% = 4 THEN 11170
11165  LOCATE 22, 1: PRINT SPACE$(75): BEEP: GOTO 11150
11170 '
11180 RETURN
11190 '
15000 '***********************************************************************
15010 'subroutine to display header screen
15020 'input variables:  none
15030 'output variables: none
15040 'global variables: none
15050 'local variables:  none
15060 '***********************************************************************
15070 CLS : KEY OFF                                           'clear screen
15080 SCREEN 2, 0, 0: WIDTH 80                               'change screen
15090  '
15100 LINE (1, 1)-(638, 40), , B                                'draw boxes
15110 LINE (5, 3)-(633, 37), , B
15120 LINE (70, 50)-(570, 140), , B
15130 LINE (75, 53)-(565, 137), , B
15140                                           'print title, authors, etc.
15150 LOCATE 3, 7
15160 PRINT " C O M P U T A T I O N A L   P H Y S I C S :";
15170 PRINT " (An  Introduction)"
15180 LOCATE 9, 40
15190 PRINT "by";
15200 LOCATE 11, 20: PRINT "R.C. Verma, P.K. Ahluwalia & K.C. Sharma"
15210 LOCATE 13, 34
15220 PRINT "   * * * *    "
15230 '
15240 BEEP
15250 LOCATE 15, 35: PRINT "* * * * * *"
15260 LOCATE 22, 25: PRINT "press any key to continue"
15270 LOCATE 23, 25: PRINT "-------------------------"
15280 '
15290 IF INKEY$ = "" THEN 15290                            'hold the screen
15300 CLS                                                     'clear screen
15310 RETURN
15320 '

