10 '**************************************************************************
20 'Chapter 13, Example 1: Demonstration of Brownian motion 
30 'COMPUTATIONAL PHYSICS: An Introduction 
40 'by R. C. Verma, P. K. Ahluwalia and K. C. Sharma
50 '   * * * *     
60 '**************************************************************************
70 '
80  GOSUB 10000                                                   'show header
90 '
100 GOSUB 1000                   'introduce the problem & get input parameters
110 '
120 GOSUB 2000                                           'draw Brownian motion
130 '
140 LOCATE 22,1
150 IF INKEY$="" THEN 150
160 '
170 CLS: LOCATE 12,15: BEEP: PRINT " Thank you !"
180 END
190 '
1000 '************************************************************************
1010 'subroutine to introduce the problem & to get input variables
1020 'input variables:  none
1030 'output variables: N
1040 'global variables: none
1050 'local variables:  none
1060 'test cases: N = 100
1070 '************************************************************************
1080 '
1090 LOCATE 2, 5: PRINT "This program simulates Brownian motion "
1100 LOCATE 4,5:  PRINT "---------------------------------------"
1110 '
1120 LOCATE 6,5: INPUT "Please give no. of steps =< 1000 ";N
1130  IF N>0 AND N<=1000 AND INT(N)=N THEN 1150
1140  BEEP: LOCATE 6,5: PRINT SPACE$(70): GOTO 1120
1150 '
1160 RETURN
1170 '
2000 '************************************************************************
2010 'subroutine to draw & find average path
2020 'input variables: N
2030 'output variables: AVDIS
2040 'global variables: none
2050 'local variables:  DIS, X1, X2, Y1, Y2, PXMIN%, PYMIN%, PXMAX%, PYMAX%
2060 'local variables:  K1, K2, K3, K4
2070 '************************************************************************
2080 CLS                                                         'clear screen
2090 PXMIN%= 28: PYMIN%=28: PXMAX%=588: PYMAX%= 148      'choose screen region
2100                                    'scale coefficients (0< random no. <1) 
2110 K1 = PXMAX%-PXMIN% : K2= PXMIN%  
2120 K3 = PYMIN%-PYMAX% : K4= PYMAX%      
2130 '
2140 LOCATE 1,15: PRINT "* * * Brownian motion * * *"
2150 LINE (PXMIN%, PYMIN%) - (PXMAX%, PYMAX%), ,B    'draw container
2160 '
2170 RANDOMIZE TIMER
2180 '
2190 FOR I% = 1 TO N
2200   X2=RND*K1+K2                         'position of successive collisions
2210   Y2=RND*K3+K4
2220   IF I%=1 THEN 2280                                   'jump if first time
2230    DIS= SQR((X2-X1)^2+(Y2-Y1)^2)                        'free path length
2240    LOCATE 21,1
2245    PRINT USING "free path in #### th collision = ###.##";I%,DIS
2250    LINE (X1,Y1) - (X2,Y2)                             'draw the free path
2260    CIRCLE (X2,Y2),3
2270    SUMD=SUMD+DIS                               'total distance from start
2280   X1=X2:Y1=Y2                                          'roll the position
2290 NEXT I%
2300 '
2310 AVDIS=SUMD/N                                         'find mean free path
2320 LOCATE 22,5 :BEEP: PRINT "mean free path = ";AVDIS
2330 '
2340 RETURN
2350 '
10000 '***********************************************************************
10010 'subroutine to display header screen
10020 'input variables:  none
10030 'output variables: none
10040 'global variables: none
10050 'local variables:  none
10060 '***********************************************************************
10070 CLS: KEY OFF                                            'clear screen
10080 SCREEN 2,0,0: WIDTH 80                                 'change screen
10090  '
10100 LINE (1,1)-(638,40),,B                                    'draw boxes
10110 LINE (5,3)-(633,37),,B
10120 LINE (70,50)-(570,140),,B
10130 LINE (75,53)-(565,137),,B
10140                                           'print title, authors, etc.
10150 LOCATE 3,7
10160 PRINT " C O M P U T A T I O N A L   P H Y S I C S :";
10170 PRINT " (An  Introduction)"
10180 LOCATE 9,40
10190 PRINT "by";
10200 LOCATE 11,20: PRINT "R.C. Verma, P.K. Ahluwalia & K.C. Sharma"
10210 LOCATE 13,34
10220 PRINT "   * * * *    "
10230 '
10240 BEEP
10250 LOCATE 15,35:  PRINT "* * * * * *"
10260 LOCATE 22,25:  PRINT "press any key to continue"
10270 LOCATE 23,25:  PRINT "-------------------------"
10280 '
10290 IF INKEY$="" THEN 10290		                   'hold the screen
10300 CLS                                  		      'clear screen
10310 RETURN
10320 '
