10 '**************************************************************************
20 'Chapter 14, Example 1: Integration of 1-dim. function by Rectangular rule
30 'COMPUTATIONAL PHYSICS: An Introduction 
40 'by R. C. Verma, P. K. Ahluwalia and K. C. Sharma
50 '   * * * *     
60 '**************************************************************************
70 '
80  GOSUB 10000                                                   'show header
90 '
100 DEF FNV(X)=SIN(X)                              'change it for other choice
110 '
120 GOSUB 1000                   'introduce the problem & get input parameters
130 '
140 GOSUB 2000                                     'perform rectangular method
150 '
160 LOCATE 22,1
170 IF INKEY$="" THEN 170
180 '
190 CLS: LOCATE 12,15: BEEP: PRINT " Thank you !"
200 END
210 '
1000 '************************************************************************
1010 'subroutine to introduce the problem & to get input variables
1020 'input variables:  none
1030 'output variables: X1, X2, N, H
1040 'global variables: none
1050 'local variables:  none
1060 'test cases: a = 0, b = 3.1416, N=100
1070 '************************************************************************
1080 '
1090 LOCATE 2,5: PRINT "This program performs integration"
1100 LOCATE 3,10: PRINT "of a function f(x) = sin(x) "
1110 LOCATE 3,15: PRINT "from x = a to x = b by rectangle rule"
1120 LOCATE 4,5: PRINT "---------------------------------------------------"
1130 '
1140 LOCATE 8,5: INPUT "Give lower & upper limits:  a, b ";X1,X2 
1150                                                'give lower & upper limits
1160  IF X1<>X2 THEN 1180
1170  BEEP: LOCATE 8,5: PRINT SPACE$(70): GOTO 1140 
1180 LOCATE 10,5: INPUT "Give no. of steps: Nx,= ";N     
1190                                               'give no. of lattice points
1200  IF N >0 AND INT(N)=N THEN 1220
1210  BEEP: LOCATE 10,5: PRINT SPACE$(70): GOTO 1180
1220 '
1230 H=(X2-X1)/N                                               'find step size
1240 '
1250 RETURN
1260 '
2000 '************************************************************************
2010 'subroutine to do numerical work
2020 'input variables: N, X1, FNV(X), H
2030 'output variables: SUM
2040 'global variables: none
2050 'local variables: I
2060 '************************************************************************
2070 '
2080 SUM=0                                   'initialize sum for x integration
2090 '
2100 FOR I% = 1 TO N-1                                 'loop for x integration
2110   X= X1+I%*H                                                'find x point
2120   SUM= SUM+FNV(X)                       'update the sum for x integration
2130  NEXT  I%
2140 '
2150  SUM=SUM*H
2160 LOCATE 18,10: BEEP: PRINT "Value of integral = ";SUM
2170 '
2180 RETURN
2190 '
10000 '***********************************************************************
10010 'subroutine to display header screen
10020 'input variables:  none
10030 'output variables: none
10040 'global variables: none
10050 'local variables:  none
10060 '***********************************************************************
10070 CLS: KEY OFF                                            'clear screen
10080 SCREEN 2,0,0: WIDTH 80                                 'change screen
10090  '
10100 LINE (1,1)-(638,40),,B                                    'draw boxes
10110 LINE (5,3)-(633,37),,B
10120 LINE (70,50)-(570,140),,B
10130 LINE (75,53)-(565,137),,B
10140                                           'print title, authors, etc.
10150 LOCATE 3,7
10160 PRINT " C O M P U T A T I O N A L   P H Y S I C S :";
10170 PRINT " (An  Introduction)"
10180 LOCATE 9,40
10190 PRINT "by";
10200 LOCATE 11,20: PRINT "R.C. Verma, P.K. Ahluwalia & K.C. Sharma"
10210 LOCATE 13,34
10220 PRINT "   * * * *    "
10230 '
10240 BEEP
10250 LOCATE 15,35:  PRINT "* * * * * *"
10260 LOCATE 22,25:  PRINT "press any key to continue"
10270 LOCATE 23,25:  PRINT "-------------------------"
10280 '
10290 IF INKEY$="" THEN 10290		                   'hold the screen
10300 CLS                                  		      'clear screen
10310 RETURN
10320 '
