10 '**************************************************************************
20 'Chapter 14, Example 2: Double Integration using Simpson rule
30 'COMPUTATIONAL PHYSICS: An Introduction 
40 'by R. C. Verma, P. K. Ahluwalia and K. C. Sharma
50 '   * * * *     
60 '**************************************************************************
70 '
80  GOSUB 10000                                                   'show header
90 '
100 DEF FNV(X,Y)=X*Y                               'change it for other choice
110 '
120 GOSUB 1000             'to introduce the problem & to get input parameters
130 '
140 GOSUB 2000                                     'perform double integration
150 '
160 LOCATE 22,1
170 IF INKEY$="" THEN 170
180 '
190 CLS: LOCATE 12,15: BEEP: PRINT " Thank you !"
200 END
210 '
1000 '************************************************************************
1010 'subroutine to introduce the problem & to get input variables
1020 'input variables:  none
1030 'output variables: X1, X2, Y1, Y2, N, NY, H, HY
1040 'global variables: none
1050 'local variables:  none
1060 '************************************************************************
1070 '
1080 LOCATE 2,5: PRINT "This program performs double integration"
1090 LOCATE 3,5: PRINT " of a function f(x, y) = xy "
1100 LOCATE 4,5: PRINT "from x = a to x = b & from y = c to y =d"
1110 LOCATE 5,5: PRINT "by Simpson rule"
1120 LOCATE 6,5: PRINT "----------------------------------------------"
1130 '
1140 LOCATE 8,5: INPUT "Give lower & upper limits of x: a, b = ";X1,X2
1150                                                'give lower & upper limits
1160  IF X1<>X2 THEN 1180
1170  BEEP: LOCATE 8, 5: PRINT SPACE$(70): GOTO 1140
1180 LOCATE 10,5: INPUT "Give lower & upper limits of y: c, d = ";Y1,Y2
1190  IF Y1<>Y2 THEN 1210
1200  BEEP: LOCATE 10,5: PRINT SPACE$(70): GOTO 1180
1210 LOCATE 12,5: INPUT "Give no. of steps in x & y direction: Nx, Ny = ";N,NY
1220                                               'give no. of lattice points
1230  IF N>0 AND NY>0 THEN 1250
1240  BEEP: LOCATE 12,5: PRINT SPACE$(70): GOTO 1210
1250 '
1260 H=(X2-X1)/N : HY=(Y2-Y1)/NY                               'find step size
1270 '
1280 RETURN
1290 '
2000 '************************************************************************
2010 'subroutine to do double integration
2020 'input variables: NX, NY, X1, X2, Y1, Y2, H, FNV(X, Y)   
2030 'output variables: SUMY
2040 'global variables: none
2050 'local variables: FAC, FACY2, SUM, 
2060 '************************************************************************
2070 '
2080 SUMY=0                                  'initialize sum for y integration
2090 FACY=2                                                   'a weight factor
2100 '
2110 FOR J%= 0 TO NY                                   'loop for y integration
2120  Y= Y1+J%*HY                                                'find y point
2130  SUM=0                                  'initialize sum for x integration
2140  FAC=2                                                     'weight factor
2150 '
2160  FOR I% = 0 TO N                                  'loop for x integration
2170   X= X1+I%*H                                                'find x point
2180   IF I%=0 THEN SUM=SUM+FNV(X,Y) : GOTO 2220                'first x-point
2190   IF I%=N THEN SUM=SUM+FNV(X,Y) : GOTO 2220                 'last x-point
2200   IF FAC=2 THEN FAC=4 ELSE FAC=2                 'alternate weight factor
2210   SUM= SUM+FAC*FNV(X,Y)                 'update the sum for x integration
2220  NEXT  I%
2230  SUM=SUM*H/3
2240 '
2250  IF J%=0  THEN SUMY=SUMY+SUM : GOTO 2290                'first y point
2260  IF J%=NY THEN SUMY=SUMY+SUM : GOTO 2290                 'last y point
2270  IF FACY=2 THEN FACY=4 ELSE FACY=2               'alternate weight factor
2280  SUMY= SUMY+FACY*SUM                    'update the sum for y integration
2290 NEXT  J%
2300 SUMY=SUMY*HY/3
2310 '
2320 LOCATE 22, 10: BEEP: PRINT "Value of the Integral = ";SUMY
2330 '
2340 RETURN
2350 '
10000 '***********************************************************************
10010 'subroutine to display header screen
10020 'input variables:  none
10030 'output variables: none
10040 'global variables: none
10050 'local variables:  none
10060 '***********************************************************************
10070 CLS: KEY OFF                                            'clear screen
10080 SCREEN 2,0,0: WIDTH 80                                 'change screen
10090  '
10100 LINE (1,1)-(638,40),,B                                    'draw boxes
10110 LINE (5,3)-(633,37),,B
10120 LINE (70,50)-(570,140),,B
10130 LINE (75,53)-(565,137),,B
10140                                           'print title, authors, etc.
10150 LOCATE 3,7
10160 PRINT " C O M P U T A T I O N A L   P H Y S I C S :";
10170 PRINT " (An  Introduction)"
10180 LOCATE 9,40
10190 PRINT "by";
10200 LOCATE 11,20: PRINT "R.C. Verma, P.K. Ahluwalia & K.C. Sharma"
10210 LOCATE 13,34
10220 PRINT "   * * * *    "
10230 '
10240 BEEP
10250 LOCATE 15,35:  PRINT "* * * * * *"
10260 LOCATE 22,25:  PRINT "press any key to continue"
10270 LOCATE 23,25:  PRINT "-------------------------"
10280 '
10290 IF INKEY$="" THEN 10290		                   'hold the screen
10300 CLS                                  		      'clear screen
10310 RETURN
10320 '
