10 '**************************************************************************
20 'Chapter 14, Example 3: Finding pi by Monte-Carlo method
30 'COMPUTATIONAL PHYSICS: An Introduction 
40 'by R. C. Verma, P. K. Ahluwalia and K. C. Sharma
50 '   * * * *     
60 '**************************************************************************
70 '
80  GOSUB 10000                                                   'show header
90 '
100 GOSUB 1000                   'introduce the problem & get input parameters
110 '
120 GOSUB 2000                                     'perform monte carlo method
130 '
140 LOCATE 22,1
150 IF INKEY$="" THEN 150
160 '
170 CLS: LOCATE 12,15: BEEP: PRINT " Thank you !"
180 END
190 '
1000 '************************************************************************
1010 'subroutine to introduce the problem & to get input variables
1020 'input variables:  none
1030 'output variables: N%
1040 'global variables: none
1050 'local variables:  none
1060 'test cases: N% = 500
1070 '************************************************************************
1080 '
1090 LOCATE 2,5: PRINT "This program finds value of pi"
1100 LOCATE 4,10: PRINT "by Monte-Carlo Method"
1110 LOCATE 5,15: PRINT "-----------------------------------------------"
1120 '
1130 LOCATE 7,5: INPUT "Give number of times you wish to hit = ";N%
1140  IF N%>0 THEN 1170
1150  BEEP: LOCATE 7,5: PRINT SPACE$(70): GOTO 1130
1160 '
1170 RETURN
1180 '
2000 '************************************************************************
2010 'subroutine to introduce the problem & to get input variables
2020 'input variables: N%
2030 'output variables: PI
2040 'global variables: none
2050 'local variables: COUNT%, X, Y, INTEG
2060 '************************************************************************
2070 '
2080 RANDOMIZE TIMER                                               'get a seed
2090 '
2100 COUNT%=0                                          'initialize the counter
2110 '
2120 FOR  I%= 1 TO N%                                          'loop over hits
2130  X = RND : Y = RND                              'coordinates of point hit
2140  IF (X^2+Y^2) <= 1 THEN COUNT% = COUNT% + 1
2150                       'increment the counter if point lies within the arc
2160 NEXT I%
2170                                                     'find pi and variance
2180 INTEG = COUNT%/N% : SIGMA = 4*SQR(INTEG*(1-INTEG)/N%)
2190 INTEG=4*INTEG
2200 '
2210 BEEP
2220 LOCATE 19,5: PRINT USING "PI = #.######  +- #.######";INTEG,SIGMA
2230 '
2240 RETURN
2250 '
10000 '***********************************************************************
10010 'subroutine to display header screen
10020 'input variables:  none
10030 'output variables: none
10040 'global variables: none
10050 'local variables:  none
10060 '***********************************************************************
10070 CLS: KEY OFF                                            'clear screen
10080 SCREEN 2,0,0: WIDTH 80                                 'change screen
10090  '
10100 LINE (1,1)-(638,40),,B                                    'draw boxes
10110 LINE (5,3)-(633,37),,B
10120 LINE (70,50)-(570,140),,B
10130 LINE (75,53)-(565,137),,B
10140                                           'print title, authors, etc.
10150 LOCATE 3,7
10160 PRINT " C O M P U T A T I O N A L   P H Y S I C S :";
10170 PRINT " (An  Introduction)"
10180 LOCATE 9,40
10190 PRINT "by";
10200 LOCATE 11,20: PRINT "R.C. Verma, P.K. Ahluwalia & K.C. Sharma"
10210 LOCATE 13,34
10220 PRINT "   * * * *    "
10230 '
10240 BEEP
10250 LOCATE 15,35:  PRINT "* * * * * *"
10260 LOCATE 22,25:  PRINT "press any key to continue"
10270 LOCATE 23,25:  PRINT "-------------------------"
10280 '
10290 IF INKEY$="" THEN 10290		                   'hold the screen
10300 CLS                                  		      'clear screen
10310 RETURN
10320 '
