 '****************************************************************************
 'Chapter 15, Example 1: Iteration of a function  k*x*x-1
 'COMPUTATIONAL PHYSICS: An Introduction
 'by R. C. Verma, P. K. Ahluwalia and K. C. Sharma
 '   * * * *    
 '****************************************************************************
 '
 GOSUB 10000                                                      'show header
 '
 DEF FNF (x) = k * x * x - 1
 '
 GOSUB 100                            'perform & display iteration of function
 '
 END
 '
100 '*************************************************************************
 'subroutine to perform & display iteration of function
 'input variables:  fnf(x)
 'output variables: none
 'global variables: none
 'local variables: n%, x
 'test cases: k=1, 1.4, 1.74, 2
 '****************************************************************************
 CLS
 '
200 LOCATE 21, 10: BEEP: INPUT "Give k lying 1 <=  k <= 2 "; k         'get input
  IF k >= 1 AND k <= 2 THEN 300
  BEEP: LOCATE 21, 10: PRINT SPACE$(70): GOTO 200
300 CLS
 VIEW (10, 10)-(620, 120), , 1                           'choose screen region
 WINDOW (200, -1.1)-(500, 1.1)
 '
 LOCATE 1, 10: PRINT "Iteration of a Function"                    'print title
 LOCATE 1, 60: PRINT "k = "; k
 x = .54321                                                      'initialize x
 '
 FOR n% = 1 TO 500                                           'loop over points
   x = FNF(x)                                               'perform iteration
   LOCATE 20, 10: PRINT USING "No. of Iteration = ###"; n%
   LOCATE 20, 40: PRINT USING "x = ##.#####"; x
   IF n% >= 200 THEN PSET (n%, x)                                 'plot points
 NEXT n%                                                            'loop ends
 '
 RETURN
 '
10000 '***********************************************************************
 ' subroutine to display header screen
 'input variables:  none
 'output variables: none
 'global variables: none
 'local variables:  none
 '****************************************************************************
 CLS : KEY OFF                                           'clear screen
 SCREEN 2, 0, 0: WIDTH 80                               'change screen
 '
 LINE (1, 1)-(638, 40), , B                                'draw boxes
 LINE (5, 3)-(633, 37), , B
 LINE (70, 50)-(570, 140), , B
 LINE (75, 53)-(565, 137), , B
					   'print title, authors, etc.
 LOCATE 3, 7
 PRINT " C O M P U T A T I O N A L   P H Y S I C S :";
 PRINT " (An  Introduction)"
 LOCATE 9, 40
 PRINT "by";
 LOCATE 11, 20: PRINT "R.C. Verma, P.K. Ahluwalia & K.C. Sharma"
 LOCATE 13, 34
 PRINT "   * * * *    "
 '
 BEEP
 LOCATE 15, 35: PRINT "* * * * * *"
 LOCATE 22, 25: PRINT "press any key to continue"
 LOCATE 23, 25: PRINT "-------------------------"
 '
10290 IF INKEY$ = "" THEN 10290                            'hold the screen
 CLS                                                  'clear screen
 '
 RETURN
 '

