 '****************************************************************************
 'Chapter 15, Example 1: Logistic equation: Mappings and Doublings
 'COMPUTATIONAL PHYSICS: An Introduction
 'by R. C. Verma, P. K. Ahluwalia and K. C. Sharma
 '   * * * *   
 '****************************************************************************
 '
 GOSUB 10000                                                      'show header
 '
 DEF fny (x) = mu * x * (1 - x)
 '
 GOSUB 1000                                                         'get input
 GOSUB 2000                                       'prepare screen for graphics
 GOSUB 3000                                                   'perform mapping
 '

 BEEP: LOCATE 23, 23: PRINT "press any key to continue"
100 IF INKEY$ = "" THEN 100
 '
150 GOSUB 4000                                    'generate rth ord map points
 LOCATE 23, 23: PRINT "press any key one by one to generate map points"
200 IF INKEY$ = "" THEN 200
 IF nint < 20 GOTO 150
 '
 END
 '
1000 '************************************************************************
 'subroutine to introduce the program & get input parameters
 'input variables:  none
 'output variables: mu, x0, ord, nint
 'global variables: none
 'local variables:  none
 '****************************************************************************
 '
 LOCATE 2, 5: PRINT "This program performs mapping &  doubling"
 LOCATE 3, 5: PRINT " of Logistic equation"
 LOCATE 4, 5: PRINT "------------------------------------------"
 '
1700 LOCATE 6, 5: INPUT "Give parameter:  0 < mu < 4 = ", mu
  IF mu > 0 AND mu < 4 THEN 1750
  BEEP: LOCATE 6, 5: PRINT SPACE$(75): GOTO 1700
'
1750 LOCATE 8, 5: INPUT "Give initial value: 0 < x0  < 1 = ", x0
  IF x0 < 1 AND x0 > 0 THEN 1800
  BEEP: LOCATE 8, 5: PRINT SPACE$(75): GOTO 1750
'
1800 LOCATE 10, 5: INPUT "Give order (integer value) of map: 1 <=  r  <=4  = ", ord
  IF INT(ord) = ord AND ord > 0 AND ord < 5 THEN 1900
  BEEP: LOCATE 10, 5: PRINT SPACE$(75): GOTO 1800
 '
1900 nint = 0                                   'counter for no. of iterations
 '
 RETURN
 '
2000 '************************************************************************
 'subroutine to prepare screen for graphics
 'input variables:  none
 'output variables: none
 'global variables: none
 'local variables:  none
 '****************************************************************************
 CLS
 LOCATE 20, 10: PRINT " x0 = "; x0; " , mu  = "; mu
 LOCATE 21, 10: PRINT "order of map = "; ord
 '
 VIEW (10, 10)-(620, 138), , 1             'choosing the the graphic view port
 WINDOW (0, 1)-(1, 0)                 'choosing the scale for plotting the map
 LOCATE 1, 1: PRINT "Logistic equation: Mappings and Doublings"
 '
 RETURN
 '
3000 '************************************************************************
 'subroutine to plot diagonal line and r-th order map
 'input variables:  fny(,)
 'output variables: none
 'global variables: none
 'local variables:  x, k, x1, g1, g2
 '****************************************************************************
 '
 FOR x = 0 TO 1 STEP .01
   x1 = x
   FOR k = 1 TO ord                           'loop for generating rth ord map
     g1 = fny(x1)
     x1 = g1
   NEXT k
   g2 = x
   PSET (x, g1)                                          'plotting rth ord map
   PSET (x, g2)                                          'diagonal line points
 NEXT x
 '
 RETURN
 '
4000 '************************************************************************
 'subroutine to generate rth order map points
 'input variables:  x0, nint
 'output variables: none
 'global variables: none
 'local variables:  k, x1, x1, y1
 '****************************************************************************
 x1 = x0
 '
 FOR k = 1 TO ord             'loop for plotting horizontal and vertical lines
   y1 = fny(x1)
   x1 = y1
 NEXT k
 '
 LINE (x0, x1)-(x0, y1)                                 'drawing vertical line
 '
 x1 = y1
 LINE (x0, y1)-(y1, y1)                               'drawing horizontal line
 '
 nint = nint + 1                                            ' incrementing the count
 LOCATE 22, 31: PRINT "No. of iterations=", nint
 '
 x0 = x1
 '
 RETURN
 '
10000 '***********************************************************************
 'subroutine to display header screen
 'input variables:  none
 'output variables: none
 'global variables: none
 'local variables:  none
 '****************************************************************************
 CLS : KEY OFF                                                   'clear screen
 SCREEN 2, 0, 0: WIDTH 80                                       'change screen
  '
 LINE (1, 1)-(638, 40), , B                                        'draw boxes
 LINE (5, 3)-(633, 37), , B
 LINE (70, 50)-(570, 140), , B
 LINE (75, 53)-(565, 137), , B
						    'print title, authors, etc.
 LOCATE 3, 7
 PRINT " C O M P U T A T I O N A L   P H Y S I C S :";
 PRINT " (An  Introduction)"
 LOCATE 9, 40
 PRINT "by";
 LOCATE 11, 20: PRINT "R.C. Verma, P.K. Ahluwalia & K.C. Sharma"
 LOCATE 13, 34
 PRINT "   * * * *    "
 '
 BEEP
 LOCATE 15, 35: PRINT "* * * * * *"
 LOCATE 22, 25: PRINT "press any key to continue"
 LOCATE 23, 25: PRINT "-------------------------"
 '
10100 IF INKEY$ = "" THEN 10100                               'hold the screen
 CLS                                                             'clear screen
 '
 RETURN
 '

