 '****************************************************************************
 'Chapter 15, Example 3: Logistic equation: Pitchfork bifurcation
 'COMPUTATIONAL PHYSICS: An Introduction
 'by R. C. Verma, P. K. Ahluwalia and K. C. Sharma
 '   * * * *    
 '****************************************************************************
 '
  GOSUB 10000                                                     'show header
 '
  GOSUB 1000                     'introduce the program & get input parameters
  GOSUB 2000                                  'study Logistic eq. & draw graph
 '
 END
 '
1000  '***********************************************************************
 'subroutine to introduce the program & get input parameters
 'input variables:  none
 'output variables: mu, dmu
 'global variables: none
 'local variables:  none
 '****************************************************************************
 '
 LOCATE 2, 5: PRINT "This program studies Logistic Equation"
 LOCATE 3, 5: PRINT "--------------------------------------"
 '
1100 LOCATE 5, 5
 INPUT "Give parameter mu : (from 1.5 to 4) = "; mu
 IF mu >= 1.5 AND mu <= 4 THEN 1150
 BEEP: LOCATE 5, 5: PRINT SPACE$(75): GOTO 1100
 '
1150 LOCATE 7, 5
 INPUT "Give increment dmu : 0 < dmu < 1 "; dmu
 IF dmu < 1 AND dmu > 0 THEN 1200
 BEEP: LOCATE 7, 5: PRINT SPACE$(75): GOTO 1150
1200 '
 '
 RETURN
 '
2000 '************************************************************************
 'subroutine to study Logistic eq. & draw graph
 'input variables:  mu, dmu
 'output variables: none
 'global variables: none
 'local variables:  I, k, x
 '****************************************************************************
 CLS
 VIEW (10, 10)-(620, 154), , 1                           'choose screen region
 WINDOW (1.4, 1)-(4, .3)
 LOCATE 1, 1: PRINT "Logistic equation: Pitchfork bifurcation"
 LOCATE 21, 10: PRINT "mu = "; mu; " dmu = "; dmu
 '
 FOR NL = mu TO 0 STEP -dmu                                   '1st loop starts
   x = .5
   FOR k = 1 TO 500                                           '2nd loop starts
     x = NL * x * (1 - x)
     IF k >= 200 THEN PSET (NL, x)
   NEXT k                                                       '2nd loop ends
NEXT NL                                                         '1st loop ends
'
RETURN
'
10000 '***********************************************************************
 'subroutine to display header screen
 'input variables:  none
 'output variables: none
 'global variables: none
 'local variables:  none
 '****************************************************************************
 CLS : KEY OFF                                                   'clear screen
 SCREEN 2, 0, 0: WIDTH 80                                       'change screen
  '
 LINE (1, 1)-(638, 40), , B                                        'draw boxes
 LINE (5, 3)-(633, 37), , B
 LINE (70, 50)-(570, 140), , B
 LINE (75, 53)-(565, 137), , B
						   'print title, authors, etc.
 LOCATE 3, 7
 PRINT " C O M P U T A T I O N A L   P H Y S I C S :";
 PRINT " (An  Introduction)"
 LOCATE 9, 40
 PRINT "by";
 LOCATE 11, 20: PRINT "R.C. Verma, P.K. Ahluwalia & K.C. Sharma"
 LOCATE 13, 34
 PRINT "   * * * *    "
 '
 BEEP
 LOCATE 15, 35: PRINT "* * * * * *"
 LOCATE 22, 25: PRINT "press any key to continue"
 LOCATE 23, 25: PRINT "-------------------------"
 '
10290 IF INKEY$ = "" THEN 10290                               'hold the screen
 CLS                                                             'clear screen
 '
 RETURN
 '

