DECLARE FUNCTION f (t#, x#, v#)
TYPE f
 f AS DOUBLE
 t AS DOUBLE
 x AS DOUBLE
 v AS DOUBLE
END TYPE
DECLARE SUB rk4 (pi#, t#, x#, v#, xnew#, vnew#, h#, c#, d#, w#)
TYPE rk4
 x AS DOUBLE
 v AS DOUBLE
 h AS DOUBLE
 c AS DOUBLE
 d AS DOUBLE
 w AS DOUBLE
 k1 AS DOUBLE
 k2 AS DOUBLE
 k3 AS DOUBLE
 k4 AS DOUBLE
 xnew AS DOUBLE
 vnew AS DOUBLE
END TYPE
CONST pi# = 3.1415962654#
'
CLS
SCREEN 2
VIEW (10, 10)-(620, 190), , 1
WINDOW (-3.15, 3.5)-(3.15, -3.5)
OPEN "adap.dat" FOR OUTPUT AS #1
'
CONST eps# = .000001                               'tolerance
CONST c# = .16
CONST w# = 2
CONST d# = 2
PRINT "I am working"
n = 25
h# = .5
'h# = 2 * pi# / (w# * n)                          '.0314156*2
'tp# = 2 * pi# / w#                               'time period
PRINT tp#
t# = 5.4 * pi# / 4                               '4.24115 ?
x# = 1
v# = 3
'

DO WHILE II# < 100000
                                                 'adaptive- size method
 CALL rk4((pi#), t#, x#, v#, xnew#, vnew#, h#, (c#), (d#), (w#))
 half# = h# / 2
 CALL rk4((pi#), t#, x#, v#, xnh#, vnh#, half#, (c#), (d#), (w#))
 CALL rk4((pi#), t# + half#, xnh#, vnh#, xn#, vn#, half#, (c#), (d#), (w#))
 d1# = ABS(xn# - xnew#)
 d2# = ABS(vn# - vnew#)
        IF d1# > d2# THEN
                delta# = d1#
          ELSE
          delta# = d2#
        END IF
'PRINT "*", delta#, t#, tmin
        IF delta# < eps# THEN
              tnew# = t# + h#
              w1# = (pi# - w# * t#) - (INT((pi# - w# * t#) / (2 * pi#)) * 2 * pi#)
              w2# = (w# * tnew# - pi#) - (INT((w# * tnew# - pi#) / (2 * pi#)) * 2 * pi#)
              'w1# = (pi# - w# * t#) MOD (2 * pi#)
              'w2# = (w# * tnew# - pi#) MOD (2 * pi#)
              'PRINT w1#, w2#
              IF w1# < (w# * h#) THEN
                  IF w2# < (w# * h#) THEN
                  tp1# = w1# / w#
                  'PRINT tp1#
                  CALL rk4((pi#), t#, x#, v#, xp#, vp#, tp1#, (c#), (d#), (w#))
              IF ABS(xp#) > pi# THEN xp# = xp# - 2 * pi# * ABS(xp#) / xp#
                PRINT #1, xp#, vp#
                count = count + 1
                PRINT xp#, vp#, count, t# * w# / (2 * pi)
              'END IF
              END IF
               END IF
             x# = xnew#
             v# = vnew#
             t# = t# + h#
                h# = h# * .95 * (eps# / delta#) ^ .25
              'PRINT "h#", h#
              IF ABS(x#) > pi# THEN
                x# = x# - 2 * pi# * ABS(x#) / x#
              END IF
        ELSE
           h# = h# * .95 * (eps# / delta#) ^ .2
        END IF
        II# = II# + 1
        LOCATE 2, 1: PRINT II#
LOOP
CLOSE #1
PRINT t#
END

FUNCTION f (t#, x#, v#) STATIC
f = -c# * v# - (1 - d# * COS(w# * t#)) * SIN(x#)
'f = x# - c# * v# - x# * x# * x# + d# * COS(w# * t#)
END FUNCTION

SUB rk4 (pi#, t#, x#, v#, xnew#, vnew#, h#, c#, d#, w#) STATIC
k1# = h# * f(t#, x#, v#)
k2# = h# * f(t# + .5 * h#, x# + .5 * h# * v#, v# + .5 * k1#)
k3# = h# * f(t# + .5 * h#, x# + .5 * h# * (v# + .5 * k1#), v# + k3#)
k4# = h# * f(t# + h#, x# + h# * v# + h# * k2# * .5, v# + k3#)
xnew# = x# + h# * v# + h# * (k1# + 2 * k2# + 2 * k3# + k4#) / 6
vnew# = v# + (k1# + 2 * k2# + 2 * k3# + k4#) / 6
'PRINT xnew#, vnew#
END SUB

