10 '**************************************************************************
20 'Chapter 1, Example 1: Freely Falling Body (using Euler Method)
30 'COMPUTATIONAL PHYSICS: An Introduction
40 'by R. C. Verma, P. K. Ahluwalia and K. C. Sharma
50 '   * * * *   
60 '**************************************************************************
70  CLS : KEY OFF
80  GOSUB 10000                                                   'show header
90 '
100 GOSUB 1000             'to introduce the problem & to get input parameters
110  CLS                                                         'clear screen
120  N% = (TF - TI) / H       'find number of steps to cover the time interval
130 GOSUB 2000                                                  'find position
140 '
150 CLS : LOCATE 12, 15: BEEP: PRINT " Thank you !"
160 END
170 '
1000 '************************************************************************
1010 'subroutine to introduce the problem & to get input variables
1020 'input variables:  none
1030 'output variables: GRAV, VINIT, TI, TF, H, XI
1040 '                  TUNIT$, VUNIT$, SUNIT$
1050 'global variables: none
1060 'local variables:  units
1070 'test cases: GRAV=9.8, VINIT=0,  TI=0, TF=2, H=0.1
1080 '************************************************************************
1090 '
1100 LOCATE 2, 10: PRINT "This program describes Free Fall"
1110 LOCATE 3, 10: PRINT "---------------------------------------------------"
1120                                                   'choose system of units
1130 LOCATE 5, 10: BEEP: PRINT "Which systems of units you want to work in?"
1140 LOCATE 7, 5: PRINT SPACE$(75)
1145 LOCATE 7, 15: INPUT "1) m.k.s., 2) c.g.s.     Press 1 or 2."; UNITS
1150   IF UNITS = 1 OR UNITS = 2 THEN 1180
1160   BEEP: PRINT "Try again!"
1170   GOTO 1140
1180 '
1190 TUNIT$ = "s"
1200 IF UNITS = 1 THEN VUNIT$ = "m/s": SUNIT$ = "m"
1210 IF UNITS = 2 THEN VUNIT$ = "cm/s": SUNIT$ = "cm"
1220 '
1230 LOCATE 9, 5: BEEP: PRINT "Please feed the input parameters"
1240 '
1250 LOCATE 11, 5: PRINT SPACE$(75)
1255 LOCATE 11, 5: INPUT "Give acceleration due to gravity "; GRAV
1260   IF UNITS = 1 AND ABS(GRAV) < 10 AND ABS(GRAV) > 9 THEN 1310
1270   IF UNITS = 2 AND ABS(GRAV) < 1000 AND ABS(GRAV) > 970 THEN 1310
1280   BEEP: PRINT "Please give correct value of g!"
1290   GOTO 1250
1300                                                       'initial conditions
1310 LOCATE 13, 5: PRINT SPACE$(75)
1315 LOCATE 13, 5: INPUT "Give initial and final times, Ti, Tf"; TI, TF
1320   IF TF > TI THEN 1360
1330   BEEP: PRINT "Please give suitable time interval Ti, Tf"
1340   GOTO 1310
1350 '
1360 LOCATE 15, 5: INPUT "Give initial velocity of ball, Vo "; VINIT
1370 '
1375 LOCATE 17, 5: PRINT SPACE$(75)
1380 LOCATE 17, 5: INPUT "Give time step h   "; H
1385  IF H > 0 THEN 1395
1390  BEEP: PRINT "Give nonzero value of h ": GOTO 1375
1395 '
1400 LOCATE 19, 5: INPUT "Give initial position Xi"; X
1410 '
1420 RETURN
1430 '
2000 '************************************************************************
2010 'subroutine to find position and velocity
2020 'input variables:  XI, TI, VINIT, GRAV, H, N%, TUNIT$, VUNIT$, SUNIT$
2030 'output variables: T, V, X
2040 'global variables: none
2050 'local variables:  NUM% , A
2060 '************************************************************************
2070 '
2080 T = TI: V = VINIT: X = XI                             'initial conditions
2090 '
2100 IF N% > 40 THEN NUM% = INT(N% / 20) ELSE NUM% = 2 'for selective printout
2110 '
2120 PRINT "---------------------------------"       'prepare table for output
2130 PRINT " Time    Velocity    Distance"
2140 PRINT "     "; TUNIT$; "       "; VUNIT$; "          "; SUNIT$
2150 PRINT "---------------------------------"
2160 '
2170 WHILE T <= TF + H
2180   PRINT USING "+###.###   +#.###^^^^   +#.###^^^^"; T; V; X
2190   T = T + H
2200   V = V + GRAV * H                                         'find velocity
2210   X = X + V * H                                      'distance  decrement
2220 WEND
2230 '
2240 PRINT "---------------------------------"                     'table ends
2250 '
2260 BEEP: PRINT : PRINT "press any key to continue"
2270 IF INKEY$ = "" THEN 2270
2280 '
2290 RETURN
2300 '
10000 '***********************************************************************
10010 'subroutine to display header screen
10020 'input variables:  none
10030 'output variables: none
10040 'global variables: none
10050 'local variables:  none
10060 '***********************************************************************
10070 CLS : KEY OFF                                           'clear screen
10080 SCREEN 2, 0, 0: WIDTH 80                               'change screen
10090  '
10100 LINE (1, 1)-(638, 40), , B                                'draw boxes
10110 LINE (5, 3)-(633, 37), , B
10120 LINE (70, 50)-(570, 140), , B
10130 LINE (75, 53)-(565, 137), , B
10140                                           'print title, authors, etc.
10150 LOCATE 3, 7
10160 PRINT " C O M P U T A T I O N A L   P H Y S I C S :";
10170 PRINT " (An  Introduction)"
10180 LOCATE 9, 40
10190 PRINT "by";
10200 LOCATE 11, 20: PRINT "R.C. Verma, P.K. Ahluwalia & K.C. Sharma"
10210 LOCATE 13, 34
10220 PRINT "   * * * *    "
10230 '
10240 BEEP
10250 LOCATE 15, 35: PRINT "* * * * * *"
10260 LOCATE 22, 25: PRINT "press any key to continue"
10270 LOCATE 23, 25: PRINT "-------------------------"
10280 '
10290 IF INKEY$ = "" THEN 10290                            'hold the screen
10300 CLS                                                     'clear screen
10310 RETURN
10320 '

