10 '**************************************************************************
20 'Chapter 1, Example 4: Drawing a graph for N points (Xi, Yi)
30 'COMPUTATIONAL PHYSICS: An Introduction
40 'by R. C. Verma, P. K. Ahluwalia and K. C. Sharma
50 '   * * * *   
60 '**************************************************************************
70 GOSUB 10000                                                    'show header
80  '
90 DIM X(100), Y(100)
100 DIM PX%(100), PY%(100), PMX%(5), PMY%(5)
110                                     'set dimensions of the array variables
120 GOSUB 1000                'introduce the problem & to get input parameters
130  CLS
140 GOSUB 2000                                                    'draw graphs
150 '
160 LOCATE 22, 1: PRINT "press any key to exit"
170 IF INKEY$ = "" THEN 170
180 '
190 CLS : LOCATE 12, 25: BEEP: PRINT "Thank You!"                'program ends
200 '
210 END
220 '
1000 '************************************************************************
1010 'subroutine to introduce the problem & to get input variables
1020 'input variables:  none
1030 'output variables: N, X(I%), Y(I%), TITLE$, XTITLE$, YTITLE$
1040 '                  PXMIN%, PXMAX%, PYMIN%, PYMAX%
1050 'global variables: none
1060 'local variables:  units
1070 '************************************************************************
1080 '
1090 LOCATE 2, 10: PRINT "This program draws a graph for N points (Xi, Yi)"
1100 LOCATE 4, 10: PRINT "---------------------------------------------------"
1110 '                                               
1120 LOCATE 6, 5: BEEP: PRINT "Please feed the points"
1130 LOCATE 8, 1: PRINT SPACE$(78)
1140 LOCATE 8, 1: INPUT "No. of points to be drawn  "; N%
1150   IF N% >= 1 AND N% <= 100 THEN 1180
1160   BEEP: PRINT "Please give a suitable value of N: 1 < N < 100 "
1170   GOTO 1130
1180 '
1190 FOR I% = 1 TO N%
1200   LOCATE 12, 10: BEEP: PRINT "Point No. = "; I%
1210   LOCATE 14, 10: PRINT "Give Coordinates X("; I%; ") and Y("; I%; ")"
1215   LOCATE 15, 10: PRINT SPACE$(50)
1220   LOCATE 15, 10: INPUT X(I%), Y(I%)
1230 NEXT I%
1240                                                             'for graphics
1250 TITLE$ = "Graph for N points Xi, Yi"
1260 XTITLE$ = "X": YTITLE$ = "Y"
1270 '
1280 PXMIN% = 132: PXMAX% = 456: PYMIN% = 20: PYMAX% = 148  'pixel coordinates
1290 '
1300 RETURN
1310 '
2000 '************************************************************************
2010 'subroutine to display graph between x(i) & y(i) variables
2020 'input variables: N%, X(I%), Y(I%), XTITLE$, YTITLE$, TITLE$,
2030 '                 PXMIN%, PXMAX%, PYMIN%, PYMAX%
2040 'output variables: none
2050 'global variables: none
2060 'local variables: XMIN, XMAX, YMIN, YMAX, PXMIN%, PXMAX%, PYMIN%, PYMAX%
2070 '                 KCOEFF1, KCOEFF2, KCOEFF3 ,KCOEFF4, PX%(I%), PY%(I%)
2080 '                 DIV%, XSCALE, YSCALE, PXSCALE, PYSCALE
2090 '                 PMX%(J%), PMY%(J%), ROWX%, COLX%, ROWY%, COLY%
2100 '************************************************************************
2110 '
2120 CLS                                                         'clear screen
2130 LOCATE 1, 15: PRINT TITLE$
2140  DIV% = 4                    'set number of divisions (<5) on x- & y-axes
2150 XMIN = X(1): XMAX = X(1): YMIN = Y(1): YMAX = Y(1) 'initialize variables
2160 '
2170 FOR I% = 1 TO N%                   'loop to find maximum & minimum values
2180  IF X(I%) < XMIN THEN XMIN = X(I%)                'along x & y directions
2190  IF X(I%) > XMAX THEN XMAX = X(I%)
2200  IF Y(I%) < YMIN THEN YMIN = Y(I%)
2210  IF Y(I%) > YMAX THEN YMAX = Y(I%)
2220 NEXT I%
2230 '
2240 IF YMAX = FIX(YMAX) OR ABS(YMAX) < 1 THEN 2260
2250  YMAX = FIX(YMAX + 1)                 'redefine to closest higher integer
2260 IF YMIN = FIX(YMIN) OR ABS(YMIN) < 1 THEN 2280
2270  YMIN = FIX(YMIN - 1)                  'redefine to closest lower integer
2280                                                  'find scale coefficients
2290 KCOEFF1 = (PXMAX% - PXMIN%) / (XMAX - XMIN)
2300 KCOEFF2 = (PXMAX% * XMIN - PXMIN% * XMAX) / (XMIN - XMAX)
2310 KCOEFF3 = (PYMAX% - PYMIN%) / (YMIN - YMAX)
2320 KCOEFF4 = (PYMAX% * YMAX - PYMIN% * YMIN) / (YMAX - YMIN)
2330 '
2340 ROWTIT% = PYMIN% / 8 + 1: COLTIT% = PXMAX% / 8 + 2
2350 '
2360 LINE (PXMIN%, PYMIN%)-(PXMAX%, PYMAX%), , B           'draw box for graph
2370 LINE (PXMIN%, KCOEFF4)-(PXMAX%, KCOEFF4)                     'draw x-axis
2380 LINE (KCOEFF2, PYMIN%)-(KCOEFF2, PYMAX%)                     'draw y-axis
2390 '
2400 XSCALE = (XMAX - XMIN) / DIV%                       'find scale for marks
2410 YSCALE = (YMAX - YMIN) / DIV%
2420 '
2430 PXSCALE = (PXMAX% - PXMIN%) / DIV%            'find pixel scale for marks
2440 PYSCALE = (PYMAX% - PYMIN%) / DIV%
2450 '
2460 ROWX% = PYMAX% / 8 + 1              'find row for marks along x-direction
2470 COLY% = PXMIN% / 8 - 10          'find column for marks along y-direction
2480 '
2490 FOR J% = 0 TO DIV%                          'start loop to mark divisions
2500   PMX(J%) = PXMIN% + PXSCALE * J%                    'find places to mark
2510   PMY(J%) = PYMIN% + PYSCALE * J%
2520    LINE (PMX(J%), PYMAX%)-(PMX(J%), PYMAX% - 5)               'draw marks
2530    LINE (PXMIN%, PMY(J%))-(PXMIN% + 5, PMY(J%))
2540 '
2550   IF J% / 2 <> INT(J% / 2) THEN 2790            'jump for alternate marks
2560 '
2570   COLX% = PMX(J%) / 8 - 3         'find column for each mark along x-axis
2580   ROWY% = PMY(J%) / 8                'find row for each mark along y-axis
2590 '
2600   LOCATE ROWX%, COLX%
2610    IF XMAX > 999.99 OR XMIN < -999.99 THEN 2650
2620    IF XMAX < .1 AND XMIN > -.1 THEN 2650                'format selection
2630   PRINT USING "+###.##"; XMIN + XSCALE * J%      'print x-scale divisions
2640   GOTO 2670
2650   PRINT USING "+#.##^^^^"; XMIN + XSCALE * J%    'print x-scale divisions
2660 '
2670   LOCATE ROWY%, COLY%
2680    IF YMAX > 999.99 OR YMIN < -999.99 THEN 2720
2690    IF YMAX < .1 AND YMIN > -.1 THEN 2720                'format selection
2700   PRINT USING "+###.##"; YMAX - YSCALE * J%      'print y-scale divisions
2710   GOTO 2740
2720   PRINT USING "+#.##^^^^"; YMAX - YSCALE * J%    'print y-scale divisions
2730 '
2740   IF J% <> 2 THEN 2790              'print names of variables along x & y
2750    LOCATE ROWX% + 2, COLTIT%: PRINT XTITLE$; " ->"
2760    LOCATE ROWY% - 1, COLY% - 1: PRINT "^"
2770    LOCATE ROWY%, COLY% - 1: PRINT "|"
2780    LOCATE ROWY% + 1, COLY% - 1: PRINT YTITLE$
2790 NEXT J%
2800 '
2810 FOR I% = 1 TO N%
2820    PX%(I%) = KCOEFF1 * X(I%) + KCOEFF2     'perform scale transformations
2830    PY%(I%) = KCOEFF3 * Y(I%) + KCOEFF4                  'along x & y axes
2840    IF I% = 1 THEN 2860
2850    LINE (PX%(I% - 1), PY%(I% - 1))-(PX%(I%), PY%(I%))         'draw graph
2860 NEXT I%
2870 '
2880 RETURN
2890 '
10000 '***********************************************************************
10010 'subroutine to display header screen
10020 'input variables:  none
10030 'output variables: none
10040 'global variables: none
10050 'local variables:  none
10060 '***********************************************************************
10070 CLS : KEY OFF                                           'clear screen
10080 SCREEN 2, 0, 0: WIDTH 80                               'change screen
10090  '
10100 LINE (1, 1)-(638, 40), , B                                'draw boxes
10110 LINE (5, 3)-(633, 37), , B
10120 LINE (70, 50)-(570, 140), , B
10130 LINE (75, 53)-(565, 137), , B
10140                                           'print title, authors, etc.
10150 LOCATE 3, 7
10160 PRINT " C O M P U T A T I O N A L   P H Y S I C S :";
10170 PRINT " (An  Introduction)"
10180 LOCATE 9, 40
10190 PRINT "by";
10200 LOCATE 11, 20: PRINT "R.C. Verma, P.K. Ahluwalia & K.C. Sharma"
10210 LOCATE 13, 34
10220 PRINT "   * * * *    "
10230 '
10240 BEEP
10250 LOCATE 15, 35: PRINT "* * * * * *"
10260 LOCATE 22, 25: PRINT "press any key to continue"
10270 LOCATE 23, 25: PRINT "-------------------------"
10280 '
10290 IF INKEY$ = "" THEN 10290                            'hold the screen
10300 CLS                                                     'clear screen
10310 RETURN
10320 '

