10 '**************************************************************************
20 'Chapter 1, Example 6: To draw graph between velocity/acceleration & time
25 '                      for Motion of a Body Falling in Air
30 'COMPUTATIONAL PHYSICS: An Introduction
40 'by R. C. Verma, P. K. Ahluwalia and K. C. Sharma
50 '   * * * *   
60 '**************************************************************************
70  CLS : KEY OFF
80  GOSUB 10000                                                   'show header
90 '
100 PI = 3.1415926#                    'define constants pi & drag coefficient
110 DC = .46                            'drag coefficient for a spherical body
120 '
130 GOSUB 1000             'to introduce the problem & to get input parameters
140 '
150  N% = (TF - TI) / H       'find number of steps to cover the time interval
160 DIM T(N%), v(N%), a(N%), X(N%), Y(N%)
170 DIM PX%(N%), PY%(N%), PMX%(5), PMY%(5)
180                                     'set dimensions of the array variables
190 dec = .5 * DC * RHO * PI * RAD * RAD / MASS         'calculate drag factor
200  IF dec <> 0 THEN 260                               'check if drag is zero
210  CLS : BEEP
215 LOCATE 12, 1: PRINT "Drag factor is zero."
220    PRINT "    Velocity would not saturate!"
225  LOCATE 15, 15: INPUT "Do you want me to work? press Y/N"; CHC$
230    IF CHC$ = "y" OR CHC$ = "Y" THEN 260
235    IF CHC$ = "n" OR CHC$ = "N" THEN 280
240    BEEP: LOCATE 15, 15: PRINT SPACE$(65): GOTO 225
250 '
260 GOSUB 2000                                           'perform Euler method
270 GOSUB 3000                                                    'draw graphs
280 '
290 CLS : LOCATE 12, 15: BEEP: PRINT "Program ends here!"
300 END
310 '
1000 '************************************************************************
1010 'subroutine to introduce the problem & to get input variables
1020 'input variables:  none
1030 'output variables: RAD, MASS,RHO,GRAV, VINIT,TI,TF,H
1040 '                  TUNIT$, VUNIT$, AUNIT$
1050 'global variables: none
1060 'local variables:  units
1070 'test cases:RAD=1, MASS=1, RHO=0.1, GRAV=9.8, VINIT=0,  TI=0, TF=2, H=0.01
1080 '           RAD=1, MASS=1, RHO=0.1, GRAV=9.8, VINIT=20, TI=0, TF=2, H=0.01
1090 '           RAD=1, MASS=1, RHO=0.1, GRAV=9.8, VINIT=-20,TI=0, TF=2, H=0.01
1100 '************************************************************************
1110 '
1120 LOCATE 2, 10: PRINT "This program describes motion of a spherical ball"
1130 LOCATE 3, 15: PRINT "falling in air."
1140 LOCATE 4, 10: PRINT "---------------------------------------------------"
1150                                                   'choose system of units
1160 LOCATE 5, 10: BEEP: PRINT "Which systems of units you want to work in?"
1170 LOCATE 7, 15: PRINT SPACE$(65)
1175 LOCATE 7, 15: INPUT "1) m.k.s., 2) c.g.s.     Press 1 or 2."; UNITS
1180   IF UNITS = 1 OR UNITS = 2 THEN 1205
1190   BEEP: PRINT "Try again!"
1200   GOTO 1170
1205 TUNIT$ = "s"
1210 IF UNITS = 1 THEN VUNIT$ = "m/s": AUNIT$ = "m/s2"
1215 IF UNITS = 2 THEN VUNIT$ = "cm/s": AUNIT$ = "cm/s2"
1220 '
1225 LOCATE 8, 1: BEEP: PRINT "Please feed the input parameters"
1230 LOCATE 10, 1: PRINT SPACE$(78)         'physical properties of the system
1235 LOCATE 10, 1: INPUT "Give radius of the  ball "; RAD
1240   IF RAD >= 0 THEN 1265
1245   BEEP: PRINT "Please give suitable value for radius!"
1250   GOTO 1230
1265 LOCATE 12, 1: PRINT SPACE$(78)         'physical properties of the system
1270 LOCATE 12, 1: INPUT "Give mass  of the  ball  "; MASS
1280   IF MASS > 0 THEN 1310
1290   BEEP: PRINT "Please give positive value for mass!"
1300   GOTO 1265
1310 '
1320 LOCATE 14, 1: PRINT SPACE$(78)
1325 LOCATE 14, 1: INPUT "Give density of the medium (air) "; RHO
1330   IF RHO >= 0 THEN 1360
1340   BEEP: PRINT "Please give suitable value for density!"
1350   GOTO 1320
1360 LOCATE 16, 1: PRINT SPACE$(78)
1365 LOCATE 16, 1: INPUT "Give acceleration due to gravity "; grav
1370  IF grav <> 0 THEN 1380
1375  BEEP: GOTO 1360                                      'initial conditions
1380 LOCATE 18, 1: PRINT SPACE$(78)
1385 LOCATE 18, 1: INPUT "Give initial and final times: Ti, Tf"; TI, TF
1390   IF TF > TI THEN 1420
1400   BEEP: PRINT "Please give suitable time interval Ti, Tf <1000!"
1410   GOTO 1380
1420 LOCATE 20, 1: INPUT "Give initial velocity of the ball, Vo "; VINIT
1430 '
1440  HMIN = (TF - TI) / 2000                       'minimum step size allowed
1450 LOCATE 22, 1: PRINT SPACE$(78)
1455 LOCATE 22, 1: INPUT "Give time step h   "; H
1460  IF H >= HMIN THEN 1500
1470  BEEP: PRINT "Please give h > "; HMIN; " due to limit on array-memory"
1480  BEEP: GOTO 1450
1500                                    'for comparatively large r and small m
1510                                              'time step h should be small
1520 RETURN
1530 '
2000 '************************************************************************
2010 'subroutine to perform Euler method
2020 'input variables:  TI, VINIT, GRAV, H, N%, DEC, TUNIT$, VUNIT$, AUNIT$
2030 'output variables: N%, T(I%), V(I%), A(I%), VNUM, VEXACT
2040 'global variables: none
2050 'local variables:  NUM%
2060 '************************************************************************
2070 '
2080 T(0) = TI: v(0) = VINIT: a(0) = grav - dec * v(0) * ABS(v(0))'initial conditions
2090 '
2100 IF N% > 40 THEN NUM% = INT(N% / 20) ELSE NUM% = 2 'for selective printout
2110 '
2120 PRINT "---------------------------------"       'prepare table for output
2130 PRINT " Time    Acceleration  Velocity "
2140 PRINT "     "; TUNIT$; "       "; AUNIT$; "          "; VUNIT$
2150 PRINT "---------------------------------"
2160 '
2170 FOR i% = 1 TO N%
2190   T(i%) = T(i% - 1) + H
2200   v(i%) = v(i% - 1) + a(i% - 1) * H        'Euler method to find velocity
2210   a(i%) = grav - dec * v(i%) * ABS(v(i%))         'acceleration decrement
2220   IF (i% MOD NUM%) <> 0 AND i% <> N% THEN 2240         'print selectively
2230   PRINT USING "+###.###   +#.###^^^^   +#.###^^^^"; T(i%); a(i%); v(i%)
2240 NEXT i%
2250 '
2260 PRINT "---------------------------------"                     'table ends
2270 '
2280 VNUM = v(N%)                           'numerical value of final velocity
2290 IF dec <> 0 THEN 2320                              'check if drag is zero
2300 VEXACT = VINIT + (TF - TI) * grav     'analytical value when drag is zero
2310  GOTO 2340
2320 VEXACT = SQR(grav / dec)           'analytical value when drag is nonzero
2330 '
2340 PRINT : PRINT "Final Velocity:": PRINT
2350 PRINT "Numerical result = "; VNUM; " "; VUNIT$
2360 PRINT "Analytical result = "; VEXACT; " "; VUNIT$
2370 '
2380 BEEP: PRINT : PRINT "press any key to continue"
2390 IF INKEY$ = "" THEN 2390
2400 '
2410 RETURN
2420 '
3000 '************************************************************************
3010 'subroutine to draw graphs: velocity & acceleration vs. time
3020 'input variables:  N%, T(I%), V(I%), A(I%), VNUM, VEXACT
3030 'output variables: X(I%), Y(I%), TITLE$, SUBTITLE$, XTITLE$, YTITLE$
3040 '                  PXMIN%, PXMAX%, PYMIN%, PYMAX%
3050 'global variables: none
3060 'local variables:  none
3070 '************************************************************************
3080 CLS                                                         'clear screen
3090 PXMIN% = 136: PXMAX% = 392: PYMIN% = 20: PYMAX% = 84'choose screen region
3100 TITLE$ = "*** Motion of a Body Falling in Air ***"
3110 SUBTITLE$ = "Velocity vs. Time": XTITLE$ = "t": YTITLE$ = "v"
3120 '
3130 FOR i = 0 TO N%
3140  X(i) = T(i): Y(i) = v(i)             'assign variables for v vs. t graph
3150 NEXT i
3160 '
3170 GOSUB 4000                                                 'display graph
3180 '                                   'print numerical & analytical results
3190 LOCATE ROWTIT% + 2, COLTIT% + 1: PRINT "Terminal Velocity ("; VUNIT$; ")"
3200 LOCATE ROWTIT% + 3, COLTIT% + 1
3210  IF ABS(VNUM) > .0001 AND ABS(VNUM) < 999.9999 THEN 3240
3220  PRINT USING "+#.###^^^^ (numeric)"; VNUM
3230   GOTO 3250
3240  PRINT USING "+###.#### (numeric)"; VNUM
3250 LOCATE ROWTIT% + 4, COLTIT% + 1
3260  IF ABS(VNUM) > .0001 AND ABS(VNUM) < 999.9999 THEN 3290
3270  PRINT USING "+#.###^^^^ (analytic)"; VEXACT
3280   GOTO 3300
3290 PRINT USING "+###.#### (analytic)"; VEXACT
3300 '
3310 PXMIN% = 136: PXMAX% = 392: PYMIN% = 108: PYMAX% = 164
3315                                                     'choose screen region
3320 SUBTITLE$ = "Acceleration vs. Time": XTITLE$ = "t": YTITLE$ = "a"
3330 '
3340 FOR i = 0 TO N%
3350  X(i) = T(i): Y(i) = a(i)             'assign variables for a vs. t graph
3360 NEXT i
3370 '
3380 GOSUB 4000                                                 'display graph
3390 '
3400 IF INKEY$ = "" THEN 3400
3410 '
3420 RETURN
3430 '
4000 '************************************************************************
4010 'subroutine to display graph between x(i) & y(i) variables
4020 'input variables: N%, X(I%), Y(I%), XTITLE$, YTITLE$, TITLE$, SUBTITLE$
4030 '                 PXMIN%, PXMAX%, PYMIN%, PYMAX%
4040 'output variables: ROWTIT%, COLTIT%
4050 'global variables: none
4060 'local variables: XMIN, XMAX, YMIN, YMAX, PXMIN%, PXMAX%, PYMIN%, PYMAX%
4070 '                 KCOEFF1, KCOEFF2, KCOEFF3 ,KCOEFF4, PX%(I%), PY%(I%)
4080 '                 DIV%, XSCALE, YSCALE, PXSCALE, PYSCALE
4090 '                 PMX%(J%), PMY%(J%), ROWX%, COLX%, ROWY%, COLY%
4100 '************************************************************************
4110 LOCATE 1, 15: PRINT TITLE$
4120  DIV% = 4                    'set number of divisions (<5) on x- & y-axes
4130 XMIN = 0: XMAX = 0: YMIN = 0: YMAX = 0              'initialize variables
4140 '
4150 FOR i% = 0 TO N%                   'loop to find maximum & minimum values
4160  IF X(i%) < XMIN THEN XMIN = X(i%)                'along x & y directions
4170  IF X(i%) > XMAX THEN XMAX = X(i%)
4180  IF Y(i%) < YMIN THEN YMIN = Y(i%)
4190  IF Y(i%) > YMAX THEN YMAX = Y(i%)
4200 NEXT i%
4210 '
4220 IF YMAX = FIX(YMAX) OR ABS(YMAX) < 1 THEN 4240
4230  YMAX = FIX(YMAX + 1)                 'redefine to closest higher integer
4240 IF YMIN = FIX(YMIN) OR ABS(YMIN) < 1 THEN 4260
4250  YMIN = FIX(YMIN - 1)                  'redefine to closest lower integer
4260                                                  'find scale coefficients
4270 KCOEFF1 = (PXMAX% - PXMIN%) / (XMAX - XMIN)
4280 KCOEFF2 = (PXMAX% * XMIN - PXMIN% * XMAX) / (XMIN - XMAX)
4290 KCOEFF3 = (PYMAX% - PYMIN%) / (YMIN - YMAX)
4300 KCOEFF4 = (PYMAX% * YMAX - PYMIN% * YMIN) / (YMAX - YMIN)
4310 '
4320 ROWTIT% = PYMIN% / 8 + 1: COLTIT% = PXMAX% / 8 + 2
4330 LOCATE ROWTIT%, COLTIT%: PRINT SUBTITLE$               'print graph-title
4340 '
4350 LINE (PXMIN%, PYMIN%)-(PXMAX%, PYMAX%), , B           'draw box for graph
4360 LINE (PXMIN%, KCOEFF4)-(PXMAX%, KCOEFF4)                     'draw x-axis
4370 LINE (KCOEFF2, PYMIN%)-(KCOEFF2, PYMAX%)                     'draw y-axis
4380 '
4390 XSCALE = (XMAX - XMIN) / DIV%                       'find scale for marks
4400 YSCALE = (YMAX - YMIN) / DIV%
4410 '
4420 PXSCALE = (PXMAX% - PXMIN%) / DIV%            'find pixel scale for marks
4430 PYSCALE = (PYMAX% - PYMIN%) / DIV%
4440 '
4450 ROWX% = PYMAX% / 8 + 1              'find row for marks along x-direction
4460 COLY% = PXMIN% / 8 - 10          'find column for marks along y-direction
4470 '
4480 FOR J% = 0 TO DIV%                          'start loop to mark divisions
4490   PMX(J%) = PXMIN% + PXSCALE * J%                    'find places to mark
4500   PMY(J%) = PYMIN% + PYSCALE * J%
4510    LINE (PMX(J%), PYMAX%)-(PMX(J%), PYMAX% - 5)               'draw marks
4520    LINE (PXMIN%, PMY(J%))-(PXMIN% + 5, PMY(J%))
4530 '
4540   IF J% / 2 <> INT(J% / 2) THEN 4780            'jump for alternate marks
4550 '
4560   COLX% = PMX(J%) / 8 - 3         'find column for each mark along x-axis
4570   ROWY% = PMY(J%) / 8 + 1            'find row for each mark along y-axis
4580 '
4590   LOCATE ROWX%, COLX%
4600    IF XMAX > 999.99 OR XMIN < -999.99 THEN 4640
4610    IF XMAX < .1 AND XMIN > -.1 THEN 4640                'format selection
4620   PRINT USING "+###.##"; XMIN + XSCALE * J%      'print x-scale divisions
4630   GOTO 4660
4640   PRINT USING "+#.##^^^^"; XMIN + XSCALE * J%    'print x-scale divisions
4650 '
4660   LOCATE ROWY%, COLY%
4670    IF YMAX > 999.99 OR YMIN < -999.99 THEN 4710
4680    IF YMAX < .1 AND YMIN > -.1 THEN 4710                'format selection
4690   PRINT USING "+###.##"; YMAX - YSCALE * J%      'print y-scale divisions
4700   GOTO 4730
4710   PRINT USING "+#.##^^^^"; YMAX - YSCALE * J%    'print y-scale divisions
4720 '
4730   IF J% <> 2 THEN 4780              'print names of variables along x & y
4740    LOCATE ROWX%, COLTIT% + 3: PRINT XTITLE$; " ->"
4750    LOCATE ROWY% - 1, COLY% - 1: PRINT "^"
4760    LOCATE ROWY%, COLY% - 1: PRINT "|"
4770    LOCATE ROWY% + 1, COLY% - 1: PRINT YTITLE$
4780 NEXT J%
4790 '
4800 FOR i% = 0 TO N%
4810    PX%(i%) = KCOEFF1 * X(i%) + KCOEFF2     'perform scale transformations
4820    PY%(i%) = KCOEFF3 * Y(i%) + KCOEFF4                  'along x & y axes
4830    IF i% = 0 THEN 4850
4840    LINE (PX%(i% - 1), PY%(i% - 1))-(PX%(i%), PY%(i%))         'draw graph
4850 NEXT i%
4860 '
4870 RETURN
4880 '
10000 '***********************************************************************
10010 'subroutine to display header screen
10020 'input variables:  none
10030 'output variables: none
10040 'global variables: none
10050 'local variables:  none
10060 '***********************************************************************
10070 CLS : KEY OFF                                           'clear screen
10080 SCREEN 2, 0, 0: WIDTH 80                               'change screen
10090  '
10100 LINE (1, 1)-(638, 40), , B                                'draw boxes
10110 LINE (5, 3)-(633, 37), , B
10120 LINE (70, 50)-(570, 140), , B
10130 LINE (75, 53)-(565, 137), , B
10140                                           'print title, authors, etc.
10150 LOCATE 3, 7
10160 PRINT " C O M P U T A T I O N A L   P H Y S I C S :";
10170 PRINT " (An  Introduction)"
10180 LOCATE 9, 40
10190 PRINT "by";
10200 LOCATE 11, 20: PRINT "R.C. Verma, P.K. Ahluwalia & K.C. Sharma"
10210 LOCATE 13, 34
10220 PRINT "   * * * *    "
10230 '
10240 BEEP
10250 LOCATE 15, 35: PRINT "* * * * * *"
10260 LOCATE 22, 25: PRINT "press any key to continue"
10270 LOCATE 23, 25: PRINT "-------------------------"
10280 '
10290 IF INKEY$ = "" THEN 10290                            'hold the screen
10300 CLS                                                     'clear screen
10310 RETURN
10320 '

