10 '**************************************************************************
15 'Chapter 2, Example 1: Motion of a Projectile including Air Drag
20 '                      a) thrown hoizontally
25 '                      b) throwm at an inclination
30 'COMPUTATIONAL PHYSICS: An Introduction
40 'by R. C. Verma, P. K. Ahluwalia and K. C. Sharma
50 '   * * * *   
60 '**************************************************************************
70  CLS : KEY OFF
80  GOSUB 10000                                                   'show header
90                                                           'define functions
100 DEF FNV (VX, VY) = DEC * SQR(VX * VX + VY * VY)
110 DEF FNX (VX, VY) = -VX * FNV(VX, VY)                'acceleration formulas
120 DEF FNY (VX, VY) = -ABS(GRAV) - VY * FNV(VX, VY)        'g is taken as -ve
130 '
140 PI = 3.1415926#                    'define constants pi & drag coefficient
150 DC = .46                            'drag coefficient for a spherical body
160 '
170 FLAG = 0                                                         'set flag
180 '
190 GOSUB 1000             'to introduce the problem & to get input parameters
200  CLS                                                         'clear screen
210  NSTEP% = (TF - TI) / H
220                           'find number of steps to cover the time interval
230 DIM T(NSTEP% + 1), VX(NSTEP% + 1), VY(NSTEP% + 1)
240 DIM AX(NSTEP% + 1), AY(NSTEP% + 1), X(NSTEP% + 1), Y(NSTEP% + 1)
250 DIM PX%(NSTEP% + 1), PY%(NSTEP% + 1), PMX%(5), PMY%(5)
260 '                                                    'dimension the arrays
270 DEC = .5 * DC * RHO * PI * RAD * RAD / MASS         'calculate drag factor
280 '
290 GOSUB 3000                                       'perform Half-step method
300 '
310 GOSUB 4000                                                    'draw graphs
320 '
330 LOCATE 22, 1
340   PRINT SPACE$(78)                            'clear space for next choice
350   BEEP
360 LOCATE 22, 1
370  IF FLAG < 12 THEN 430                     'check if space filled in graph
380  BEEP
390  PRINT "Space full!  Press any key to exit."
400 IF INKEY$ = "" THEN 400
410 GOTO 500
420 '
430 LOCATE 22, 1: PRINT SPACE$(78)
440 BEEP: LOCATE 22, 1: INPUT "Do you want another try? Press Y/N"; ANS$
450   IF ANS$ = "y" OR ANS$ = "Y" THEN 470
455   IF ANS$ = "N" OR ANS$ = "n" THEN 510
460   GOTO 430
470 LOCATE 22, 1: PRINT SPACE$(78)                                'next choice
480 BEEP: GOSUB 1000                          'get another angle of projection
490 GOTO 270
500 '
510 CLS : LOCATE 12, 15: BEEP: PRINT "Program ends here!"
520 END
530 '
1000 '************************************************************************
1010 'subroutine to introduce the problem & to get input variables
1020 'input variables:  FLAG
1030 'output variables: RAD, MASS, RHO, GRAV, TI, TF, VINIT, THP, XI, YI
1040 '                  H, TUNIT$, VUNIT$, AUNIT$, MUNIT$, KIND
1050 'global variables: none
1060 'local variables:  UNITS
1070 'test cases:
1080 'RAD=1, MASS=1, RHO=1, GRAV=9.8, VINIT=0.5, THP=45, TI=0, TF=2, H=0.01
1090 'RAD=2, MASS=.5, RHO=0.5, GRAV=9.8, VINIT=1, THP=0, TI=0, TF=2, H=0.01
1100 '************************************************************************
1110 '
1120 IF FLAG <> 0 THEN 1880                            'jump if not first time
1130 '
1140 LOCATE 2, 10: PRINT "This program describes motion of a projectile"
1150 LOCATE 4, 15: PRINT "in 2-dimensions including air drag."
1160 LOCATE 6, 10: PRINT "---------------------------------------------------"
1170                                            'choose kind of the projectile
1180 LOCATE 10, 10: BEEP: PRINT "Which kind of projectile you want to study?"
1190 LOCATE 12, 15: PRINT "1) thrown horizontally or downwards"
1200 LOCATE 13, 15: PRINT "2) thrown at an inclination "
1210 LOCATE 15, 15: PRINT SPACE$(65)
1215 LOCATE 15, 15: INPUT "Press 1 or 2."; KIND
1220   IF KIND = 1 OR KIND = 2 THEN 1260
1230   BEEP: PRINT "Try again!"
1240   GOTO 1210
1250                                                   'choose system of units
1260 LOCATE 17, 10: BEEP: PRINT "Which systems of units you want to work in?"
1270 LOCATE 19, 15: PRINT "1) m.k.s., 2) c.g.s."
1280 LOCATE 21, 15: PRINT SPACE$(65)
1285 LOCATE 21, 15: INPUT "Press 1 or 2."; UNITS
1290   IF UNITS = 1 OR UNITS = 2 THEN 1320
1300   BEEP: PRINT "Try again!"
1310   GOTO 1280
1320 '
1330   TUNIT$ = "s"
1340 IF UNITS <> 1 THEN 1360
1350   VUNIT$ = "m/s": AUNIT$ = "m/s2": SUNIT$ = "m": MUNIT$ = "kg"
1360 IF UNITS <> 2 THEN 1390
1370   VUNIT$ = "cm/s": AUNIT$ = "cm/s2": SUNIT$ = "cm": MUNIT$ = "g"
1380 '
1390  CLS
1400 IF KIND = 1 THEN TITLE$ = "Projectile thrown Horizontally or Downwards"
1410 IF KIND = 2 THEN TITLE$ = "Projectile thrown at an Inclination"
1420 LOCATE 1, 5: PRINT "* * "; TITLE$; " * *"
1425 LOCATE 2, 5: BEEP: PRINT "Please feed the input parameters"
1430                                        'physical properties of the system
1435 LOCATE 4, 1: PRINT SPACE$(78)
1440 LOCATE 4, 1: INPUT "Give radius of the projectile "; RAD
1445   IF RAD >= 0 THEN 1460
1450   BEEP: PRINT "Please give suitable value for radius!"
1455   GOTO 1435
1460 LOCATE 6, 1: PRINT SPACE$(78)
1465 LOCATE 6, 1: INPUT "Give mass of the projectile "; MASS
1470   IF MASS > 0 THEN 1500
1480   BEEP: PRINT "Please give nonzero value for mass!"
1490   GOTO 1460
1500 '
1510 LOCATE 8, 1: PRINT SPACE$(78)
1515 LOCATE 8, 1: INPUT "Give density of the medium (air) "; RHO
1520   IF RHO >= 0 THEN 1550
1530   BEEP: PRINT "Please give suitable value for density!"
1540   GOTO 1510
1550 '
1560 LOCATE 10, 1: PRINT SPACE$(78)
1565 LOCATE 10, 1: INPUT "Give acceleration due to gravity "; GRAV
1570   IF GRAV <> 0 THEN 1600
1580   BEEP: PRINT "Please give nonzero value for g"
1590   GOTO 1560
1600                                                            'time interval
1610 LOCATE 12, 1: PRINT SPACE$(78)
1615 LOCATE 12, 1: INPUT "Give initial and final times, Ti, Tf"; TI, TF
1620   IF TF > TI THEN 1660
1630   BEEP: PRINT "Please give suitable time interval Ti, Tf!"
1640   GOTO 1610
1650 '
1660  HMIN = (TF - TI) / 1000                       'minimum step size allowed
1670 LOCATE 14, 1: PRINT SPACE$(78)
1675 LOCATE 14, 1: INPUT "Give time step h   "; H
1680  IF H >= HMIN THEN 1730
1690  BEEP: PRINT "Please give h >= "; HMIN; " due to limit on array-memory"
1700  PRINT
1710  GOTO 1670
1720 '
1730   XI = 0                                     'initial x-position is fixed
1740  IF KIND = 1 THEN 1780
1750  YI = 0         'initial y-position is also fixed for inclined projection
1760 LOCATE 16, 1: PRINT "Initial position is fixed: Xo=0, Yo=0 "
1770  GOTO 1830
1780 LOCATE 18, 1: PRINT SPACE$(78)
1785 LOCATE 18, 1: INPUT "We fix Xo =0: Give initial y-position Yo > 0 "; YI
1790   IF YI > 0 THEN 1830
1800   BEEP: PRINT "Please give suitable Yo (Earth surface is reference pt.)"
1810   GOTO 1780
1820 '
1830 LOCATE 20, 1: PRINT SPACE$(78)
1835 LOCATE 20, 1: INPUT "Give magnitude of initial velocity of projection "; VINIT
1840   IF VINIT > 0 THEN 1880
1850   BEEP: PRINT "Please give a positive value of the magnitude"
1860   GOTO 1830
1870 '
1880 LOCATE 22, 1: PRINT SPACE$(78)
1885 LOCATE 22, 1: INPUT "Give angle of projection (in degree)"; THP
1890   LOCATE 23, 1: PRINT SPACE$(78)
1900 IF KIND = 2 THEN 1950
1910 IF (THP <= 0 AND THP >= -180) OR (THP <= 360 AND THP >= 180) THEN 1990
1920   BEEP: LOCATE 23, 1: PRINT "Give angle in IV or III qudrant! "
1940   GOTO 1880
1950 IF (THP >= 0 AND THP <= 180) OR (THP >= -360 AND THP <= -180) THEN 1990
1960 BEEP: LOCATE 23, 1: PRINT "Give angle in I or II quadrant!"
1980   GOTO 1880
1990  LOCATE 23, 1: PRINT SPACE$(78)
2000 '
2010 RETURN
2020 '
3000 '************************************************************************
3010 'subroutine to perform Half-Step method
3020 'input variables:  TI, TF, XI, YI, VINIT, THP, GRAV, H, NSTEP%, DEC
3030 '                  TUNIT$, VUNIT$, AUNIT$, PI
3040 'output variables: N%, T(I%), VX(I%), VY(I%), X(I%), Y(I%), HORZ, VERT
3050 'global variables:
3060 'local variables:  NUM%, THRAD
3070 '************************************************************************
3080 '
3090  N% = NSTEP%                                       'define a new variable
3100 IF N% > 40 THEN NUM% = INT(N% / 20) ELSE NUM% = 2
3110                                                   'for selective printout
3120 THRAD = THP * PI / 180             'convert degrees of angle to radian
3130 UXI = VINIT * COS(THRAD): UYI = VINIT * SIN(THRAD)
3140                                                 'find velocity components
3150 T(0) = TI: VX(0) = UXI: VY(0) = UYI: X(0) = XI: Y(0) = YI     'initialize
3160 VDIS = 0                                    'initialize vertical distance
3170   AX(0) = FNX(VX(0), VY(0))                         'initial acceleration
3180   AY(0) = FNY(VX(0), VY(0))
3190   VX(1) = VX(0) + AX(0) * H / 2                    'velocity at half-step
3200   VY(1) = VY(0) + AY(0) * H / 2
3210 '
3220 FOR I% = 1 TO N%
3230   T(I%) = T(I% - 1) + H
3240   X(I%) = X(I% - 1) + VX(I%) * H                        'distance formula
3250   Y(I%) = Y(I% - 1) + VY(I%) * H
3260   AX(I%) = FNX(VX(I%), VY(I%))                    'acceleration decrement
3270   AY(I%) = FNY(VX(I%), VY(I%))
3280   VX(I% + 1) = VX(I%) + AX(I%) * H                      'velocity formula
3290   VY(I% + 1) = VY(I%) + AY(I%) * H
3300   IF ABS(Y(I%) - Y(0)) > ABS(VDIS) THEN VDIS = Y(I%) - Y(0)
3310                                  'find maximum vertical distance traveled
3320   IF Y(I%) >= 0 THEN 3350
3330    N% = I%: Y(I%) = 0                  'avoid penetration into the earth
3340    GOTO 3360           'record last time step & jump out of the time loop
3350 NEXT I%
3360 '
3370 HORZ = X(N%) - X(0)
3380 VERT = VDIS
3390 '
3400 RETURN
3410 '
4000 '************************************************************************
4010 'subroutine to draw graphs: velocity & acceleration vs. time
4020 'input variables:  N%, X(I%), Y(I%), FLAG, KIND, TITLE$
4030 '                  XI, YI, GRAV, VINIT, THP, HORZ, VERT, DEC
4040 'output variables: XTITLE$, YTITLE$
4050 '                  PXMIN%, PXMAX%, PYMIN%, PYMAX%
4060 '                  XMIN, XMAX, YMIN, YMAX
4070 'global variables: ROWTIT$, COLTIT$
4080 'local variables:  none
4090 '************************************************************************
4100 IF FLAG <> 0 THEN 4240
4110 CLS                                              'clear screen first time
4120                                                 'find limits for graphics
4130 IF KIND = 1 THEN 4170
4140 XMAX = XI + VINIT * VINIT / ABS(GRAV): XMIN = -XMAX         'for graphics
4150 YMAX = YI + .5 * VINIT * VINIT / ABS(GRAV): YMIN = 0
4160 GOTO 4190                                'when inclined projectile thrown
4170 YMAX = YI: YMIN = 0: XMAX = VINIT * SQR(2 * YI / GRAV): XMIN = -XMAX
4180                                      'when projectile thrown horizontally
4190 PXMIN% = 104: PXMAX% = 360: PYMIN% = 20: PYMAX% = 154
4200                                                     'choose screen region
4210 LOCATE 1, 15: PRINT TITLE$
4220 XTITLE$ = "x": YTITLE$ = "y"
4230 '
4240 GOSUB 5000                                                 'display graph
4250 '
4260 LOCATE ROWTIT%, COLTIT%
4265 IF DEC <> 0 THEN PRINT "* Motion with Air Drag *"
4270 IF DEC = 0 THEN PRINT "* Motion without Air Drag *"
4280 LOCATE ROWTIT% + 2, COLTIT%: PRINT "Final Time, Max.Range & Height"
4290 LOCATE ROWTIT% + 3, COLTIT% + 1
4300 PRINT "     "; TUNIT$; "         "; SUNIT$; "       "; SUNIT$; ""
4310                                                            'print results
4320 LOCATE ROWTIT% + 3 + FLAG, COLTIT% + 1
4325  IF T(N%) < 999.9999 THEN 4340
4330  PRINT USING "#.##^^^^  "; T(N%);
4335   GOTO 4350
4340  PRINT USING "###.###   "; T(N%);
4350 '
4360  IF ABS(HORZ) > .0001 AND ABS(HORZ) < 999.9999 THEN 4390
4370  PRINT USING "+#.##^^^^ "; HORZ;
4380   GOTO 4400
4390  PRINT USING "+####.### "; HORZ;
4400  '
4410  IF ABS(VERT) > .0001 AND ABS(VERT) < 999.9999 THEN 4440
4420  PRINT USING "+#.##^^^^"; VERT
4430   GOTO 4450
4440  PRINT USING "+####.###"; VERT
4450  '
4460 RETURN
4470 '
5000 '************************************************************************
5010 'subroutine to display graph between x(i) & y(i) variables
5020 'input variables: N%, X(I%), Y(I%), XTITLE$, YTITLE$, FLAG
5030 '                 PXMIN%, PXMAX%, PYMIN%, PYMAX%
5040 '                 XMIN, XMAX, YMIN, YMAX
5050 'output variables: ROWTIT%, COLTIT%
5060 'global variables: none
5070 'local variables: XMIN, XMAX, YMIN, YMAX, PXMIN%, PXMAX%, PYMIN%, PYMAX%
5080 '                 KCOEFF1, KCOEFF2, KCOEFF3 ,KCOEFF4, PX%(I%), PY%(I%)
5090 '                 DIV%, XSCALE, YSCALE, PXSCALE, PYSCALE
5100 '                 PMX%(J%), PMY%(J%), ROWX%, COLX%, ROWY%, COLY%
5110 '************************************************************************
5120  IF FLAG <> 0 THEN 5710                'set screen coordinates first time
5130  DIV% = 4                    'set number of divisions (<5) on x- & y-axes
5140 ROWTIT% = PYMIN% / 8 + 1: COLTIT% = PXMAX% / 8 + 2
5150 '
5160 IF YMAX = FIX(YMAX) OR ABS(YMAX) < 1 THEN 5180
5170  YMAX = FIX(YMAX + 1)                 'redefine to closest higher integer
5180 IF YMIN = FIX(YMIN) OR ABS(YMIN) < 1 THEN 5200
5190  YMIN = FIX(YMIN - 1)                  'redefine to closest lower integer
5200                                                  'find scale coefficients
5210 KCOEFF1 = (PXMAX% - PXMIN%) / (XMAX - XMIN)
5220 KCOEFF2 = (PXMAX% * XMIN - PXMIN% * XMAX) / (XMIN - XMAX)
5230 KCOEFF3 = (PYMAX% - PYMIN%) / (YMIN - YMAX)
5240 KCOEFF4 = (PYMAX% * YMAX - PYMIN% * YMIN) / (YMAX - YMIN)
5250 '
5260 LINE (PXMIN%, PYMIN%)-(PXMAX%, PYMAX%), , B           'draw box for graph
5270 LINE (PXMIN%, KCOEFF4)-(PXMAX%, KCOEFF4)                     'draw x-axis
5280 LINE (KCOEFF2, PYMIN%)-(KCOEFF2, PYMAX%)                     'draw y-axis
5290 '
5300 XSCALE = (XMAX - XMIN) / DIV%                       'find scale for marks
5310 YSCALE = (YMAX - YMIN) / DIV%
5320 '
5330 PXSCALE = (PXMAX% - PXMIN%) / DIV%            'find pixel scale for marks
5340 PYSCALE = (PYMAX% - PYMIN%) / DIV%
5350 '
5360 ROWX% = PYMAX% / 8 + 1              'find row for marks along x-direction
5370 COLY% = PXMIN% / 8 - 10          'find column for marks along y-direction
5380 '
5390 FOR J% = 0 TO DIV%                          'start loop to mark divisions
5400   PMX(J%) = PXMIN% + PXSCALE * J%                    'find places to mark
5410   PMY(J%) = PYMIN% + PYSCALE * J%
5420    LINE (PMX(J%), PYMAX%)-(PMX(J%), PYMAX% - 5)               'draw marks
5430    LINE (PXMIN%, PMY(J%))-(PXMIN% + 5, PMY(J%))
5440 '
5450   IF J% / 2 <> INT(J% / 2) THEN 5690            'jump for alternate marks
5460 '
5470   COLX% = PMX(J%) / 8 - 3         'find column for each mark along x-axis
5480   ROWY% = PMY(J%) / 8                'find row for each mark along y-axis
5490 '
5500   LOCATE ROWX% + 1, COLX%
5510    IF XMAX > 999.99 OR XMIN < -999.99 THEN 5550
5520    IF XMAX < .1 AND XMIN > -.1 THEN 5550                'format selection
5530   PRINT USING "+###.##"; XMIN + XSCALE * J%      'print x-scale divisions
5540   GOTO 5570
5550   PRINT USING "+#.##^^^^"; XMIN + XSCALE * J%    'print x-scale divisions
5560 '
5570   LOCATE ROWY%, COLY%
5580    IF YMAX > 999.99 OR YMIN < -999.99 THEN 5620
5590    IF YMAX < .1 AND YMIN > -.1 THEN 5620                'format selection
5600   PRINT USING "+###.##"; YMAX - YSCALE * J%      'print y-scale divisions
5610   GOTO 5640
5620   PRINT USING "+#.##^^^^"; YMAX - YSCALE * J%    'print y-scale divisions
5630 '
5640   IF J% <> 2 THEN 5690              'print names of variables along x & y
5650    LOCATE ROWX%, COLTIT% + 3: PRINT XTITLE$; " ->"
5660    LOCATE ROWY% - 1, COLY% - 1: PRINT "^"
5670    LOCATE ROWY%, COLY% - 1: PRINT "|"
5680    LOCATE ROWY% + 1, COLY% - 1: PRINT YTITLE$
5690 NEXT J%
5700 '
5710 FOR I% = 0 TO N%
5720    PX%(I%) = KCOEFF1 * X(I%) + KCOEFF2     'perform scale transformations
5730    PY%(I%) = KCOEFF3 * Y(I%) + KCOEFF4                  'along x & y axes
5740    IF I% = 0 THEN 5760
5750    LINE (PX%(I% - 1), PY%(I% - 1))-(PX%(I%), PY%(I%))         'draw graph
5760 NEXT I%
5770 '
5780 FLAG = FLAG + 1                                              'change flag
5790 '
5800 RETURN
5810 '
10000 '***********************************************************************
10010 'subroutine to display header screen
10020 'input variables:  none
10030 'output variables: none
10040 'global variables: none
10050 'local variables:  none
10060 '***********************************************************************
10070 CLS : KEY OFF                                           'clear screen
10080 SCREEN 2, 0, 0: WIDTH 80                               'change screen
10090  '
10100 LINE (1, 1)-(638, 40), , B                                'draw boxes
10110 LINE (5, 3)-(633, 37), , B
10120 LINE (70, 50)-(570, 140), , B
10130 LINE (75, 53)-(565, 137), , B
10140                                           'print title, authors, etc.
10150 LOCATE 3, 7
10160 PRINT " C O M P U T A T I O N A L   P H Y S I C S :";
10170 PRINT " (An  Introduction)"
10180 LOCATE 9, 40
10190 PRINT "by";
10200 LOCATE 11, 20: PRINT "R.C. Verma, P.K. Ahluwalia & K.C. Sharma"
10210 LOCATE 13, 34
10220 PRINT "   * * * *    "
10230 '
10240 BEEP
10250 LOCATE 15, 35: PRINT "* * * * * *"
10260 LOCATE 22, 25: PRINT "press any key to continue"
10270 LOCATE 23, 25: PRINT "-------------------------"
10280 '
10290 IF INKEY$ = "" THEN 10290                            'hold the screen
10300 CLS                                                     'clear screen
10310 RETURN
10320 '

