10 '**************************************************************************
20 'Chapter 2, Example 2: Motion of a Satellite around a Planet
30 'COMPUTATIONAL PHYSICS: An Introduction
40 'by R. C. Verma, P. K. Ahluwalia and K. C. Sharma
50 '   * * * *   
60 '**************************************************************************
70  CLS : KEY OFF
80  GOSUB 10000                                                   'show header
90 '                                                         'define functions
100 DEF FND (X, Y) = (X * X + Y * Y) ^ 1.5            'acceleration components
110 DEF FNX (X, Y) = -X * GNEWTON * MASS / FND(X, Y)
120 DEF FNY (X, Y) = -Y * GNEWTON * MASS / FND(X, Y)
130 '
140 PI = 3.1415926#                                  'define constants pi & GM
150 GNEWTON = 1!                             'GNEWTON is the Newton's constant
160 '
170 FLAG = 0                                                         'set flag
180 '
190 GOSUB 1000             'to introduce the problem & to get input parameters
200 GOSUB 4000                            'to draw the planet & firing station
210 GOSUB 2000                                       'perform Half-step method
220                                                       'and draw trajectory
230 LOCATE 22, 1: PRINT SPACE$(40): BEEP
240 LOCATE 22, 1: INPUT "Do you want another try? Press Y/N"; ANS$
250  IF ANS$ = "y" OR ANS$ = "Y" THEN 270
255  IF ANS$ = "n" OR ANS$ = "N" THEN 310
260  BEEP: GOTO 230
270 '
280 LOCATE 22, 1: PRINT SPACE$(80)                                'clean space
290                                'get another velocity & angle of projection
300 GOTO 190
310 '
320 CLS : LOCATE 12, 15: BEEP: PRINT "Program ends here!"
330 END
340 '
1000 '************************************************************************
1010 'subroutine to introduce the problem & to get input variables
1020 'input variables:  FLAG
1030 'output variables: RAD, MOUNT, VINIT, THPROJ, TITLE$, H, TMAX, ASPECT
1040 'global variables: none
1050 'local variables:  UNITS
1060 'test cases: RAD=1 MASS=1, MOUNT=10, VINIT=0.1, THPROJ=0, H=1,TF=3000
1070 '************************************************************************
1080 '
1090 IF FLAG <> 0 THEN 1670                            'jump if not first time
1100 '
1110 LOCATE 1, 10: PRINT "This program describes motion of"
1120 LOCATE 2, 15: PRINT "a satellite around a planet"
1130 LOCATE 3, 20: PRINT "fired from top of a mountain"
1140 LOCATE 4, 10: PRINT "---------------------------------------------------"
1150                                                          'system of units
1160 LOCATE 5, 10: PRINT "We work in special units for this problem keeping GM = 1"
1170 '
1180 LOCATE 7, 5: BEEP: PRINT "Please feed the input parameters"
1190 '
1200  ASPECT = 2.25                                              'aspect ratio
1210 LOCATE 9, 10: PRINT " We fix aspect ratio of the screen = 2.25"
1215 LOCATE 10, 10: PRINT SPACE$(70)
1220 LOCATE 10, 10: INPUT "Do you wish to change it? Press Y/N"; CHC$
1225   IF CHC$ = "N" OR CHC$ = "n" THEN 1290
1230   IF CHC$ = "y" OR CHC$ = "Y" THEN 1240
1235   BEEP: GOTO 1215
1240 LOCATE 11, 10: PRINT SPACE$(70)
1245 LOCATE 11, 10: INPUT "Give Aspect ratio of your screen"; ASPECT
1250   IF ASPECT >= 1.5 AND ASPECT <= 3 THEN 1290
1260   LOCATE 12, 10: PRINT SPACE$(70)
1265   BEEP: LOCATE 12, 10: INPUT "Is the given ratio correct? Press Y/N"; CHK$
1270   IF CHK$ = "N" OR CHK$ = "n" THEN 1240
1275   IF CHK$ = "y" OR CHK$ = "Y" THEN 1290
1280   BEEP: GOTO 1260
1285                                        'physical properties of the system
1290 LOCATE 13, 1: PRINT SPACE$(78)
1295 LOCATE 13, 1: INPUT "Give radius of Planet (in units of Earth's radius)"; rad
1300   IF rad > 0 AND rad <= 2 THEN 1340
1310   BEEP: PRINT "Please give suitable values for the Planet's radius <= 2!"
1320   GOTO 1290
1330 '
1340  rad = rad * 30                              '50 is the scale coefficient
1350 '
1360 LOCATE 14, 1: PRINT SPACE$(78)
1365 LOCATE 14, 1: INPUT "Give Mass of Planet (in units of Earth's mass)"; MASS
1370   IF MASS > 0 AND MASS < 500 THEN 1400
1380   BEEP: PRINT "Please give suitable values for the Planet's mass < 500!"
1390   GOTO 1360
1400 '
1410 LOCATE 16, 1: PRINT "Give height of Firing Pad, say around "; rad / 5
1420 LOCATE 17, 1: PRINT SPACE$(70)
1425 LOCATE 17, 1: INPUT MOUNT
1430   IF MOUNT <= rad / 4 AND MOUNT >= rad / 10 THEN 1460
1440   BEEP: PRINT "Please give suitable value:"; rad / 10; ";<  Height < "; rad / 4
1450   GOTO 1420
1460 '
1470 TPERIOD = 2 * PI * (rad + MOUNT) ^ 1.5              'expected time period
1480 '
1490 TI = 0                                                'initial time fixed
1500 LOCATE 18, 1
1510  PRINT "We take initial time Ti=0: Give final time Tf (near "; TPERIOD; "s"
1520 LOCATE 19, 1: PRINT SPACE$(70)
1525 LOCATE 19, 1: INPUT TF
1530   IF TF > TI THEN 1560
1540   BEEP: PRINT "Please give suitable time Tf "
1550   GOTO 1500
1560 '
1570 LOCATE 20, 1: PRINT SPACE$(70)
1575 LOCATE 20, 1: INPUT "Give time step h:  (near 1 sec) "; H
1580  IF H > 0 AND H < (TPERIOD / 100) THEN 1620
1590  BEEP: PRINT "Give time step: 0 < h <"; TPERIOD / 100
1600  PRINT
1610  GOTO 1570
1620 '
1630 XE = 120: YE = 100             'centre of the planets - PIXEL coordinates
1640 XM = 0                              'initial x-position of the firing pad
1650 XI = 0: YI = rad + MOUNT        'We fix initial position of the satellite
1660 '
1670 LOCATE 21, 1: PRINT SPACE$(80)
1690 BEEP: LOCATE 21, 1: INPUT "Give initial velocity"; VINIT
1700   IF VINIT > 0 THEN 1740
1710   BEEP: LOCATE 22, 1: PRINT "Give +ve value!"
1730   GOTO 1670
1740 LOCATE 22, 1: PRINT SPACE$(80)
1750 BEEP: LOCATE 22, 1: INPUT "Give projection angle"; THPROJ
1790 '
1800 RETURN
1810 '
2000 '************************************************************************
2010 'subroutine to perform Half-Step method
2020 'input variables:  TI, TF, XI, YI, VINIT, THPROJ, H, NSTEP%
2030 '                  PI, FNX(X,Y), FNY(X,Y)
2040 'output variables: N%, T, VX, VY, X, Y, TIME, VEL
2050 'global variables: none
2060 'local variables:  NUM%, THRAD, UXI, UYI, RMAG
2070 '************************************************************************
2080 '
2090 THRAD = THPROJ * PI / 180             'convert degrees of angle to radian
2100 UXI = VINIT * COS(THRAD): UYI = VINIT * SIN(THRAD)
2110                                                 'find velocity components
2120 '
2130   T = TI: VX = UXI: VY = UYI: X0 = XI: Y0 = YI            'initialization
2140  RMAG = SQR(X0 ^ 2 + Y0 ^ 2)           'find initial distance from centre
2150                                                         'half-step method
2160   AX = FNX(X0, Y0)                                  'initial acceleration
2170   AY = FNY(X0, Y0)
2180   VX = VX + AX * H / 2                             'velocity at half-step
2190   VY = VY + AY * H / 2
2200 '
2210 WHILE (RMAG >= rad) AND (T <= TF)
2220   LOCATE 16, 65: PRINT USING "t=#.###^^^^"; T
2230   LOCATE 18, 56: PRINT USING "X=+#.##^^^^ Y=+#.##^^^^"; X0; Y0
2235   LOCATE 20, 55: PRINT USING "Vx=+#.##^^^^ Vy=+#.##^^^^"; VX; VY
2240   T = T + H
2250   X = X0 + VX * H                                       'distance formula
2260   Y = Y0 + VY * H
2270     RMAG = SQR(X ^ 2 + Y ^ 2)                  'find distance from centre
2280   AX = FNX(X, Y)                                  'acceleration decrement
2290   AY = FNY(X, Y)
2300   VX = VX + AX * H                                      'velocity formula
2310   VY = VY + AY * H
2320   GOSUB 3000                                             'draw trajectory
2330   X0 = X: Y0 = Y                                         'roll the values
2340 WEND
2350 '
2360 TIME = T                                                  'time of flight
2370 VEL = SQR(VX ^ 2 + VY ^ 2)                                'final velocity
2380 BEEP
2390 LOCATE 21, 56: PRINT USING "Flight Time = +###.####"; TIME
2400 LOCATE 22, 54: PRINT USING "Final Velocity = +###.####"; VEL
2410 '
2420 RETURN
2430 '
3000 '************************************************************************
3010 'subroutine to draw trajectory
3020 'input variables:  RAD, MOUNT, XE, YE, X0, Y0, ASPECT
3030 'output variables: FLAG
3040 'global variables: none
3050 'local variables:  HC, X1, Y1, X2, Y2
3060 '************************************************************************
3070 '
3080 Y1 = YE - Y0                                        'scaling for graphics
3090 X1 = XE + X0: X1 = X1 * ASPECT
3100 Y2 = YE - Y
3110 X2 = XE + X: X2 = X2 * ASPECT
3120 LINE (X1, Y1)-(X2, Y2)                                   'draw trajectory
3130 '
3140    LOCATE (YE - rad - MOUNT) / 8 + 1, XE * ASPECT / 8: PRINT SPACE$(1)
3150    LOCATE (YE - rad - MOUNT) / 8 + 1, XE * ASPECT / 8: PRINT "*"
3160                                                           'flashing point
3170 RETURN
3180 '
4000 '************************************************************************
4010 'subroutine to draw the planet & place of firing
4020 'input variables:  FLAG, RAD, MOUNT, XE, YE
4030 'output variables: none
4040 'global variables: none
4050 'local variables:  HC, XP, YP, ZP, XP0, YP0, ZP0, TITLE$
4060 '************************************************************************
4070 IF FLAG <> 0 THEN RETURN                     'draw planet first time only
4080 CLS
4090 TITLE$ = "Simulation of Trajectory of a Satellite"
4100 LOCATE 1, 10: PRINT TITLE$
4110 PRINT "---------------------------------------------------"
4120                           'to choose center of screen as center of circle
4130                                              'keep  x1=120,y1=100, r <100
4140 LOCATE 1, 20
4150 LOCATE 13, 30: PRINT "PLANET"
4160  HC = 1
4170                                                              'draw planet
4180 FOR I = 0 TO 2 * rad
4190  XP = -rad + I * HC + XE
4200  YP = YE + SQR(rad * rad - (XP - XE) ^ 2)
4210  ZP = YE - SQR(rad * rad - (XP - XE) ^ 2)
4220  XP = XP * ASPECT                           'multiply by the aspect ratio
4230  IF I = 0 THEN 4260                           'normalize the x & y scales
4240  LINE (XP0, YP0)-(XP, YP)
4250  LINE (XP0, ZP0)-(XP, ZP)
4260  XP0 = XP: YP0 = YP: ZP0 = ZP
4270 NEXT I
4280                                                'draw the flashing station
4290  LOCATE (YE - rad - MOUNT) / 8 + 1, XE * ASPECT / 8: PRINT "*"
4300  LINE (XE * ASPECT, YE - rad)-(XE * ASPECT, YE - rad - MOUNT)
4310 '
4320 FLAG = FLAG + 1
4330 '
4340 RETURN
4350 '
10000 '***********************************************************************
10010 'subroutine to display header screen
10020 'input variables:  none
10030 'output variables: none
10040 'global variables: none
10050 'local variables:  none
10060 '***********************************************************************
10070 CLS : KEY OFF                                           'clear screen
10080 SCREEN 2, 0, 0: WIDTH 80                               'change screen
10090  '
10100 LINE (1, 1)-(638, 40), , B                                'draw boxes
10110 LINE (5, 3)-(633, 37), , B
10120 LINE (70, 50)-(570, 140), , B
10130 LINE (75, 53)-(565, 137), , B
10140                                           'print title, authors, etc.
10150 LOCATE 3, 7
10160 PRINT " C O M P U T A T I O N A L   P H Y S I C S :";
10170 PRINT " (An  Introduction)"
10180 LOCATE 9, 40
10190 PRINT "by";
10200 LOCATE 11, 20: PRINT "R.C. Verma, P.K. Ahluwalia & K.C. Sharma"
10210 LOCATE 13, 34
10220 PRINT "   * * * *    "
10230 '
10240 BEEP
10250 LOCATE 15, 35: PRINT "* * * * * *"
10260 LOCATE 22, 25: PRINT "press any key to continue"
10270 LOCATE 23, 25: PRINT "-------------------------"
10280 '
10290 IF INKEY$ = "" THEN 10290                            'hold the screen
10300 CLS                                                     'clear screen
10310 RETURN
10320 '

