10 '**************************************************************************
20 'Chapter 3, Example 2: Motion of a Driven Oscillator (1-dimensional)
30 'COMPUTATIONAL PHYSICS: An Introduction
40 'by R. C. Verma, P. K. Ahluwalia and K. C. Sharma
50 '   * * * *   
60 '**************************************************************************
70  CLS : KEY OFF
80  GOSUB 10000                                                   'show header
90                                                    'define acceleration fn.
100 DEF FNA (T, X, V) = (DRIAMP * SIN(DRIW * T + PHI) - KSPRING * X + DAMPC * V) / MASS
110 '
120 PI = 3.1415926#                    'define constants pi & drag coefficient
130 '
140 GOSUB 1000                'introduce the problem & to get input parameters
150 '
160 NSTEP% = (TF - TI) / H
170                           'find number of steps to cover the time interval
180 DIM T(NSTEP% + 1), S(NSTEP% + 1), V(NSTEP% + 1), A(NSTEP% + 1)
190 DIM X(NSTEP% + 1), Y(NSTEP% + 1), DRVAMP(NSTEP% + 1)
200 DIM PX%(NSTEP% + 1), PY%(NSTEP% + 1), PMX%(5), PMY%(5)
210 '                                                    'dimension the arrays
220 FLAG = 0                                                         'set flag
230 PHI = PHI * PI / 180                       'convert phase degree to radian
240 GOSUB 2000                                       'perform Half-step method
250 GOSUB 3000                                                    'draw graphs
260 '
270 CLS
275 LOCATE 12, 1: PRINT SPACE$(78)
280 LOCATE 12, 1: BEEP: INPUT "Do you want make another try? Press Y/N"; ANS$
290   IF ANS$ = "y" OR ANS$ = "Y" THEN 310
295   IF ANS$ = "N" OR ANS$ = "n" THEN 390
300   BEEP: GOTO 275
310 LOCATE 16, 1: PRINT SPACE$(78)                                'next choice
320 LOCATE 16, 1
325 INPUT "Give another Frequency (w) & Phase of the Driver"; DRIW, PHI
330   IF DRIW > 0 THEN 370
340   LOCATE 16, 1: PRINT SPACE$(78)
350   LOCATE 16, 1: BEEP: PRINT "Please give +ve suitable value for w!"
360   GOTO 310
370 '
380 GOTO 220                                           'repeat for next choice
390 '
400 CLS : LOCATE 12, 15: BEEP: PRINT "Program ends here!"
410 END
420 '
1000 '************************************************************************
1010 'subroutine to introduce the problem & to get input variables
1020 'input variables:  PI
1030 'output variables: KSPRING, MASS, DAMPC, DRIAMP, DRIW, PHI, SI, VI, TI, TF
1040 '                  H, TUNIT$, SUNIT$, VUNIT$, AUNIT$, MUNIT$, DRVMAX
1050 'global variables: none
1060 'local variables:  UNITS, OMEGA
1070 'test cases: KSPRING=1, MASS=1, DAMPC=0.2, DRIAMP=5, DRIW=2, PHI=90
1080 '            TI=0, TF =10, H=0.01, SI=0, VI=1
1090            'For large k, small m keep time interval small/ large damping
1100 '************************************************************************
1110 '
1120 LOCATE 2, 10: PRINT "This program describes motion of a damped oscillator"
1130 LOCATE 3, 10: PRINT "----------------------------------------------------"
1140                                                   'choose system of units
1150 LOCATE 4, 10: BEEP: PRINT "Which systems of units you want to work in?"
1160 LOCATE 6, 15: PRINT "1) m.k.s., 2) c.g.s."
1170 LOCATE 8, 15: PRINT SPACE$(65)
1175 LOCATE 8, 15: INPUT "Press 1 or 2."; UNITS
1180   IF UNITS = 1 OR UNITS = 2 THEN 1210
1190   BEEP: PRINT "Try again!"
1200   GOTO 1170
1210 '
1220   TUNIT$ = "s"
1230 IF UNITS <> 1 THEN 1250
1240  SUNIT$ = "m": MUNIT$ = "kg": VUNIT$ = "m/s": AUNIT$ = "m/s2"
1250 IF UNITS <> 2 THEN 1265
1255  SUNIT$ = "cm": MUNIT$ = "g": VUNIT$ = "cm/s": AUNIT$ = "cm/s2"
1260 '
1265 BEEP: LOCATE 12, 10: PRINT "press any key to continue"
1270  IF INKEY$ = "" THEN 1270
1275 CLS
1280 LOCATE 1, 10: BEEP: PRINT "Please feed the input parameters"
1290                                        'physical properties of the system
1295 LOCATE 3, 1: PRINT SPACE$(78)
1300 LOCATE 3, 1: INPUT "Give spring constant: k "; KSPRING
1305   IF KSPRING > 0 THEN 1320
1310   BEEP: PRINT "Please give suitable value for k!"
1315   GOTO 1295
1320 LOCATE 5, 1: PRINT SPACE$(78)
1325 LOCATE 5, 1: INPUT "Give value of mass attached: m "; MASS
1330   IF MASS > 0 THEN 1345
1335   BEEP: PRINT "Please give +ve value of m!"
1340   GOTO 1320
1345 '
1350   TPERIOD = 2 * PI / SQR(KSPRING / MASS)
1355                                   'expected time period for input purpose
1360   OMEGA = 2 * PI / TPERIOD                                  'and graphics
1370 '
1380 LOCATE 7, 1: PRINT SPACE$(78)
1385 LOCATE 7, 1: INPUT "Give damping coefficient: c "; DAMPC
1390   IF DAMPC >= 0 THEN 1420
1400   BEEP: PRINT "Please give suitable value for the coefficient!"
1410   GOTO 1380
1420 LOCATE 9, 1: PRINT SPACE$(78)
1425 LOCATE 9, 1: INPUT "Give amplitude of driver"; DRIAMP
1430   IF DRIAMP <> 0 THEN 1470
1435 BEEP: LOCATE 10, 1
1440 INPUT "Given Amplitude is zero! Do you want to change it? Press Y/N"; QANS$
1445  IF QANS$ = "N" OR QANS$ = "n" THEN 1470
1450  IF QANS$ = "Y" OR QANS$ = "y" THEN 1420
1455  LOCATE 10, 1: PRINT SPACE$(80): GOTO 1435
1460 '
1470 LOCATE 11, 1: PRINT SPACE$(78)
1475 LOCATE 11, 1: INPUT "Give frequency of driver: w "; DRIW
1480   IF DRIAMP = 0 OR DRIW > 0 THEN 1495
1485   BEEP: PRINT "Please give nonzero value for w!"
1490   GOTO 1470
1495 LOCATE 13, 1: PRINT SPACE$(78)
1500 LOCATE 13, 1: INPUT "Give initial phase of driver"; PHI
1505 '
1515 DRVMAX = DRIAMP / (MASS * DRIW * DRIW)         'defined for graphics only
1520 '                                                          'time interval
1525 LOCATE 15, 1: PRINT SPACE$(78)
1530 LOCATE 15, 1: INPUT "Give initial and final times: Ti, Tf"; TI, TF
1535   IF TF > TI THEN 1555
1540   BEEP: PRINT "Give suitable time interval Ti, Tf!"
1550   GOTO 1525
1555 '
1560  HMIN = (TF - TI) / 1000                       'minimum step size allowed
1565 LOCATE 17, 1: PRINT SPACE$(78)
1570 LOCATE 17, 1: INPUT "Give time step h "; H
1575  IF H >= HMIN AND H < TPERIOD / 10 THEN 1590
1580  BEEP: PRINT "Please give "; HMIN; " < h < "; TPERIOD / 10
1585  GOTO 1565                                  'array size & h < time period
1590 '
1600 LOCATE 19, 1: INPUT "Give initial position: X0 "; SI
1605 LOCATE 21, 1: INPUT "Give initial velocity: Vo "; VI
1610 '
1620 RETURN
1630 '
2000 '************************************************************************
2010 'subroutine to perform Feynman-Newton Half-step method
2020 'input variables:  KSPRING. MASS, DAMPC, TI, SI, VI, H, NSTEP%,
2030 '                  TUNIT$, SUNIT$, VUNIT$, AUNIT$
2040 'output variables: N%, T(I%), S(I%), V(I%), A(I%)
2050 'global variables: none
2060 'local variables:  NUM%,
2070 '************************************************************************
2080 '
2090 IF NSTEP% > 40 THEN NUM% = INT(NSTEP% / 20) ELSE NUM% = 2
2100 '
2110  T(0) = TI: S(0) = SI: V(0) = VI                      'initial conditions
2120   A(0) = FNA(T(0), S(0), V(0))                      'initial acceleration
2130   V(1) = V(0) + .5 * A(0) * H                      'velocity at half-step
2140 '
2150 PRINT " Position, Velocity and Acceleration of Oscillator"
2160 PRINT "----------------------------------------------------"
2170 PRINT "  Time         A           V          S"
2180 PRINT "   "; TUNIT$; "         "; AUNIT$; "        "; VUNIT$; "           "; SUNIT$
2190 PRINT "----------------------------------------------------"
2200 '                                                       'half-step method
2210 FOR I% = 0 TO NSTEP%
2220   IF I% = 0 THEN 2270                                         'print only
2230   T(I%) = T(I% - 1) + H
2240   S(I%) = S(I% - 1) + V(I%) * H                         'distance formula
2250   A(I%) = FNA(T(I%), S(I%), V(I%))                      'new acceleration
2260   V(I% + 1) = V(I%) + A(I%) * H                         'velocity formula
2270   DRVAMP(I%) = DRVMAX * SIN(DRIW * T(I%) + PHI)
2280                        'get driver's own oscillations for comparison only
2290   IF (I% MOD NUM%) <> 0 AND I% <> NSTEP% THEN 2310     'print selectively
2300   PRINT USING "##.###   +#.####^^^^   +#.####^^^^   +#.####^^^^"; T(I%); A(I%); V(I%); S(I%)
2310 NEXT I%
2320 '
2330 PRINT "----------------------------------------------------"
2340                                                               'table ends
2350 PRINT : PRINT "press any key to continue": PRINT
2360 IF INKEY$ = "" THEN 2360
2370 '
2380 RETURN
2390 '
3000 '************************************************************************
3010 'subroutine to draw: displacement, velocity & acceleration vs. time
3020 'input variables:  N%, T(I%), S(I%), V(I%), A(I%),
3030 'output variables: X(I%), Y(I%), TITLE$, SUBTITLE$, XTITLE$, YTITLE$
3040 '                  PXMIN%, PXMAX%, PYMIN%, PYMAX%
3050 'global variables: none
3060 'local variables:  none
3070 '************************************************************************
3080 CLS                                                         'clear screen
3090 '
3100 TITLE$ = "* * *  Motion of a Damped Oscillator  * * *"
3110 FLAG = 0                                                        'set flag
3120                                         'draw displacement vs. time graph
3130 PXMIN% = 120: PXMAX% = 280: PYMIN% = 24: PYMAX% = 64'choose screen region
3140 SUBTITLE$ = "Displacement vs. time": XTITLE$ = "t": YTITLE$ = "S"
3150 '
3160 FOR I% = 0 TO NSTEP%
3170  X(I%) = T(I%): Y(I%) = S(I%)         'assign variables for S vs. t graph
3180 NEXT I%
3190 '
3200 GOSUB 4000                                                 'display graph
3210 '
3220 LOCATE 22, 5: PRINT USING "Max. Amplitude = +#.###^^^^ "; YMAX;
3230 PRINT SUNIT$
3240                                             'draw velocity vs. time graph
3250 PXMIN% = 440: PXMAX% = 600: PYMIN% = 24: PYMAX% = 64'choose screen region
3260 SUBTITLE$ = "Velocity vs. time": XTITLE$ = "t": YTITLE$ = "V"
3270 '
3280 FOR I% = 0 TO NSTEP%
3290   Y(I%) = V(I%)                       'assign variables for V vs. t graph
3300 NEXT I%
3310 '
3320 GOSUB 4000                                                 'display graph
3330 '
3340 LOCATE 22, 45: PRINT USING "Max. Velocity = +#.###^^^^ "; YMAX;
3350 PRINT VUNIT$
3360                                         'draw acceleration vs. time graph
3370 PXMIN% = 120: PXMAX% = 280: PYMIN% = 96: PYMAX% = 140'choose screen region
3380 SUBTITLE$ = "Acceleration vs. time": XTITLE$ = "t": YTITLE$ = "A"
3390 '
3400 FOR I% = 0 TO NSTEP%
3410  Y(I%) = A(I%)                        'assign variables for A vs. t graph
3420 NEXT I%
3430 '
3440 YMAX = AAMP: YMIN = -YMAX                            'limits for graphics
3450 '
3460 GOSUB 4000                                                 'display graph
3470 '
3480                                              'draw phase space trajectory
3490 PXMIN% = 446: PXMAX% = 600: PYMIN% = 96: PYMAX% = 140 'choose screen region
3500 SUBTITLE$ = "Driver's oscillations": XTITLE$ = "t": YTITLE$ = "X"
3510 '
3520 FOR I% = 0 TO NSTEP%
3530  Y(I%) = DRVAMP(I%)                   'assign variables for V vs. S graph
3540 NEXT I%
3550 '
3560 YMAX = DRVMAX: YMIN = -YMAX
3570 FLAG = 1                                                        'set flag
3580 '
3590 GOSUB 4000                                                 'display graph
3600 '
3610 LOCATE 23, 30: BEEP: PRINT "press any key to continue"
3620 IF INKEY$ = "" THEN 3620
3630 '
3640 RETURN
3650 '
4000 '************************************************************************
4010 'subroutine to display graph between x(i) & y(i) variables
4020 'input variables: N%, X(I%), Y(I%), XTITLE$, YTITLE$, TITLE$, SUBTITLE$
4030 '                 XMIN, XMAX, YMIN, YMAX, PXMIN%, PXMAX%, PYMIN%, PYMAX%
4040 'output variables: none
4050 'global variables: none
4060 'local variables: PXMIN%, PXMAX%, PYMIN%, PYMAX%
4070 '                 KCOEFF1, KCOEFF2, KCOEFF3 ,KCOEFF4, PX%(I%), PY%(I%)
4080 '                 DIV%, XSCALE, YSCALE, PXSCALE, PYSCALE
4090 '                 PMX%(J%), PMY%(J%), ROWX%, COLX%, ROWY%, COLY%
4100 '************************************************************************
4110 LOCATE 1, 15: PRINT TITLE$
4120  DIV% = 4                    'set number of divisions (<5) on x- & y-axes
4130                                                  'find max. min. of X & Y
4140 IF FLAG <> 0 THEN 4290                           'MIN & MAX already given
4150 '
4160 XMIN = 0: XMAX = 0: YMIN = 0: YMAX = 0              'initialize variables
4170 '
4180 FOR I% = 0 TO NSTEP%               'loop to find maximum & minimum values
4190  IF X(I%) < XMIN THEN XMIN = X(I%)                'along x & y directions
4200  IF X(I%) > XMAX THEN XMAX = X(I%)
4210  IF Y(I%) < YMIN THEN YMIN = Y(I%)
4220  IF Y(I%) > YMAX THEN YMAX = Y(I%)
4230 NEXT I%
4240 '
4250  IF YMAX * YMIN > 0 THEN 4290
4260 IF ABS(YMAX) > ABS(YMIN) THEN YMIN = -YMAX
4270 IF ABS(YMAX) < ABS(YMIN) THEN YMAX = -YMIN
4280                                                  'find scale coefficients
4290 KCOEFF1 = (PXMAX% - PXMIN%) / (XMAX - XMIN)
4300 KCOEFF2 = (PXMAX% * XMIN - PXMIN% * XMAX) / (XMIN - XMAX)
4310 KCOEFF3 = (PYMAX% - PYMIN%) / (YMIN - YMAX)
4320 KCOEFF4 = (PYMAX% * YMAX - PYMIN% * YMIN) / (YMAX - YMIN)
4330 '
4340 ROWTIT% = PYMIN% / 8 - 1: COLTIT% = PXMIN% / 8 + 1
4350 LOCATE ROWTIT%, COLTIT%: PRINT SUBTITLE$               'print graph-title
4360 '
4370 LINE (PXMIN%, PYMIN%)-(PXMAX%, PYMAX%), , B           'draw box for graph
4380 LINE (PXMIN%, KCOEFF4)-(PXMAX%, KCOEFF4)                     'draw x-axis
4390 LINE (KCOEFF2, PYMIN%)-(KCOEFF2, PYMAX%)                     'draw y-axis
4400 '
4410 XSCALE = (XMAX - XMIN) / DIV%                       'find scale for marks
4420 YSCALE = (YMAX - YMIN) / DIV%
4430 '
4440 PXSCALE = (PXMAX% - PXMIN%) / DIV%            'find pixel scale for marks
4450 PYSCALE = (PYMAX% - PYMIN%) / DIV%
4460 '
4470 ROWX% = PYMAX% / 8 + 2              'find row for marks along x-direction
4480 COLY% = PXMIN% / 8 - 10          'find column for marks along y-direction
4490 '
4500 FOR J% = 0 TO DIV%                          'start loop to mark divisions
4510   PMX(J%) = PXMIN% + PXSCALE * J%                    'find places to mark
4520   PMY(J%) = PYMIN% + PYSCALE * J%
4530    LINE (PMX(J%), PYMAX%)-(PMX(J%), PYMAX% - 5)               'draw marks
4540    LINE (PXMIN%, PMY(J%))-(PXMIN% + 5, PMY(J%))
4550 '
4560   IF J% / 2 <> INT(J% / 2) THEN 4800            'jump for alternate marks
4570 '
4580   COLX% = PMX(J%) / 8 - 3         'find column for each mark along x-axis
4590   ROWY% = PMY(J%) / 8 + 1            'find row for each mark along y-axis
4600 '
4610   LOCATE ROWX%, COLX%
4620    IF XMAX > 999.99 OR XMIN < -999.99 THEN 4660
4630    IF XMAX < .1 AND XMIN > -.1 THEN 4660                'format selection
4640   PRINT USING "+###.##"; XMIN + XSCALE * J%      'print x-scale divisions
4650   GOTO 4680
4660   PRINT USING "+#.##^^^^"; XMIN + XSCALE * J%    'print x-scale divisions
4670 '
4680   LOCATE ROWY%, COLY%
4690    IF YMAX > 999.99 OR YMIN < -999.99 THEN 4730
4700    IF YMAX < .1 AND YMIN > -.1 THEN 4730                'format selection
4710   PRINT USING "+###.##"; YMAX - YSCALE * J%      'print y-scale divisions
4720   GOTO 4750
4730   PRINT USING "+#.##^^^^"; YMAX - YSCALE * J%    'print y-scale divisions
4740 '
4750   IF J% <> 2 THEN 4800              'print names of variables along x & y
4760    LOCATE ROWX% - 2, PXMAX% / 8 + 3: PRINT XTITLE$; "->"
4770    LOCATE ROWY% - 1, COLY% - 1: PRINT "^"
4780    LOCATE ROWY%, COLY% - 1: PRINT "|"
4790    LOCATE ROWY% + 1, COLY% - 1: PRINT YTITLE$
4800 NEXT J%
4810 '
4820 FOR I% = 0 TO NSTEP%
4830    PX%(I%) = KCOEFF1 * X(I%) + KCOEFF2     'perform scale transformations
4840    PY%(I%) = KCOEFF3 * Y(I%) + KCOEFF4                  'along x & y axes
4850    IF I% = 0 THEN 4870
4860    LINE (PX%(I% - 1), PY%(I% - 1))-(PX%(I%), PY%(I%))         'draw graph
4870 NEXT I%
4880 '
4890 RETURN
4900 '
10000 '***********************************************************************
10010 'subroutine to display header screen
10020 'input variables:  none
10030 'output variables: none
10040 'global variables: none
10050 'local variables:  none
10060 '***********************************************************************
10070 CLS : KEY OFF                                           'clear screen
10080 SCREEN 2, 0, 0: WIDTH 80                               'change screen
10090  '
10100 LINE (1, 1)-(638, 40), , B                                'draw boxes
10110 LINE (5, 3)-(633, 37), , B
10120 LINE (70, 50)-(570, 140), , B
10130 LINE (75, 53)-(565, 137), , B
10140                                           'print title, authors, etc.
10150 LOCATE 3, 7
10160 PRINT " C O M P U T A T I O N A L   P H Y S I C S :";
10170 PRINT " (An  Introduction)"
10180 LOCATE 9, 40
10190 PRINT "by";
10200 LOCATE 11, 20: PRINT "R.C. Verma, P.K. Ahluwalia & K.C. Sharma"
10210 LOCATE 13, 34
10220 PRINT "   * * * *    "
10230 '
10240 BEEP
10250 LOCATE 15, 35: PRINT "* * * * * *"
10260 LOCATE 22, 25: PRINT "press any key to continue"
10270 LOCATE 23, 25: PRINT "-------------------------"
10280 '
10290 IF INKEY$ = "" THEN 10290                            'hold the screen
10300 CLS                                                     'clear screen
10310 RETURN
10320 '

