10 '**************************************************************************
20 'Chapter 4, Example 3: Fourier sum of harmonic waves
30 'COMPUTATIONAL PHYSICS: An Introduction
40 'by R. C. Verma, P. K. Ahluwalia and K. C. Sharma
50 '   * * * *
60 '**************************************************************************
70  CLS : KEY OFF
80  GOSUB 10020                                                   'show header
90 '
91 DIM AMP(25)         'give dimensions for amplitude array
92  'define function for wave amplitude for odd harmonics
93 DEF FNF (I, T) = AMP(I) * SIN((2 * I - 1) * W * T)
94 '
95 '
96 ' data for amplitude of first 25 odd harmonics
100 DATA 1, .333333, .2, .142857, .111111, 0.090909
110 DATA .076923, .066667, .058824, .052632, .047619
120 DATA .043478, 0.04, .037037, .034483, .03228
130 DATA .030303, .028571, .027027, .025641, .024390
140 DATA .023256, .022222, .021277, .020408
150 '
160 INPUT "No. of terms to be included  <25 "; NWAVE
170 INPUT "Give the funamental frequency w "; W
180 INPUT "maximum time Tmax "; TMAX
190 INPUT "Give step size "; H
200 '
210 FOR I = 1 TO NWAVE
220  READ AMP(I)              'read corresponding amplitude
230 NEXT I
240 '
270 GOSUB 1020             'draw base line
280 '
290  T = 0                   'initialize time
295 '
300 WHILE T <= TMAX          'loop over time
310    Y = 0               'initialize sum
320    FOR I = 1 TO NWAVE           'loop over waves
330      Y = Y + FNF(I, T)        'in nondispersive medium
340    NEXT I                        'loop over waves ends
350    GOSUB 2020             'draw resultant wave
360    T = T + H             'increment time
370 WEND                     'loop over time ends
380 '
390 END
400 '
1000 'subroutine to draw axes of the graph
1010 '
1020 SCREEN 2, 0, 0: WIDTH 80: CLS 'change screen for graphics
1030 '        find maximum possible amplitude for graphics
1040 FOR I = 1 TO NWAVE: YMAX = YMAX + AMP(I): NEXT I
1050 YMIN = -YMAX: TMIN = 0       'lower limits
1060  XSCALE = 480 / (TMAX - TMIN)'scales for x- & y-axes
1070  YSCALE = 160 / (YMAX - YMIN)
1080 LOCATE 1, 30!                 'print title
1090  PRINT "Fourier Sum of Harmonic Waves: Square Wave"
1100  LINE (64, 96)-(544, 96)          'draw base line
1110 RETURN
1120 '
2000 'subroutine to draw the waves
2010  '             scale transformations for graphics
2020  X% = T * XSCALE + 64
2030  Y% = (YMAX - Y) * YSCALE + 16
2040 IF T > TMIN THEN LINE -(X%, Y%) ELSE PSET (X%, Y%)
2050 RETURN
2060 '

10010 '
10020 '***********************************************************************
10030 'subroutine to display header screen
10040 'input variables:  none
10050 'output variables: none
10060 'global variables: none
10070 'local variables:  none
10080 '***********************************************************************
10090 CLS : KEY OFF                                           'clear screen
10100 SCREEN 2, 0, 0: WIDTH 80                               'change screen
10110  '
10120 LINE (1, 1)-(638, 40), , B                                'draw boxes
10130 LINE (5, 3)-(633, 37), , B
10140 LINE (70, 50)-(570, 140), , B
10150 LINE (75, 53)-(565, 137), , B
10160                                           'print title, authors, etc.
10170 LOCATE 3, 7
10180 PRINT " C O M P U T A T I O N A L   P H Y S I C S :";
10190 PRINT " (An  Introduction)"
10200 LOCATE 9, 40
10210 PRINT "by";
10220 LOCATE 11, 20: PRINT "R.C. Verma, P.K. Ahluwalia & K.C. Sharma"
10230 LOCATE 13, 34
10240 PRINT "   * * * *    "
10250 '
10260 BEEP
10270 LOCATE 15, 35: PRINT "* * * * * *"
10280 LOCATE 22, 25: PRINT "press any key to continue"
10290 LOCATE 23, 25: PRINT "-------------------------"
10300 '
10310 IF INKEY$ = "" THEN 10310                            'hold the screen
10320 CLS                                                     'clear screen
10330 '
10340 RETURN
10350 '

