10 '**************************************************************************
20 'Chapter 4, Example 4:Phenomenon of Dispersion
30 'COMPUTATIONAL PHYSICS: An Introduction
40 'by R. C. Verma, P. K. Ahluwalia and K. C. Sharma
50 '   * * * *    
60 '**************************************************************************
70  CLS : KEY OFF
80  GOSUB 10000                                                   'show header
90  DIM X1%(2), Y1%(2), X2%(2), Y2%(2)
100 DIM PMX%(5), PMY%(5), KCOEF1(2), KCOEF2(2), KCOEF3(2), KCOEF4(2)
110 DIM PMXMIN%(2), PMXMAX%(2), PMYMIN%(2), PMYMAX%(2)
120                                                           'give dimensions
130                                        'define function for wave amplitude
140 DEF FNF (X, T) = AMPD * SIN(KVEC * X - WFRQ * T)
150 '
160 PI = 3.1415926#                                        'define constant pi
170 '
180 GOSUB 1000                'introduce the problem & to get input parameters
190 CLS                                                          'clear screen
200 FIG% = 1: GOSUB 5000                 'draw upper graph axes and set scales
210 FIG% = 2: GOSUB 5000                 'draw lower graph axes and set scales
220 GOSUB 2000                              'find amplitude of pulse & draw it
230 '
240 LOCATE 23, 1: BEEP: PRINT "press any key to continue"
250 IF INKEY$ = "" THEN 250
260 '
270 CLS : LOCATE 12, 15: BEEP: PRINT "Program ends here!"
280 END
290 '
1000 '************************************************************************
1010 'subroutine to introduce the problem & to get input variables
1020 'input variables:  none
1030 'output variables: NWAVE%, AMP(I%), KVE(I%), WFR(I%)
1040 '                  TMIN, TMAX, XMIN, XMAX, H, HT, YMIN, YMAX
1050 'global variables: none
1060 'local variables:  AMPSUM, I%
1070 'test cases: NWAVE%=3: AMP(I%)=1,1,1 : KVE(I%)=1,3,5 : WFR(I%)=1,1,1
1080 '            H=0.05, HT=0.05, XMIN=0, XMAX=10, TMIN=0, TMAX=10
1090 '************************************************************************
1100 '
1110 LOCATE 2, 10
1115  PRINT "This program demonstrate the phenomenon of Dispersion"
1120 LOCATE 4, 10
1125  PRINT "-----------------------------------------------------"
1130 '
1140 LOCATE 6, 5: BEEP
1150  PRINT "Please feed the input parameters of the component waves"
1160 '
1170                                        'physical properties of the system
1180 LOCATE 7, 5: PRINT "Feed parameters of the component waves"
1190 LOCATE 9, 1: PRINT SPACE$(80)
1195 LOCATE 9, 1: INPUT "Give no. of waves to be superposed = "; NWAVE%
1200  IF NWAVE% > 0 THEN 1210
1205  BEEP: GOTO 1190
1210 FOR I% = 1 TO NWAVE%
1220  LOCATE 10, 1: PRINT SPACE$(78)
1230  LOCATE 10, 1: BEEP: PRINT "wave no. ="; I%
1240  LOCATE 11, 1: PRINT SPACE$(75): LOCATE 11, 1
1250  INPUT "Give amplitude, wave-vector & frequency"; AMP(I%), KVE(I%), WFR(I%)
1260   IF AMP(I%) > 0 AND KVE(I%) >= 0 AND WFR(I%) >= 0 THEN 1300
1270   BEEP: PRINT "Please give suitable amplitude, wave-vector and frequency"
1280   GOTO 1240
1290 '
1300 NEXT I%
1310 '
1320 FOR I% = 1 TO NWAVE%
1330   IF WFR(I%) > 0 THEN 1380  'find time limits only when freq. is nonzero
1340 NEXT I%
1350 TMIN = 0: TMAX = 0: HT = .1     'fix limits when all frequencies are zero
1360 GOTO 1490
1370 '
1380 LOCATE 13, 1: PRINT SPACE$(80)
1385 LOCATE 13, 1: INPUT "Give initial and final times, & Ti, Tf"; TMIN, TMAX
1390   IF TMAX > TMIN THEN 1430
1400   BEEP: PRINT "Please give suitable time interval Ti, Tf!"
1410   GOTO 1380
1420 '
1430 LOCATE 15, 1: PRINT SPACE$(80)
1435 LOCATE 15, 1: INPUT "Give time step h "; HT
1440  IF HT > 0 THEN 1480
1450  BEEP: PRINT "Please give suitable value of time step!"
1460  PRINT
1470  GOTO 1430
1480 LOCATE 17, 1: PRINT SPACE$(80)                                  'x-domain
1490 LOCATE 17, 1
1495 INPUT "Give initial and final X positions, Xi, Xf"; XMIN, XMAX
1500   IF XMAX > XMIN THEN 1530
1510   BEEP: PRINT "Please give suitable X-domain Xi, Xf!"
1520   GOTO 1480
1530 '
1540 LOCATE 19, 1: PRINT SPACE$(80)
1545 LOCATE 19, 1: INPUT "Give position-step: hx "; H
1550  IF H > 0 THEN 1590
1560  BEEP: PRINT "Please give suitable value of time step!"
1570  PRINT
1580  GOTO 1540
1590 '
1600  AMPSUM = 0
1610 FOR I% = 1 TO NWAVE%
1620   AMPSUM = AMPSUM + AMP(I%)          'find sum of amplitudes for graphics
1630 NEXT I%
1640  YMAX = AMPSUM: YMIN = -YMAX                    'max. & min. for graphics
1650 '
1660 RETURN
1670 '
2000 '************************************************************************
2010 'subroutine to calculate and draw wave amplitude
2020 'input variables:  TMIN, TMAX, XI, XMAX, FNF(X,T), H, HT
2030 '                  AMP(I%), KVE(I%), WFR(I%)
2040 'output variables: X, Y, T, FIG%
2050 'global variables: none
2060 'local variables:  SUMY, AMPD, KVEC, WFRQ
2070 '************************************************************************
2080 '
2090 T = TMIN
2100 '
2110 WHILE T <= TMAX                                           'loop over time
2120  X = XMIN                                            'initialize position
2130  FIG% = 1: GOSUB 3000                                 'clear upper screen
2140  FIG% = 2: GOSUB 3000                                 'clear lower screen
2150  WHILE X <= XMAX                                  'loop over space points
2160    SUMY = 0: SUMZ = 0                                     'initialize sum
2170    FOR I% = 1 TO NWAVE%                                  'loop over waves
2180      AMPD = AMP(I%): KVEC = KVE(I%): WFRQ = WFR(I%)      'wave parameters
2190      SUMY = SUMY + FNF(X, T)                     'in nondispersive medium
2200      WFRQ = WFR(I%) * SQR(KVEC)                     'introduce dispersion
2210      SUMZ = SUMZ + FNF(X, T)
2220   NEXT I%                                           'loop over waves ends
2230   Y = SUMY
2240   FIG% = 1: GOSUB 4000       'draw resultant wave in nondispersive medium
2250   Y = SUMZ
2260   FIG% = 2: GOSUB 4000          'draw resultant wave in dispersive medium
2270   X = X + H                                             'next space point
2280  WEND                                        'loop over space points ends
2290 '
2300  T = T + HT                                               'increment time
2310 WEND                                                 'loop over time ends
2320 '
2330 RETURN
2340 '
3000 '************************************************************************
3010 'subroutine for clearing the box & find initial point on screen
3020 'input variables: PXMIN%(FIG%), PXMAX%(FIG%), PYMIN%(FIG%), PYMAX%(FIG%)
3030 '                 KCOEF1(FIG%): KCOEF2(FIG%): KCOEF3(FIG%): KCOEF4(FIG%)
3035 '                 FIG%, X,Y, T
3040 'output variable: X1%(FIG%), Y1%(FIG%)
3050 'local variables: none
3060 'global variable: none
3070 '************************************************************************
3080 LINE (PXMIN%(FIG%) + 1, PYMIN%(FIG%) + 1)-(PXMAX%(FIG%) - 1, PYMAX%(FIG%) - 1), 0, BF
3090 LINE (PXMIN%(FIG%), KCOEF4(FIG%))-(PXMAX%(FIG%), KCOEF4(FIG%))
3095                                                              'draw x-axis
3100  X1%(FIG%) = KCOEF1(FIG%) * X + KCOEF2(FIG%)'perform scale transformations
3110  Y1%(FIG%) = KCOEF3(FIG%) * Y + KCOEF4(FIG%)            'along x & y axes
3115 '
3120 LOCATE 22, 70: BEEP: PRINT USING "t = ##.##"; T       'print current time
3130 '
3140 RETURN
3150 '
4000 '************************************************************************
4010 'subroutine to draw wave pattern
4020 'input variables: X, Y, X1%(FIG%), Y1%(FIG%), FIG%
4030 '                 KCOEF1(FIG%): KCOEF2(FIG%): KCOEF3(FIG%): KCOEF4(FIG%)
4040 'Output variable: None
4050 'local variables: X2%(FIG%), Y2%(FIG%)
4060 'Global variable: NI
4070 '************************************************************************
4080                                     'scale transformation for x- & y-axes
4090  X2%(FIG%) = KCOEF1(FIG%) * X + KCOEF2(FIG%)'perform scale transformations
4100  Y2%(FIG%) = KCOEF3(FIG%) * Y + KCOEF4(FIG%)            'along x & y axes
4110                                           'present position and amplitude
4120  LINE (X1%(FIG%), Y1%(FIG%))-(X2%(FIG%), Y2%(FIG%)) 'join with last point
4130  X1%(FIG%) = X2%(FIG%): Y1%(FIG%) = Y2%(FIG%)            'roll the values
4140 '
4150 RETURN
4160 '
5000 '************************************************************************
5010 'subroutine to draw axes and set scales
5020 'input variables:  XMIN, XMAX, YMIN. YMAX, FIG%
5030 'output variables: TITLE$, XTITLE$, YTITLE$,
5040 '                  KCOEF1(FIG%): KCOEF2(FIG%): KCOEF3(FIG%): KCOEF4(FIG%)
5050 '                  PXMIN%(FIG%), PXMAX%(FIG%), PYMIN%(FIG%), PYMAX%(FIG%)
5060 'global variables: none
5070 '************************************************************************
5080 IF FIG% = 1 THEN SUBTITLE$ = "nondispersive medium"
5090 IF FIG% = 2 THEN SUBTITLE$ = "dispersive medium"
5100 '
5110 DIV% = 4                                       'no. of marks on x, y axes
5120 PXMIN%(FIG%) = 136: PXMAX%(FIG%) = 456              'choose screen region
5130 IF FIG% = 1 THEN PYMIN%(FIG%) = 20: PYMAX%(FIG%) = 72'
5135                                                 'for nondispersive medium
5140 IF FIG% = 2 THEN PYMIN%(FIG%) = 104: PYMAX%(FIG%) = 156
5145                                                    'for dispersive medium
5150 '
5160 TITLE$ = "*** Effects of Dispersive Medium ***"
5170 LOCATE 1, 15: PRINT TITLE$                             'print graph-title
5180 XTITLE$ = "x": YTITLE$ = "y"
5190 '
5200 KCOEF1(FIG%) = (PXMAX%(FIG%) - PXMIN%(FIG%)) / (XMAX - XMIN)
5210 KCOEF2(FIG%) = (PXMAX%(FIG%) * XMIN - PXMIN%(FIG%) * XMAX) / (XMIN - XMAX)
5220 KCOEF3(FIG%) = (PYMAX%(FIG%) - PYMIN%(FIG%)) / (YMIN - YMAX)
5230 KCOEF4(FIG%) = (PYMAX%(FIG%) * YMAX - PYMIN%(FIG%) * YMIN) / (YMAX - YMIN)
5240 '
5250 ROWTIT% = PYMIN%(FIG%) / 8 - 1: COLTIT% = PXMIN%(FIG%) / 8 + 2
5260 LOCATE ROWTIT%, COLTIT%: PRINT SUBTITLE$               'print graph-title
5270 '
5280 LINE (PXMIN%(FIG%), PYMIN%(FIG%))-(PXMAX%(FIG%), PYMAX%(FIG%)), , B
5285                                                       'draw box for graph
5290 LINE (PXMIN%(FIG%), KCOEF4(FIG%))-(PXMAX%(FIG%), KCOEF4(FIG%))
5295                                                              'draw x-axis
5300 '
5310 XSCALE = (XMAX - XMIN) / DIV%                       'find scale for marks
5320 YSCALE = (YMAX - YMIN) / DIV%
5330 '
5340 PXSCALE = (PXMAX%(FIG%) - PXMIN%(FIG%)) / DIV%'find pixel scale for marks
5350 PYSCALE = (PYMAX%(FIG%) - PYMIN%(FIG%)) / DIV%
5360 '
5370 ROWX% = PYMAX%(FIG%) / 8 + 2        'find row for marks along x-direction
5380 COLY% = PXMIN%(FIG%) / 8 - 10    'find column for marks along y-direction
5390 '
5400 FOR J% = 0 TO DIV%                          'start loop to mark divisions
5410   PMX(J%) = PXMIN%(FIG%) + PXSCALE * J%              'find places to mark
5420   PMY(J%) = PYMIN%(FIG%) + PYSCALE * J%
5430    LINE (PMX(J%), PYMAX%(FIG%))-(PMX(J%), PYMAX%(FIG%) - 5)   'draw marks
5440    LINE (PXMIN%(FIG%), PMY(J%))-(PXMIN%(FIG%) + 5, PMY(J%))
5450 '
5460   IF J% / 2 <> INT(J% / 2) THEN 5700            'jump for alternate marks
5470 '
5480   COLX% = PMX(J%) / 8 - 3         'find column for each mark along x-axis
5490   ROWY% = PMY(J%) / 8 + 1            'find row for each mark along y-axis
5500 '
5510   LOCATE ROWX%, COLX%
5520    IF XMAX > 999.99 OR XMIN < -999.99 THEN 5560
5530    IF XMAX < .1 AND XMIN > -.1 THEN 5560                'format selection
5540   PRINT USING "+###.##"; XMIN + XSCALE * J%      'print x-scale divisions
5550   GOTO 5580
5560   PRINT USING "+#.##^^^^"; XMIN + XSCALE * J%    'print x-scale divisions
5570 '
5580   LOCATE ROWY%, COLY%
5590    IF YMAX > 999.99 OR YMIN < -999.99 THEN 5630
5600    IF YMAX < .1 AND YMIN > -.1 THEN 5630                'format selection
5610   PRINT USING "+###.##"; YMAX - YSCALE * J%      'print y-scale divisions
5620   GOTO 5650
5630   PRINT USING "+#.##^^^^"; YMAX - YSCALE * J%    'print y-scale divisions
5640 '
5650   IF J% <> 2 THEN 5700              'print names of variables along x & y
5660    LOCATE ROWX%, PXMAX%(FIG%) / 8 + 5: PRINT XTITLE$; " ->"
5670    LOCATE ROWY% - 1, COLY% - 1: PRINT "^"
5680    LOCATE ROWY%, COLY% - 1: PRINT "|"
5690    LOCATE ROWY% + 1, COLY% - 1: PRINT YTITLE$
5700 NEXT J%
5710 '
5720 RETURN
5730 '
10000 '***********************************************************************
10010 'subroutine to display header screen
10020 'input variables:  none
10030 'output variables: none
10040 'global variables: none
10050 'local variables:  none
10060 '***********************************************************************
10070 CLS : KEY OFF                                           'clear screen
10080 SCREEN 2, 0, 0: WIDTH 80                               'change screen
10090  '
10100 LINE (1, 1)-(638, 40), , B                                'draw boxes
10110 LINE (5, 3)-(633, 37), , B
10120 LINE (70, 50)-(570, 140), , B
10130 LINE (75, 53)-(565, 137), , B
10140                                           'print title, authors, etc.
10150 LOCATE 3, 7
10160 PRINT " C O M P U T A T I O N A L   P H Y S I C S :";
10170 PRINT " (An  Introduction)"
10180 LOCATE 9, 40
10190 PRINT "by";
10200 LOCATE 11, 20: PRINT "R.C. Verma, P.K. Ahluwalia & K.C. Sharma"
10210 LOCATE 13, 34
10220 PRINT "   * * * *    "
10230 '
10240 BEEP
10250 LOCATE 15, 35: PRINT "* * * * * *"
10260 LOCATE 22, 25: PRINT "press any key to continue"
10270 LOCATE 23, 25: PRINT "-------------------------"
10280 '
10290 IF INKEY$ = "" THEN 10290                            'hold the screen
10300 CLS                                                     'clear screen
10310 '
10320 RETURN
10330 '

