10 '**************************************************************************
20 'Chapter 9, Example 2: Growth of current in RL-Circuit
30 'COMPUTATIONAL PHYSICS: An Introduction
40 'by R. C. Verma, P. K. Ahluwalia and K. C. Sharma
50 '   * * * *    
60 '**************************************************************************
70 '
80 GOSUB 10000                                                    'show header
90 '
100 GOSUB 1000             'to introduce the problem & to get input parameters
110 GOSUB 3000                                                     'draw boxes
120 GOSUB 2000                           'perform Euler method and draw graphs
130 '
140 LOCATE 22, 1
150 IF INKEY$ = "" THEN 150
160 '
170 CLS : LOCATE 12, 15: BEEP: PRINT " Thank you !"
180 END
190 '
1000 '************************************************************************
1010 'subroutine to introduce the problem & to get input variables
1020 'input variables:  none
1030 'output variables: CH%
1040 'global variables: none
1050 'local variables:  none
1060 '************************************************************************
1070 '
1080 LOCATE 2, 5: PRINT "This Program describes growth and decay of current"
1090 LOCATE 3, 5: PRINT "                  in a LR - Circuit. ": PRINT
1100 LOCATE 4, 5: PRINT "---------------------------------------------------"
1110 '
1120 LOCATE 6, 5: PRINT "To make your choice, press 1 or 2"
1130 LOCATE 8, 5: PRINT "1. Growth of current in the LR-Circuit "
1140 LOCATE 10, 5: PRINT "2. Decay of current in the LR-Circuit "
1150 '
1160 LOCATE 12, 5: INPUT "choice No. = "; CH%
1170  IF CH% = 1 OR CH% = 2 THEN 1200
1180  PRINT "try again !": BEEP
1190  LOCATE 12, 5: PRINT SPACE$(70): GOTO 1160
1200 '
1210 GOSUB 5000                                          'get input parameters
1220 '
1230 RETURN
1240 '
2000 '************************************************************************
2010 'subroutine to find current in LR circuit
2020 'input variables: R, L,  H, TMIN, TMAX, II
2030 'output variables: T, I
2040 'global variables: none
2050 'local variables:  DI
2060 '************************************************************************
2070 '
2080 I = II: T = TMIN                                    'initialize variables
2090 '
2100 WHILE T <= TMAX                               'start loop over time steps
2110    GOSUB 4000                                'draw graph current vs. time
2120   T = T + H                                               'increment time
2130   DI = (V - I * R) / L              'find rate of change of current di/dt
2140   I = I + DI * H                               'find current at next step
2150 WEND                                                           'loop ends
2160 '
2170 RETURN
2180 '
3000 '************************************************************************
3010 'subroutine to x- & y- axis , to choose scales
3020 'input variables: IMIN, TMIN, IMAX, TMAX, CH%
3030 'output variables: XMIN, XMAX, YMIN, YMAX, PXMIN%, PXMAX%, PYMIN%, PYMAX%
3040 '                  TITLE$, SUBTITLE$, XTITLE$, YTITLE$
3050 'global variables: none
3060 'local variables: none
3070 '************************************************************************
3080 '
3090 IF CH% = 1 THEN TITLE$ = "Growth of current in LR - circuit"
3100 IF CH% = 2 THEN TITLE$ = "Decay of current in LR - circuit"
3110 '
3120 PXMIN% = 136: PXMAX% = 392: PYMIN% = 24: PYMAX% = 144
3130                                                     'choose screen region
3140 SUBTITLE$ = "Current vs. time"
3150 XTITLE$ = "t": YTITLE$ = "i"
3160 XMIN = TMIN: XMAX = TMAX           'assign limits for graphics subroutine
3170 YMIN = IMIN: YMAX = IMAX
3180 '
3190 GOSUB 6000                                     'find scales and draw axes
3200 '
3210 RETURN
3220 '
4000 '************************************************************************
4010 'subroutine to display graph
4020 'input variables: T, I, KCOEFF1, KCOEFF2, KCOEFF3, KCOEFF4
4030 'output variables: none
4040 'global variables: none
4050 'local variables:T1, T2, I1, I2
4060 '************************************************************************
4070                                            'perform scale transformations
4080 T2 = KCOEFF1 * T + KCOEFF2
4090 I2 = KCOEFF3 * I + KCOEFF4
4100 '
4110 IF T = TMIN THEN 4140                                 'jump if first time
4120 '
4130 LINE (T1, I1)-(T2, I2)                             'draw current vs. time
4140 '
4150 T1 = T2: Q1 = Q2: I1 = I2                    'roll variables for graphics
4160 '
4170 RETURN
4180 '
5000 '************************************************************************
5010 'subroutine for getting inputs for growth of current in LR circuit
5020 'input variables:  none
5030 'output variables: R, L, V, TC, H, TMIN, TMAX, IMIN, IMAX, II
5040 'global variables: none
5050 'local variables:  none
5060 '************************************************************************
5070 CLS
5080 LOCATE 2, 5: PRINT "Please give circuit parameters"
5090 LOCATE 3, 10
5100 IF CH% = 1 THEN PRINT "for studying growth of current in the LR circuit"
5110 IF CH% = 2 THEN PRINT "for studying decay of current in the LR circuit"
5120 '
5130 LOCATE 5, 10: INPUT "Value of Resistance R = "; R
5140  IF R > 0 THEN 5160
5150  BEEP: LOCATE 5, 10: PRINT SPACE$(65): GOTO 5130
5160 LOCATE 7, 10: INPUT "Value of Inductance L = "; L
5170  IF L > 0 THEN 5200
5180  BEEP: LOCATE 7, 10: PRINT SPACE$(65): GOTO 5160
5190 '
5200 IF CH% = 1 THEN 5230 ELSE 5270
5210                                           'for case=1 (growth of current)
5220  II = 0                                    'set initial current condition
5230 LOCATE 9, 10: INPUT "Voltage applied (at t = 0) "; V
5240  IF V <> 0 THEN 5310
5250  BEEP: LOCATE 9, 10: PRINT SPACE$(65): GOTO 5230
5260                                          'for case = 2 (decay of current)
5270 LOCATE 9, 10: INPUT "Initial current in the circuit  (at t = 0) ="; II
5280  IF II <> 0 THEN 5310
5290  BEEP: LOCATE 9, 10: PRINT SPACE$(65): GOTO 5270
5300 '
5310 LOCATE 11, 10: INPUT "Maximum time = "; TMAX
5320   IF TMAX > 0 THEN 5340
5330   BEEP: LOCATE 11, 10: PRINT SPACE$(65): GOTO 5310
5340 LOCATE 13, 10: INPUT "Give time step h  = "; H
5350   IF H > 0 THEN 5370
5360   BEEP: LOCATE 13, 10: PRINT SPACE$(65): GOTO 5340
5370 '
5380 TMIN = 0: IMIN = 0                               'set limits for graphics
5390 IF CH% = 1 THEN IMAX = V / R ELSE IMAX = II
5400 '
5410 RETURN
5420 '
6000 '************************************************************************
6010 'subroutine to display graph between x(i) & y(i) variables
6020 'input variables: XTITLE$, YTITLE$, TITLE$, SUBTITLE$
6030 '                 PXMIN%, PXMAX%, PYMIN%, PYMAX%
6040 'output variables: KCOEFF1, KCOEFF2, KCOEFF3 ,KCOEFF4,
6050 'global variables: none
6060 'local variables: XMIN, XMAX, YMIN, YMAX, ROWTIT%, COLTIT%
6070 '                 DIV%, XSCALE, YSCALE, PXSCALE, PYSCALE
6080 '                 PMX%(J%), PMY%(J%), ROWX%, COLX%, ROWY%, COLY%
6090 '************************************************************************
6100 CLS
6110 LOCATE 1, 15: PRINT TITLE$
6120  DIV% = 4                    'set number of divisions (<5) on x- & y-axes
6130                                                  'find scale coefficients
6140 KCOEFF1 = (PXMAX% - PXMIN%) / (XMAX - XMIN)
6150 KCOEFF2 = (PXMAX% * XMIN - PXMIN% * XMAX) / (XMIN - XMAX)
6160 KCOEFF3 = (PYMAX% - PYMIN%) / (YMIN - YMAX)
6170 KCOEFF4 = (PYMAX% * YMAX - PYMIN% * YMIN) / (YMAX - YMIN)
6180 '
6190 ROWTIT% = PYMIN% / 8 + 1: COLTIT% = PXMAX% / 8 + 2
6200 LOCATE ROWTIT%, COLTIT%: PRINT SUBTITLE$               'print graph-title
6210 '
6220 LINE (PXMIN%, PYMIN%)-(PXMAX%, PYMAX%), , B           'draw box for graph
6230 LINE (PXMIN%, KCOEFF4)-(PXMAX%, KCOEFF4)                     'draw x-axis
6240 LINE (KCOEFF2, PYMIN%)-(KCOEFF2, PYMAX%)                     'draw y-axis
6250 '
6260 XSCALE = (XMAX - XMIN) / DIV%                       'find scale for marks
6270 YSCALE = (YMAX - YMIN) / DIV%
6280 '
6290 PXSCALE = (PXMAX% - PXMIN%) / DIV%            'find pixel scale for marks
6300 PYSCALE = (PYMAX% - PYMIN%) / DIV%
6310 '
6320 ROWX% = PYMAX% / 8 + 2              'find row for marks along x-direction
6330 COLY% = PXMIN% / 8 - 10          'find column for marks along y-direction
6340 '
6350 FOR J% = 0 TO DIV%                          'start loop to mark divisions
6360   PMX(J%) = PXMIN% + PXSCALE * J%                    'find places to mark
6370   PMY(J%) = PYMIN% + PYSCALE * J%
6380    LINE (PMX(J%), PYMAX%)-(PMX(J%), PYMAX% - 5)               'draw marks
6390    LINE (PXMIN%, PMY(J%))-(PXMIN% + 5, PMY(J%))
6400 '
6410   IF J% / 2 <> INT(J% / 2) THEN 6650            'jump for alternate marks
6420 '
6430   COLX% = PMX(J%) / 8 - 3         'find column for each mark along x-axis
6440   ROWY% = PMY(J%) / 8 + 1            'find row for each mark along y-axis
6450 '
6460   LOCATE ROWX%, COLX%
6470    IF XMAX > 999.99 OR XMIN < -999.99 THEN 6510
6480    IF XMAX < .01 AND XMIN > -.01 THEN 6510              'format selection
6490   PRINT USING "+###.##"; XMIN + XSCALE * J%      'print x-scale divisions
6500   GOTO 6530
6510   PRINT USING "+#.##^^^^"; XMIN + XSCALE * J%    'print x-scale divisions
6520 '
6530   LOCATE ROWY%, COLY%
6540    IF YMAX > 999.99 OR YMIN < -999.99 THEN 6580
6550    IF YMAX < .01 AND YMIN > -.01 THEN 6580              'format selection
6560   PRINT USING "+###.##"; YMAX - YSCALE * J%      'print y-scale divisions
6570   GOTO 6600
6580   PRINT USING "+#.##^^^^"; YMAX - YSCALE * J%    'print y-scale divisions
6590 '
6600   IF J% <> 2 THEN 6650              'print names of variables along x & y
6610    LOCATE ROWX%, COLTIT% + 3: PRINT XTITLE$; " ->"
6620    LOCATE ROWY% - 1, COLY% - 1: PRINT "^"
6630    LOCATE ROWY%, COLY% - 1: PRINT "|"
6640    LOCATE ROWY% + 1, COLY% - 1: PRINT YTITLE$
6650 NEXT J%
6660 '
6670 RETURN
6680 '
10000 '***********************************************************************
10010 'subroutine to display header screen
10020 'input variables:  none
10030 'output variables: none
10040 'global variables: none
10050 'local variables:  none
10060 '***********************************************************************
10070 CLS : KEY OFF                                           'clear screen
10080 SCREEN 2, 0, 0: WIDTH 80                               'change screen
10090  '
10100 LINE (1, 1)-(638, 40), , B                                'draw boxes
10110 LINE (5, 3)-(633, 37), , B
10120 LINE (70, 50)-(570, 140), , B
10130 LINE (75, 53)-(565, 137), , B
10140                                           'print title, authors, etc.
10150 LOCATE 3, 7
10160 PRINT " C O M P U T A T I O N A L   P H Y S I C S :";
10170 PRINT " (An  Introduction)"
10180 LOCATE 9, 40
10190 PRINT "by";
10200 LOCATE 11, 20: PRINT "R.C. Verma, P.K. Ahluwalia & K.C. Sharma"
10210 LOCATE 13, 34
10220 PRINT "   * * * *    "
10230 '
10240 BEEP
10250 LOCATE 15, 35: PRINT "* * * * * *"
10260 LOCATE 22, 25: PRINT "press any key to continue"
10270 LOCATE 23, 25: PRINT "-------------------------"
10280 '
10290 IF INKEY$ = "" THEN 10290                            'hold the screen
10300 CLS                                                     'clear screen
10310 RETURN
10320 '
