 '************************************************************************
 'Chapter 15, Example 6A:
 'COMPUTATIONAL PHYSICS: An Introduction
 'by R. C. Verma, P. K. Ahluwalia and K. C. Sharma
 '
 '************************************************************************
  CLS : KEY OFF
  GOSUB 10000                                               'show header
'
CLS
OPEN "poincare.out" FOR OUTPUT AS #1
SCREEN 2
PI# = 3.14159
INPUT "c,d,w", c#, d#, w#
DEF FNF (T#, x#, V#) = -c# * V# - SIN(x#) + d# * COS(w# * T#)
LET N# = 25
LET H# = 2 * PI# / (w# * N#)
LET T# = 5.4 * PI# / 4
LET x# = 1
LET V# = 3
CLS
j = 1
DO WHILE j < 10000
j = j + 1
PRINT #1, x#, V#
'PSET (X, V)
FOR I = 1 TO N#
LET K1# = H# * FNF(T#, x#, V#)
LET K2# = H# * FNF(T# + .5 * H#, x# + H# * .5 * V#, V# + .5 * K1#)
LET K3# = H# * FNF(T# + .5 * H#, x# + H# * .5 * (V# + .5 * K1#), V# + .5 * K2#)
LET K4# = H# * FNF(T# + H#, x# + H# * V# + H# * K2# * .5, V# + K3#)
LET x# = x# + H# * V# + H# * (K1# + K2# + K3#) / 6
LET V# = V# + (K1# + K2# + K2# + K3# + K3# + K4#) / 6
LET T# = T# + H#
IF x# > PI# THEN LET x# = x# - 2 * PI#
IF x# < -PI# THEN LET x# = x# + 2 * PI#
NEXT I
LOOP
CLOSE

10000 '********************************************************************
10010 ' subroutine to display header screen
10020 'input variables:  none
10030 'output variables: none
10040 'global variables: none
10050 'local variables:  none
10060 '********************************************************************
10070 CLS : KEY OFF                                           'clear screen
10080 SCREEN 2, 0, 0: WIDTH 80                               'change screen
10090  '
10100 LINE (1, 1)-(638, 40), , B                                'draw boxes
10110 LINE (5, 3)-(633, 37), , B
10120 LINE (70, 50)-(570, 140), , B
10130 LINE (75, 53)-(565, 137), , B
10140                                           'print title, authors, etc.
10150 LOCATE 3, 7
10160 PRINT " C O M P U T A T I O N A L   P H Y S I C S :";
10170 PRINT " (An  Introduction)"
10180 LOCATE 9, 40
10190 PRINT "by";
10200 LOCATE 11, 20: PRINT "R.C. Verma, P.K. Ahluwalia & K.C. Sharma"
10210 LOCATE 13, 34
10220 PRINT "Copyright 1995"
10230 '
10240 BEEP
10250 LOCATE 15, 35: PRINT "* * * * * *"
10260 LOCATE 22, 25: PRINT "press any key to continue"
10270 LOCATE 23, 25: PRINT "-------------------------"
10280 '
10290 IF INKEY$ = "" THEN 10290                            'hold the screen
10300 CLS                                                     'clear screen
10310 RETURN
10320 '

END

