DECLARE FUNCTION f (t#, x#, v#)
TYPE f
 f AS DOUBLE
 t AS DOUBLE
 x AS DOUBLE
 v AS DOUBLE
END TYPE
DECLARE SUB rk4 (pi#, t#, x#, v#, xnew#, vnew#, h#, c#, d#, w#)
TYPE rk4
 x AS DOUBLE
 v AS DOUBLE
 h AS DOUBLE
 c AS DOUBLE
 d AS DOUBLE
 w AS DOUBLE
 k1 AS DOUBLE
 k2 AS DOUBLE
 k3 AS DOUBLE
 k4 AS DOUBLE
 xnew AS DOUBLE
 vnew AS DOUBLE
END TYPE
CONST pi# = 3.1415962654#
'
'************************************************************************
'Chapter 15, Example 6B:
'COMPUTATIONAL PHYSICS: An Introduction
'by R. C. Verma, P. K. Ahluwalia and K. C. Sharma
'
'************************************************************************
CLS : KEY OFF
GOSUB 10000                                               'show header
'
CLS
SCREEN 2
OPEN "adap.dat" FOR OUTPUT AS #1
'
CONST eps# = .000001                               'tolerance
CONST c# = .16
CONST w# = 2
CONST d# = 2
PRINT "I am working"
n = 25
h# = .5
'h# = 2 * pi# / (w# * n)                          '.0314156*2
'tp# = 2 * pi# / w#                               'time period
'PRINT tp#
t# = 5.4 * pi# / 4                               '
x# = 1
v# = 3
'
DO WHILE II# < 100000
                                                 'adaptive- size method
 CALL rk4((pi#), t#, x#, v#, xnew#, vnew#, h#, (c#), (d#), (w#))
 half# = h# / 2
 CALL rk4((pi#), t#, x#, v#, xnh#, vnh#, half#, (c#), (d#), (w#))
 CALL rk4((pi#), t# + half#, xnh#, vnh#, xn#, vn#, half#, (c#), (d#), (w#))
 d1# = ABS(xn# - xnew#)
 d2# = ABS(vn# - vnew#)
        IF d1# > d2# THEN
                delta# = d1#
          ELSE
          delta# = d2#
        END IF
        IF delta# < eps# THEN
              tnew# = t# + h#
              w1# = (pi# - w# * t#) - (INT((pi# - w# * t#) / (2 * pi#)) * 2 * pi#)
              w2# = (w# * tnew# - pi#) - (INT((w# * tnew# - pi#) / (2 * pi#)) * 2 * pi#)
              'w1# = (pi# - w# * t#) MOD (2 * pi#)
              'w2# = (w# * tnew# - pi#) MOD (2 * pi#)
              'PRINT w1#, w2#
              IF w1# < (w# * h#) THEN
                  IF w2# < (w# * h#) THEN
                  tp1# = w1# / w#
                  'PRINT tp1#
                  CALL rk4((pi#), t#, x#, v#, xp#, vp#, tp1#, (c#), (d#), (w#))
              IF ABS(xp#) > pi# THEN xp# = xp# - 2 * pi# * ABS(xp#) / xp#
                PRINT #1, xp#, vp#
                count = count + 1
                PRINT xp#, vp#, count, t# * w# / (2 * pi)
              'END IF
              END IF
               END IF
             x# = xnew#
             v# = vnew#
             t# = t# + h#
                h# = h# * .95 * (eps# / delta#) ^ .25
              'PRINT "h#", h#
              IF ABS(x#) > pi# THEN
                x# = x# - 2 * pi# * ABS(x#) / x#
              END IF
        ELSE
           h# = h# * .95 * (eps# / delta#) ^ .2
        END IF
        II# = II# + 1
        LOCATE 2, 1: PRINT II#
LOOP
CLOSE #1
PRINT t#
10000 '********************************************************************
10010 ' subroutine to display header screen
10020 'input variables:  none
10030 'output variables: none
10040 'global variables: none
10050 'local variables:  none
10060 '********************************************************************
10070 CLS : KEY OFF                                           'clear screen
10080 SCREEN 2, 0, 0: WIDTH 80                               'change screen
10090  '
10100 LINE (1, 1)-(638, 40), , B                                'draw boxes
10110 LINE (5, 3)-(633, 37), , B
10120 LINE (70, 50)-(570, 140), , B
10130 LINE (75, 53)-(565, 137), , B
10140                                           'print title, authors, etc.
10150 LOCATE 3, 7
10160 PRINT " C O M P U T A T I O N A L   P H Y S I C S :";
10170 PRINT " An  Introduction "
10180 LOCATE 9, 40
10190 PRINT "by";
10200 LOCATE 11, 20: PRINT "R.C. Verma, P.K. Ahluwalia & K.C. Sharma"
10210 LOCATE 13, 34
10220 PRINT " "
10230 '
10240 BEEP
10250 LOCATE 15, 35: PRINT "* * * * * *"
10260 LOCATE 22, 25: PRINT "press any key to continue"
10270 LOCATE 23, 25: PRINT "-------------------------"
10280 '
10290 IF INKEY$ = "" THEN 10290                            'hold the screen
10300 CLS                                                     'clear screen
10310 RETURN
10320 '

END

FUNCTION f (t#, x#, v#) STATIC
f = -c# * v# - (1 - d# * COS(w# * t#)) * SIN(x#)
'f = x# - c# * v# - x# * x# * x# + d# * COS(w# * t#)
END FUNCTION

SUB rk4 (pi#, t#, x#, v#, xnew#, vnew#, h#, c#, d#, w#) STATIC
k1# = h# * f(t#, x#, v#)
k2# = h# * f(t# + .5 * h#, x# + .5 * h# * v#, v# + .5 * k1#)
k3# = h# * f(t# + .5 * h#, x# + .5 * h# * (v# + .5 * k1#), v# + k3#)
k4# = h# * f(t# + h#, x# + h# * v# + h# * k2# * .5, v# + k3#)
xnew# = x# + h# * v# + h# * (k1# + 2 * k2# + 2 * k3# + k4#) / 6
vnew# = v# + (k1# + 2 * k2# + 2 * k3# + k4#) / 6
'PRINT xnew#, vnew#
END SUB

