10 KEY OFF: CLS
20 'Shrodinger equation for 1-dim HO potential (Runge-Kutta method)
30 FLAG=0                        'set flag
40 DEF FNPOT(X) = .5*X*X         'define potential function
50 '
60 BEEP:INPUT " Choose parity of state desired:  odd/even = ";PAR$
70 IF PAR$<>"odd" AND PAR$<>"ODD" AND PAR$<>"even" AND PAR$<>"EVEN" THEN 60
80 INPUT "Give maximum x =";XMAX
90 INPUT "Give step size h = ";H
100 BEEP:LOCATE 22,10:INPUT "guess energy of the state = ";EGUESS
110 '
120  XMIN= 0                       'initial point
130 ' initial conditions for odd/even states
140  IF PAR$="odd" OR PAR$="ODD" THEN PSI=1 :PSI1=0
150  IF PAR$="even" OR PAR$="EVEN" THEN PSI=0 :PSI1=1
160 '
170 IF FLAG=0 THEN  GOSUB 1010      'draw axes first time only
180 '
190 X=XMIN:E=EGUESS               'to start solving Schrodinger eq.
200 '
210 WHILE (X <=XMAX AND ABS(PSI) < PSIMAX)  'start loop over steps
220   K1= PSI1                    'find Runga-Kutta variables
230    P1 = 2*(FNPOT(X)-E)*PSI
240   K2= PSI1+.5*P1*H
250    P2 = 2*(FNPOT(X+H/2)-E)*(PSI+.5*K1*H)
260   K3= PSI1+.5*P2*H
270    P3 = 2*(FNPOT(X+H/2)-E)*(PSI+.5*K2*H)
280   K4= PSI1+.5*P3*H
290    P4 = 2*(FNPOT(X+H)-E)*(PSI+K3*H)
300 '
310    PSI= PSI+(K1+2*K2+2*K3+K4)*H/6      'new wavefunction
320    PSI1= PSI1+(P1+2*P2+2*P3+P4)*H/6    'new derivative
330    GOSUB 2010                      'plot the wavefunction
340    X=X+H                               'new position
350 WEND
360 '
370 IF PSIOLD*PSI >= 0 THEN 400           'check for sign change
380 LOCATE 4,8:PRINT USING "energy lies from +##.#### to +##.#### ";EOLD,EGUESS
390 '                                      'print the energy range
400 BEEP:LOCATE 23,1:INPUT "do you want to try another guess Y/N ";ANS$
410 IF LEFT$(ANS$,1 )<>"y" AND LEFT$(ANS$,1)<>"Y" THEN 450
420 EOLD=EGUESS : PSIOLD=PSI                'remember the last results
430 GOTO 100                                'another search
440 '
450 END
460 '
1000 'subroutine to draw axes of the graph
1010 SCREEN 2,0,0:WIDTH 80:CLS       'change screen for graphics
1020 PSIMIN=-2:PSIMAX=2            'range of wavefunction for graphics
1030 XSCALE=500/(XMAX-XMIN)          'find scales for x- & y-axes
1040 YSCALE=150/(PSIMAX-PSIMIN)
1050 '
1060 LINE (40,8)- (540,158), ,B         'draw the axes
1070 LOCATE 1,10:PRINT "wavefunction vs x"
1080 LINE (40,83) - (540,83)
1090 '
1100 FLAG=1     'change flag to avoid this subroutine next time
1110 '
1120 RETURN
1130 '
2000 'subroutine to plot the wave-function
2010 X%=X*XSCALE+40               'scale transformations
2020 Y%=(PSIMAX-PSI)*YSCALE+8
2030 IF X> XMIN THEN LINE -(X%,Y%) ELSE PSET(X%,Y%) 'draw the curve
2040 RETURN
