10 REM *********************************************************
20 'Trial values for INPUT t-max = 50, N0 = 200, D0 = 0, p = 0.1
30 ' For a good run:
40 '   keep value of p small 0 < p < 0.2 
50 '   keep number of parent nuclei    100 < N < 999  
60 '   keep   10 < TMAX < 50                          
70 REM *********************************************************
80 CLS: KEY OFF                         'clear screen
90 '
100 GOSUB 1000                          'introduce the program
110 '
120 INPUT "Initial number of parent nuclei N0 = ";N    
130  PRINT                               'step 1
140 INPUT "Initial number of daughter nuclei D0 = ";D  
150  PRINT                               'step 2
160 INPUT "decay probability p = ";P        
170  PRINT                               ' step 3
180 INPUT "Maximum number of intervals";TMAX             
190  PRINT                      'choose maximium time for x-axis
200 RANDOMIZE                           'step 4
210 T=0 :NI=N :DI=D                     'step 5 initialization
220 '
230 GOSUB 2000                          'draw axes for graph
240 '
250 WHILE (N>0  AND T < TMAX)           'step 6
260  NU=N                               'step 7
270    FOR I%=1 TO NU                    'step 8
280      X=RND                          'step 9
290      IF X<P THEN N=N-1 : D=D+1      'step 10
300    NEXT I%                           'step 11
310  T=T+1                              'step 12
320  GOSUB 3000                         'step 13
330  IF N <.5*NI THEN  350              'step 14
340  HALF=T                             'identify half-life
345 LOCATE 12,22
346  PRINT "halflife = ";HALF;" N( 1/2) = ";N 'print half-life
350 WEND                                'step 15
360 '
400 LOCATE 23,1:BEEP
440 END                                 'step 16
450 '
1000 '***********************************************************
1010 'subroutine to introduce the program
1020 'variables: none
1030 '***********************************************************
1050  LOCATE 5,10
1060 PRINT "This program describes a Monte Carlo Simulation"
1070  LOCATE 7,20
1080 PRINT "of Radioactive decay with stable daughter"
1090  LOCATE 9,30
1100 print "and finds approximatre half life of parent nucleus
1110 locate 12,10 : beep
1120 print " please give parameters of the sample":print
1130 '
1140 RETURN
1150 '
2000 '**********************************************************
2010 'subroutine to draw axes of the graph
2020 'Input variables: TMAX
2030 'Output variable: XSCALE, YSCALE, N1%, T1%
2040 'local variables: XPT, YPT
2050 'Global variable: NI, TMAX
2060 '**********************************************************
2065 SCREEN 2,0,0:WIDTH 80           'change screen for graphics
2070 XSCALE=500/TMAX : YSCALE=150/NI    'scales for x- & y-axes
2080 CLS                                'clear screen
2090 LINE (40,8)- (540,158), ,B         'draw the axes
2095 LOCATE 1,40:PRINT "Graph between N vs. t"
2100 '
2110 FOR J%=0 TO 5                       'mark y-axis
2120   YPT = J%*30+8
2130   LINE (36,YPT)-(40,YPT)
2140   K%=J%*30/8+1                      '8 for pixels ratio
2150   LOCATE K%,1 :PRINT (5-J%)*N/5
2160 NEXT J%
2163 LOCATE 10,70:PRINT "^"
2164 LOCATE 11,70:PRINT "|              'labe y-axis
2165 LOCATE 12,70:PRINT "N"
2170 '
2180 FOR J%=0 TO 5                       'mark x-axis
2190   XPT=J%*100+40
2200   LINE (XPT,158)-(XPT,163)
2210   K%=J%*100/8+4
2220   LOCATE 22,K%:PRINT J%*TMAX/5
2230 NEXT J%
2235 LOCATE 23,30:PRINT "t ->           labe x-axis
2240 '
2250 N1%=8                           'find first point of graph
2260 T1%=40
2270 '
2280 RETURN
2290 '
3000 '**********************************************************
3010 'subroutine to graph the number of decaying nuclei vs. t
3020 'Input variables: N, T, XSCALE, YSCALE
3030 'Output variable: None
3040 'local variables: T1%, T2%, N1%, N2%
3050 'Global variable: NI
3060 '**********************************************************
3070  '                   scale transformation for x- & y-axes
3080 T2%=T*XSCALE+40 
3090 N2%=(NI-N)*YSCALE+8              
3100 LINE (T1%,N1%)-(T2%,N2%)           'join with last point
3110 T1%=T2% : N1%=N2%                  'roll the values
3120 '
3130 return
3140 '


