10 CLS : KEY OFF
20 PRINT
30 PRINT "****************************************************"
40 PRINT
50 PRINT "This program describes ": PRINT
60 PRINT "     motion of an object in two dimensions ": PRINT
70 PRINT "          ignoring air drag": PRINT
80 PRINT "To include air drag make DC = 0.46 in line 230": PRINT
90 'test case : r=0.1, m=1, vi=10, th=45, h=0.01
100 PRINT
110 PRINT "****************************************************"
120 PRINT
130 DIM T(500), AX(500), AY(500), VX(500), VY(500), Y(500), X(500)
140 '                                    'dimension the arrays
160 '
170 DEF FNX (X, Y) = -DEC * X * SQR(X * X + Y * Y)'accerelation formulas
180 DEF FNY (X, Y) = G - DEC * Y * SQR(X * X + Y * Y)
190 '
210 G = -9.8                     'acceleration due to gravity
220 PI = 3.1415926#
230 DC = 0!                      'drag coefficients taken zero
240 RHO = 1.2                     'density of medium (air)
250 '
260 INPUT "radius and mass  of the  ball r  ,m  "; R, M: PRINT
280 DEC = .5 * DC * RHO * PI * R * R / M
290 '
300 INPUT "Give initial velocity of the projection"; VI: PRINT
320 INPUT "Angle of projection (-180 to 180)"; THD: PRINT
340 INPUT "time increment  0 < t < 0.02 = ", H 'time step
360 TH = THD * PI / 180
370 XI = 0: YI = 0                   'initial position fixed
380 XMAX = VI * VI / ABS(G): YMAX = .5 * VI * VI / ABS(G)
390 XMAX = 1.1 * XMAX: YMAX = 1.1 * YMAX: XMIN = -XMAX: YMIN = YI
400   UX = VI * COS(TH): UY = VI * SIN(TH)'find velocity components
410   TMAX = 2 * ABS(UY / G)         'time of fall (graphics)
420                 'find limits for graphics
430 '                               'main program begins
440                'convert  degrees of angle to radian
450 DEC = .5 * DC * RHO * PI * R * R / M'drag factor
460 '
470   N% = TMAX / H + 1              'no. of steps
480   VX(0) = UX: VY(0) = UY: T(0) = 0: X(0) = XI: Y(0) = YI'initialization
490   AX(0) = FNX(VX(0), VY(0))         'acceleration decrement
500   AY(0) = FNY(VX(0), VY(0))
510   VX(0) = VX(0) + AX(0) * H * .5    'velocity at half-step
520   VY(0) = VY(0) + AY(0) * H * .5
530 '
540 PRINT "----------------------------------------------"
550 PRINT " t   ,  Vx   ,   Vy   ,     X   ,     Y   "
560 PRINT "----------------------------------------------"
570 FOR I = 0 TO N%
580   T(I) = H * I
590   AX(I) = FNX(VX(I), VY(I))      'acceleration decrement
600   AY(I) = FNY(VX(I), VY(I))
610   VX(I + 1) = VX(I) + AX(I) * H  'velocity formula
620   VY(I + 1) = VY(I) + AY(I) * H
630   X(I + 1) = X(I) + VX(I) * H    'distance formula
640   Y(I + 1) = Y(I) + VY(I) * H
650    PRINT USING "##.##, +##.###, +##.###,  +##.###,  +##.###"; T(I); VX(I); VY(I); X(I); Y(I)
660 NEXT I                              'loop ends
670 '
750 END                                 'program ends

