10 CLS: KEY OFF
20 PRINT :PRINT
30 PRINT "*****************************************************"
40 PRINT
50 PRINT "This program describes motion of":PRINT
60 PRINT "            a satellite around a planet":PRINT
70 PRINT "                fired from top of a mountain":PRINT
80 PRINT "                using Feynman-Newton method":PRINT
90 'test case:RS=50,YM=10,VI=0.14 (escape vel.),h=1,TMAX=10000
100 PRINT "*****************************************************"
110 PRINT
120 '
130 FLAG=0                 'set flag
140 DEF FND(X,Y)=(X*X+Y*Y)^1.5    'acceleration components
150 DEF FNX(X,Y)=-X*P/FND(X,Y)
160 DEF FNY(X,Y)=-Y*P/FND(X,Y)
170 '
190 PI=3.1415926#
200 P=1!         'P=GM ,G Newton's constant,M mass of planet
210 '
220 INPUT  "Give initial velocity of the projection";VI :PRINT
240 INPUT "Angle of projection ";TH   :PRINT
260 INPUT "radius of earth ";RS :PRINT
280 INPUT "height of mountain ";YM  :PRINT
300 INPUT "time step (near 1 s) ";H  'increment in time
320 '
330 XE=120:YE=100: XM=0   'initial position fixed
340 XI=0 : YI=RS+YM
350 '
360 '
370 TMAX = 3*PI*(RS+YM)^1.5     'approximate time period
380 '  2 replaced by 3 to take care of numerical errors (shear guess)
390 '
400 GOSUB 840      'to draw the planet & firing station
410                          'main program begins
420   N%=TMAX/H              'no. of steps
430   TH=TH*PI/180           'convert degree to radian
440   UX=VI*COS(TH) : UY=VI*SIN(TH)  ' find velocity components
450   VX=UX :VY=UY:    X0=XI:Y0=YI  'initialization
460   AX=FNX(X0,Y0)              'acceleration formulas
470   AY=FNY(X0,Y0)
480   VX=VX+.5*AX*H                  'velocity at half-step
490   VY=VY+.5*AY*H
500   R=SQR(X0^2+Y0^2)            'distance from centre
570 WHILE R > RS
580   X=X0+VX*H                   'distance formula
590   Y=Y0+VY*H
600   R=SQR(X^2+Y^2)      'distance from centre
610   LOCATE 23,1:IF R>= RS THEN PRINT USING "t=####.##  R=###.####  Vx= +##.####  Vy=+##.####";T,R,VX,VY
620   GOSUB 1040                     'draw trajectory
630   T=T+H
640   AX=FNX(X,Y)               'acceleration decrement
650   AY=FNY(X,Y)
660   VX=VX+AX*H                  'velocity formula
670   VY=VY+AY*H
680   X0=X: Y0=Y                    'roll the values
690 WEND
700 '
730 '
740 LOCATE 21,1:PRINT SPACE$(75)
750 LOCATE 21,10:BEEP
760 INPUT "give new velocity & angle of projection = ";VI,TH
770 '
780 GOTO 430             ' repeat the program with new velocity
790 '
800 END
810 '
820 '*********************************************************
830 '
840 ' subroutine to draw the planet & place of firing
850 '
860 '*********************************************************
870 IF FLAG=1 THEN RETURN    'draw planet first time only
880 CLS:SCREEN 2,0,0:WIDTH 80
890 '
900 'to choose center of screen as center of circle
910 '                       keep  x1=120,y1=100, r <100
920 LOCATE 1,20
930 PRINT "Simulation of Trajectory of a Satellite"
940 LOCATE 13,30:PRINT "PLANET"
950 '
960  CIRCLE (2.5*XE,YE),RS*2.5  'draw the planet
970 '                         'draw the flashing station
980  LOCATE (YE-RS-YM)/8+1,XE*2.5/8:PRINT "*"
990  LINE (XE*2.5,YE-RS)-(XE*2.5,YE-RS-YM)
1000 '
1010 FLAG = 1
1020 RETURN
1030 '
1040 '*************************************************************
1050 ' sub for graphics
1060 '*************************************************************
1070 Y1=YE-Y0                   'scaling for graphics
1080 X1=XE+X0   : X1=X1*2.5
1090 Y2=YE-Y
1100 X2=XE+X    : X2=X2*2.5
1110 LINE (X1,Y1)-(X2,Y2)       'draw the trajectory
1120 '                          'firing station falshes
1130 LOCATE (YE-RS-YM)/8+1,XE*2.5/8:PRINT SPACE$(1)
1140 LOCATE (YE-RS-YM)/8+1,XE*2.5/8:PRINT "*"
1150 '
1160 RETURN
1170 '
