10 CLS :KEY OFF
20 PRINT :PRINT
30 PRINT "*************************************************************":PRINT
40 PRINT "This program describes motion of driven oscillators   ":PRINT
50 'Test case : k=9, m=1, u=0, xi=0, c=3.0 ,omega=3.5 :f0=2
60 'For large k, small m keep time interval small/ large damping
70 PRINT "*************************************************************":PRINT
80 DIM T(2000),A(2000),V(2000),S(2000),ETOT(2000)
90 PI=3.1415926#
100  DEF FNA(X,V,T)=(-K*X-C*V+F0*COS(OMEGA*T))/M   'acceleration function
110 '
120 INPUT "spring constant & mass of the object ";K,M
130        OMEGAN=SQR(K/M)                           'find natural frequency
140 INPUT "damping coefficient";C  :PRINT
150 INPUT "initial position ";XI
160 INPUT "initial velocity ";U    :PRINT
170 PRINT "Give frequency of driver between ";.5*OMEGAN;" & ";2*OMEGAN
180 INPUT "omega = ";OMEGA
190 INPUT "and amplitude of driving force = ";F0  :PRINT
200 INPUT "time step < 0.1  = ",H       'increment in time
210 INPUT " t max = ";TMAX
220 '
230 PERIOD=2*PI/OMEGA                     'expected time period
240 NC% = 2*(TMAX/PERIOD+1)               'no. of cycles
250 DIM TP(NC%)                           'dimension calculated
260 N%=TMAX/H                             'find time steps
270 '
280 STP=0                                 'initialization
290 V(0)=U :T(0)=0 :S(0)=XI
300   A(0)= FNA(S(0),V(0),T(0))           'acceleration at t=0
310   V(0)=V(0)+.5*A(0)*H                 'velocity at half step
320   PRINT                               'print title
330   PRINT "----------------------------------------------"
340   PRINT " time acceleration velocity position  energy"
350   PRINT "----------------------------------------------"
360 '                                     'print title
370 FOR  I = 0 TO  N%
380   T(I+1)=H*(I+1)
390   S(I+1)=S(I)+V(I)*H                  'distance formula
400   A(I+1)=FNA(S(I+1),V(I),T(I+1))     'acceleration formula
410   V(I+1)=V(I)+A(I+1)*H                  'velocity formula
420   ETOT(I) = .5*(M*V(I)*V(I)+K*S(I)*S(I))  'find total energy
430 IF S(I+1)*S(I)<0 THEN STP=STP+1: TP(STP)=I  'sign change in S to find T
440   PRINT USING "##.###, +#.####, +##.####, +##.####,  +##.####";T(I),A(I),V(I),S(I),ETOT(I)
450 NEXT I
460 '
470 PRINT "----------------------------------------------"
480 PRINT
1000 '
1010 ' following steps make the numerical instabilty transparent
1020 ' Compare time period :numerical vs theoretical
1030 '
1040 TIME=(TP(STP)-TP(STP-1))*H*2             'find time period
1050 PRINT "numerical T = ";TIME;" : Theoretical T ";PERIOD
1060 '
1070 ' Compare max amplitude :numerical vs theoretical
1080 '
1090  SMAX=0 :SMIN = 0: TMIN = 0
1100 FOR I = 0 TO N%               'find max numerical amplitude
1110   IF S(I)< SMIN THEN SMIN=S(I)
1120   IF S(I)> SMAX THEN SMAX=S(I)
1130 NEXT I
1140 IF ABS(SMIN) > ABS(SMAX) THEN SMAX = -SMIN ELSE SMIN = - SMAX
1150 '                                 find theoretical amplitude
1160 AMP=(F0/M)/SQR((OMEGAN^2-OMEGA^2)^2+(C*OMEGA)^2)
1170 PRINT "Amplitude (numerical) = ";SMAX;", (theoretical) = ";AMP
2000 '
2010 PRINT :PRINT "press any key to continue"  :PRINT
2020 IF INKEY$="" THEN 2020
3000 '
3010 'following part draws the x vs. t curve
3020 '
3030 SCREEN 2,0,0:WIDTH 80           'change screen
3040 CLS
3050 '
3060 LINE (70,91)-(570,91)            'draw x-axis
3070 LINE (70,11)-(70,171)            'draw x-axis
3080 LOCATE 1,10: PRINT " x vs. t trajectory"
3090 '                                   label the axes
3100 LOCATE 12,74:  PRINT "t -->"
3110 LOCATE  9,1:  PRINT " ^  "
3120 LOCATE 10,1:  PRINT " |  "
3130 LOCATE 11,42:  PRINT "s(t)"
3140 '                                   'find scales
3150 YSCALE=160/(SMAX-SMIN)
3160 XSCALE=500/(TMAX-TMIN)
3170                        'to graph the velocity & acceleration
3180 FOR I%=0 TO N%
3190   T(I%)=T(I%)*XSCALE+70
3200   S(I%)=91-S(I%)*YSCALE
3210   IF I%>0 THEN  LINE (T(I%-1),S(I%-1))-(T(I%),S(I%))
3220 NEXT I%
3230 '
3235 LOCATE 20,1
3240 END
3250 '
