10 'This program shows a Travelling pulse
20 '
30 CLS:KEY OFF
40 PI=3.141592
50 '
60 DEF FNF(X,T)=SIN(2*PI*(X-V*T)/LAM) 'define pulse fn
70 '
80  INPUT "Give wavelength, velocity of pulse";LAM,V
85  INPUT "Xmax ";XMAX
90 TMAX=XMAX/V
100  HX=.05: HT=.2             'step size for x & t variables
110  XMIN=0:T=0               'initial postion & time
120  GOSUB 1010                'find scales & draw x-axis
130 '
140 WHILE T =< TMAX           'loop over time
150   XMIN=V*T  'starting position of pulse at next instant
160   X= XMIN                'initialize x
170   GOSUB 2020               'clean the box
180   WHILE X =< XMIN+LAM     'loop for space points
190     Y = FNF(X,T)          'pulse amplitude
200     IF X <=XMAX THEN GOSUB 3020 ' draw pulse
210     X=X+HX                'increment space point
220   WEND                    'loop over x ends
230   T=T+HT                  'increment time
240 WEND                      'loop over t ends
250 '
260 END                       'program ends
270 '
1000 'subroutine to draw axes of the graph
1010 CLS
1020 SCREEN 2,0,0:WIDTH 80       'change screen for graphics
1030 YMIN=-1:YMAX=1              'max., min, for graphics
1040 XSCALE=500/(XMAX-XMIN)      'scales for x- & y-axes
1050 YSCALE=150/(YMAX-YMIN)
1060 LOCATE 1,10:PRINT "Traveling pulse:"
1070 LOCATE 1,28:PRINT "wavelength = ";LAM;", velocity = ";V
1080 LINE (41,83)-(539,83)           'base axis
1090 RETURN
1100 '
2000 'subroutine for clearing the box
2010 '
2020 LINE (40,9)-(540,82), 0, BF     'clean the last box
2030 LINE (40,84)-(540,160), 0, BF
2040 BEEP                           'beep for new instant
2050 LOCATE 3,60 :PRINT USING "t = ##.##";T 'print current time
2060 X1%=XMIN*XSCALE+40               'initial point of pulse
2070 Y1%=(YMAX-FNF(XMIN,T))*YSCALE+8
2080 PSET(X1%,Y1%)                     'first point of pulse
2090 RETURN
2100 '
3000 'subroutine to graph the pulse
3010  '                   scale transformations for x- & y-axes
3020 X2%=X*XSCALE+40                   'present position
3030 Y2%=(YMAX-Y)*YSCALE+8             'present amplitude
3040 LINE -(X2%,Y2%)                 'join with last point
3050 RETURN
3060 '
