10 'This program performs Fourier sum of harmonic waves
20 '
30 CLS : KEY OFF
35 DIM AMP(25)         'give dimensions for amplitude array
40  'define function for wave amplitude for odd harmonics
50 DEF FNF (I, T) = AMP(I) * SIN((2 * I - 1) * W * T)
60 '
80 '
90 ' data for amplitude of first 25 odd harmonics
100 DATA 1, .333333, .2, .142857, .111111, 0.090909
110 DATA .076923, .066667, .058824, .052632, .047619
120 DATA .043478, 0.04, .037037, .034483, .03228
130 DATA .030303, .028571, .027027, .025641, .024390
140 DATA .023256, .022222, .021277, .020408
150 '
160 INPUT "No. of terms to be included  <25 "; NWAVE
170 INPUT "Give the funamental frequency w "; W
180 INPUT "maximum time Tmax "; TMAX
190 INPUT "Give step size "; H
200 '
210 FOR I = 1 TO NWAVE
220  READ AMP(I)              'read corresponding amplitude
230 NEXT I
240 '
270 GOSUB 1020             'draw base line
280 '
290  T = 0                   'initialize time
295 '
300 WHILE T <= TMAX          'loop over time
310    Y = 0               'initialize sum
320    FOR I = 1 TO NWAVE           'loop over waves
330      Y = Y + FNF(I, T)        'in nondispersive medium
340    NEXT I                        'loop over waves ends
350    GOSUB 2020             'draw resultant wave
360    T = T + H             'increment time
370 WEND                     'loop over time ends
380 '
390 END
400 '
1000 'subroutine to draw axes of the graph
1010 '
1020 SCREEN 2, 0, 0: WIDTH 80: CLS 'change screen for graphics
1030 '        find maximum possible amplitude for graphics
1040 FOR I = 1 TO NWAVE: YMAX = YMAX + AMP(I): NEXT I
1050 YMIN = -YMAX: TMIN = 0       'lower limits
1060  XSCALE = 480 / (TMAX - TMIN)'scales for x- & y-axes
1070  YSCALE = 160 / (YMAX - YMIN)
1080 LOCATE 1, 30!                 'print title
1090  PRINT "Fourier Sum of Harmonic Waves: Square Wave"
1100  LINE (64, 96)-(544, 96)          'draw base line
1110 RETURN
1120 '
2000 'subroutine to draw the waves
2010  '             scale transformations for graphics
2020  X% = T * XSCALE + 64
2030  Y% = (YMAX - Y) * YSCALE + 16
2040 IF T > TMIN THEN LINE -(X%, Y%) ELSE PSET (X%, Y%)
2050 RETURN
2060 '

