10 'This program shows propagation of superposed waves
20 ' dispersive & nondispersive media using
30 ' dispersion formula W = W x sqr(V)
40 '
50 CLS:KEY OFF
60 PI=3.141592
70                   'define function for wave amplitude
80 DEF FNF(X,T)=AMPD*SIN(KVEC*X-WFRQ*T)
90 PRINT "Feed parameters of the component waves":PRINT
100 INPUT "no. of waves to be superposed = ";NWAVE:PRINT
110 '
120 FOR I= 1 TO NWAVE
130  PRINT "wave no. =";I
140  INPUT "amplitude, wave-vector, & frquency";AMP(I),KVE(I),WFR(I)
150 NEXT I
160 '
170 PRINT :INPUT "tmax, xamx ";TMAX,XMAX
180 '
190 XMIN=0:T=0             'initialize time & position
200 H=.1: HT=.5            'step sizes
210 '
220 GOSUB 440              'draw base lines
230 '
240 WHILE T <=TMAX           'loop over time
250  X= XMIN                 'initialize position
260  GOSUB 1160               'clear screen
270  WHILE X <= XMAX             'loop over space points
280    SUMY=0 :SUMZ=0            'initialize sum
290    FOR I=1 TO NWAVE             'loop over waves
300      AMPD=AMP(I):KVEC= KVE(I):WFRQ=WFR(I) 'wave parameters
310      SUMY = SUMY + FNF(X,T)     'in nondispersive medium
320      WFRQ=WFR(I)*SQR(KVEC)      'change frequency for
330      SUMZ = SUMZ + FNF(X,T)     'dispersive medium
340   NEXT I                        'loop over waves ends
350   Z = SUMZ                   'total amplitudes
360   Y = SUMY
370   GOSUB 2090                  'draw wave in both media
380   X=X+H                      'next space point
390  WEND                        'loop over space points ends
400  T=T+HT                   'increment time
410 WEND                      'loop over time ends
420 '
430 END
440 '
1000 'subroutine to draw axes of the graph
1010 '
1020 SCREEN 2,0,0:WIDTH 80      'change screen for graphics
1030 CLS
1040 '        find maximum possible amplitude for graphics
1050 FOR I=1 TO NWAVE : YMAX=YMAX+AMP(I):NEXT I
1060 YMIN=-YMAX
1070  XSCALE=480/(XMAX-XMIN)      'scales for x- & y-axes
1080  YSCALE=80/(YMAX-YMIN)
1090 LOCATE 1,30!    'print title
1100  PRINT "Wave Propagation in"
1110 LOCATE 2,1:PRINT "1) non-dispersive medium"
1120  LINE (64,56)- (544,56)           'draw base line
1130 LOCATE 13,1:PRINT "2) dispersive  medium"
1140  LINE (64,144)- (544,144)
1150 RETURN
1160 '
2000 'subroutine to clear screen
2010 '
2020 LINE (65,17)-(543,55), 0, BF    'clean upper box
2030 LINE (65,57)-(543,94), 0, BF
2040 LINE (65,105)-(543,143), 0, BF    'clean lower box
2050 LINE (65,145)-(543,183), 0, BF
2060 BEEP                              'beep for new instant
2070  LOCATE 4,70 :PRINT USING "t = ##.##";T 'print new instant
2080 RETURN
2090 '
3000 'subroutine to draw the waves
3010  '             scale transformations for graphics
3020  X2%=X*XSCALE+64
3030  Y2%=(YMAX-Y)*YSCALE+16
3040  Z2%=(YMAX-Z)*YSCALE+104
3050 IF X> XMIN THEN LINE (X1%,Y1%)-(X2%,Y2%)    'join with last point
3060 IF X> XMIN THEN LINE (X1%,Z1%)-(X2%,Z2%)    'join with last point
3070  X1%=X2% : Y1%= Y2% :Z1%=Z2%                  'roll the values
3080 RETURN
3090 '
