10 CLS:KEY OFF
20 'This program shows interference in double slit expt.
30 '
40 PI=3.141592                 'define amplitude function
50 DEF FNF(X,Y,T)=AMPD*((COS(KVEC*X-WFRQ*T))/X + (COS(KVEC*Y - WFRQ *T))/Y)
60 '
70  INPUT "wavelength of light (angstrom) = ";LAM  :PRINT
80 INPUT "amplitude  of light (unit = 1) = ";AMPD :PRINT
90 INPUT "screen length (20 mm) ";YMAX    :PRINT
100 INPUT "distance from slit & screen (200 mm) = ";DIS :PRINT
110 INPUT "slit spacing (0.01 mm) ";SL  :PRINT
120 INPUT "no. of points on the screen (32) ";NPTS
130 INPUT "time step for one cycle (8) ";NTIME :PRINT
140                   'set graphios
150 H= YMAX/NPTS
160 LAM=LAM*.0000001 : CL = 30         'speed of light (x 10 ^ 10 mm/s)
170 KVEC=2*PI/LAM : WFRQ=CL*LAM        'wave vector & frequency
180                              'coordinates of slits
190 X1=0 : Y1=.5*(YMAX-SL) : X2=X1: Y2=.5*(YMAX+SL)
200 X=DIS+X1                    'x-coordinate of points on screen
210 GOSUB 400                         'draw two slit arrangement
230 '
240 FOR I = 0 TO NPTS                  'loop over screen points
250  Y=YMIN+I*H                        'scaning the screen
260  R1= (X-X1)*(X-X1)+(Y-Y1)*(Y-Y1)   'find distance from slit 1
270  R2= (X-X2)*(X-X2)+(Y-Y2)*(Y-Y2)   'find distance from slit 2
280  R1=SQR(R1) : R2=SQR(R2)
290  INTS=0                            'initialize intensity
300  FOR T= 1 TO NTIME                 'loop over time period
310    AMP= FNF(R1,R2,T)               'find resultant amplitude
320    INTS = INTS+AMP*AMP             'update intensity
330  NEXT T
340  INTS=INTS/NTIME                   'find average intensity
350  GOSUB 1140                         'draw intensity
360 NEXT I
370 '
380 END
400 '
1000 'subroutine to draw axes of the graph
1010 '
1020 SCREEN 2,0,0:WIDTH 80 :CLS      'change screen for graphics
1030 ZMAX=(AMPD*2/DIS)^2 : ZMIN=0 :YMIN = 0
1040 YSCALE=160/(YMAX-YMIN)          'find scale for main screen
1050 ZSCALE=200/(ZMAX-ZMIN)          'find intensity scale
1060 YS1= 93:YS2= 118:XS=100         'screen coordinates of slits
1070 SW = 2                          'slit width
1080 LINE (400,24) - (400,186)       'draw main screen
1090 LINE (XS,24)-(XS,YS1-SW)        'draw slit-screen
1100 LINE (XS,YS1+SW)-(XS,YS2-SW)
1110 LINE (XS,YS2+SW)-(XS,186)
1120 LOCATE 14,6:PRINT "*"            'source of light
1130 RETURN
1140 '
2000 'subroutine to graph
2010  '                   scale transformation for x- & y-axes
2020 X2%=400 : X1%=100             'x-coordinate of two screens
2030 Y2%=(YMAX-Y)*YSCALE+26        'y-coordinate of this point
2040 Z%=(INTS-ZMIN)*ZSCALE+400     'intensity scaled
2050 LINE (101,25)-(399,.185), 0, BF
2060 LINE (X1%,YS1)-(X2%,Y2%)    'draw light path from slit 1
2070 LINE (X1%,YS2)-(X2%,Y2%)    'draw light ray from slit 2
2080 LINE (X2%,Y2%) - (Z%,Y2%)   'draw intensity at this point
2090 RETURN
