10 CLS:KEY OFF
20 'This program shows the diffraction in N-slit expt.
30 DIM XS(100),YS(100),YGS%(100)      'give dimensions for slits
40 PI=3.141592
50 '           define wave-amplitude function
60 DEF FNF(X,T)=AMPD*COS(KVEC*X-WFRQ*T)/X
70            'feed the inputs
80  INPUT "wavelength of light (angstrom) = ";LAM       :PRINT
90  INPUT "amplitude  of light (unit = 1) = ";AMPD      :PRINT
100 INPUT "screen length (10 mm) ";YMAX                 :PRINT
110 INPUT "distance from slit & screen (200 mm) = ";DIS :PRINT
120 INPUT "slit size   (0.01 mm) ";SZ                   :PRINT
130 INPUT "no. of slits (10) ";NSLIT                    :PRINT
140 INPUT "no. of points on the screen ";NPTS           :PRINT
150 INPUT "time step for one cycle  ";NTIME
160 '                      find slit spacing
170 SL=SZ/(NSLIT-1)  : BL = (YMAX-(NSLIT+1)*SL)*.5
180 FOR J=1 TO  NSLIT : YS(J)=J*SL+BL:XS(J)=0: NEXT J
190 '
200 H= YMAX/NPTS                      'step size
210 LAM=LAM*.0000001 :CL = 30         'speed of light (x 10 ^ 10 mm/s)
220 KVEC=2*PI/LAM : WFRQ=CL*LAM       'find wave vector & frequency
230 X=DIS:YMIN = 0                    'coordinates of screen
240 GOSUB 1010                        'draw slits arrangement
250 '
260 FOR I = 0 TO NPTS                 'loop over points on screen
270   Y=YMIN+I*H                      'scaning the screen
280   INTS=0                          'initialize intensity
290   GOSUB 4010                      'clear box
300   GOSUB 2020                      'draw ray from each slit
310   FOR T= 1 TO NTIME               'loop over time period
320     SUMA=0                        'initialize total amplitude
330     FOR J= 1 TO NSLIT             'loop over slits
340       R= (X-XS(J))*(X-XS(J))+(Y-YS(J))*(Y-YS(J)) 'find distance
350       R=SQR(R)
360       AMP1= FNF(R,T)              'find wave amplitude
370       SUMA = SUMA+AMP1            'update total amplitude
380     NEXT J
390     INTS=INTS+SUMA*SUMA           'update intensity
400   NEXT T
410   INTS=INTS/NTIME                 'average intensity
420   GOSUB 3010                      'draw intensity
430 NEXT I
440 GOSUB 4010                        'clean the box
450 END
470 '
1000 'subroutine to draw axes of the graph
1005 '
1010 SCREEN 2,0,0:WIDTH 80:CLS       'change screen for graphics
1015 ZMAX=(AMPD*NSLIT/DIS)^2:ZMIN=0  'intensity limits for graphics
1020 YSCALE=160/(YMAX-YMIN)          'find scale along screen axis
1025 ZSCALE=200/(ZMAX-ZMIN)          'find scale for light intensity
1030 '
1035 LINE (400,24) - (400,184)       'draw slits arrangement
1040 LINE (100,24)-(100,184)
1045 '
1050 GA=-60/(NSLIT-1) : GB=134-GA   'find slits dimensions and
1055 YS1= 93 : YS2= 118 : SW=2      'coordinates for graphics
1060 '
1065 FOR J%= 1 TO NSLIT
1070  YGS%(J%) = GA*J%+GB           'y-cordinate of slits
1075  PRESET(100,YGS%(J%))          'draw slits
1080 NEXT J%
1085 '
1090 LOCATE 14,6:PRINT "*"          'source of light
1095 RETURN
1100 '
2000 'subroutine to draw rays of light
2010  '                   scale transformation for x- & y-axes
2020 X2%=400 : X1%=100
2030 Y2%=(YMAX-Y)*YSCALE+26
2040  '
2050 FOR J%=1 TO NSLIT
2060  LINE (40,104)-(X1%,YGS%(J%))    'start from source
2070  LINE (X1%,YGS%(J%))-(X2%,Y2%)    'draw light ray from each slit
2080 NEXT J%
2090 RETURN
2100 '
3000 'subroutine to draw intensity histogram
3005               'scale transformation for intensity
3010 X2%=400
3015 YI2%=(YMAX-Y-.5*H)*YSCALE+26    'histogram y-coordinates
3020 YF2%=(YMAX-Y+.5*H)*YSCALE+26
3025 Z%=(INTS-ZMIN)*ZSCALE+400       'histogram height
3030 LINE (X2%,YI2%) - (Z%,YF2%),1,BF    'draw solid box
3035 RETURN
3040 '
4000 'subroutine to clean middle of screen
4005 '
4010 LINE (41,25)-(99,183), 0, BF
4015 LINE (101,25)-(399,190), 0, BF
4020 RETURN
