10 CLS:KEY OFF
20 'motion of polarization vector
30 PI=3.141592
40   'define amplitude function of light
50 DEF FNF(A,X,T,P)=A*SIN(KV*X-WF*T-PI*P/180)
60 '
70 INPUT "wave vectro & frequency of the light = ";KV,WF :PRINT
80 INPUT "X, Y components of its Electric Field = ";EXI, EYI:PRINT
90 INPUT "phases of x, y components = ";PHX,PHY   :PRINT
100 INPUT "tmax ";TMAX
110 '
120 X=0:T=0                  'initialize time and x
130 H=.1                     'time step
140 GOSUB 1020                'draw axes
150 '
160 WHILE T < TMAX            'loop over time
170  GOSUB 2020                'clear box
180  EX=FNF(EXI,X,T,PHX)      'find x component of Field vector
190  EY=FNF(EYI,X,T,PHY)      'find y component of field
200  GOSUB 3020                'draw field vector
210  T=T+H                    'increment time
220 WEND
230 '
240 END
250 '
1000 'subroutine to draw axes of the graph
1010 '
1020 SCREEN 2,0,0:WIDTH 80 :CLS     'change screen for graphics
1030 IF EXI>= EYI THEN MAX= EXI ELSE MAX=EYI
1040 EXMAX=MAX:EXMIN=-EXMAX         'set limits for graphics
1050 EYMAX=MAX:EYMIN=-EYMAX
1060 YSCALE=128/(EYMAX-EYMIN)       'scale along y-axis
1070 XSCALE=YSCALE*2.5              'x-scale:aspect ratio 2.5
1080 '
1090 XL%=(EXMIN-EXMIN)*XSCALE+64    'corners of coordinate system
1100 YM%=(EYMAX-EYMIN)*YSCALE+16
1110 XM%=(EXMAX-EXMIN)*XSCALE+64
1120 YL%=(EYMAX-EYMAX)*YSCALE+16
1130 LOCATE 1,10:PRINT "Polarization: Electric Field Vector Orientation"
1140 XH%=.5*(XL%+XM%)  : XD%=(XM%-XL%)/4
1150 YH%=.5*(YL%+YM%)  : YD% = (YM%-YL%)/4
1160  LINE (XL%,YH%)-(XM%,YH%)        'draw x and y axes
1170  LINE (XH%,YL%)-(XH%,YM%)
1180 RETURN
1190 '
2000 'subroutine to clear box
2010 '
2020 LINE (XL%,YL%)-(XH%-1,YH%-1), 0, BF
2030 LINE (XL%,YH%+1)-(XH%-1,YM%), 0, BF
2040 LINE (XH%+1,YL%)-(XM%,YH%-1), 0, BF
2050 LINE (XH%+1,YH%+1)-(XM%,YM%), 0, BF
2060 LOCATE 3,70 :PRINT USING "t = ##.##";T   'current time
2070 RETURN
2080 '
3000 'subroutine to draw field vector
3010  '                   scale transformation for x- & y-axes
3020 X%=(EX-EXMIN)*XSCALE+64
3030 Y%=(EYMAX-EY)*YSCALE+16
3040 LINE (XH%,YH%)-(X%,Y%)    'join with last point
3050 RETURN
