10 CLS: KEY OFF        'clear screen
20 'This program describes motion of a charged particle
30 '  inside a magnetic field
40 PI = 3.141592#
50  DEF FNX(V) = MAGFAC*V        'define acceleration functions
60  DEF FNY(V) = -MAGFAC*V
70 '
80  INPUT "Give charge & mass of the partcle ";CH,MASS
90 INPUT  "Give initial velocity of the particle";VI
100 INPUT  "Give angle of shooting  of the particle";TH
110 INPUT  "Give initial position x,y (-100 to 100)";XI,YI
120 INPUT "strength of the magnetic field ";MAG
130 INPUT "time max = ";TMAX
140 INPUT "time step ";H
150 '
160 'set parameters of the field etc. for graphics
170 RS=50                'radius of magnetic region
180 LSPEED = 1               ' speed of light = 1
190 XE=120:YE=100: XM=0   'position of magnetic field fixed
200 '
210 GOSUB 470                   'to draw the magnetic region
220                             'main program begins
230 MAGFAC= CH*MAG/(MASS*LSPEED)  'useful factor
240 TH=TH*PI/180              'convert degree to radian
250 VX=VI*COS(TH) : VY=VI*SIN(TH)  ' find velocity components
260  X=XI:Y=YI                     'initialization
270 '
280   T=0                  'initialize time
290 '
300 WHILE (T < TMAX AND ABS(X) <200 AND ABS(Y) < 200)
310   X=X+VX*H                     'distance formula
320   Y=Y+VY*H
330   R=SQR(X^2+Y^2)
340   KE= .5*MASS*(VX*VX+VY*VY)   'find K.E.
350   GOSUB 2010                  'draw trajectory
360   IF R > RS THEN 410          'particle lies outside field
370   AX=FNX(VY)                  'acceleration formula
380   AY=FNY(VX)
390   VX=VX+AX*H                  'velocity formula
400   VY=VY+AY*H
410   LOCATE 20,1
420   PRINT USING "t=###.##, x=+###.###, y=+###.###, K.E.= ####.###,";T,X,Y,KE
430   T=T+H                        'increment time
440 WEND
450 '
460 END
470 '
1000 'subroutine to draw magnetic region
1010 CLS:SCREEN 2,0,0:WIDTH 80  'change screen
1020 'to choose center of screen as center of circle
1030 'keep  x1=120,y1=100, r <100
1040 '
1050 LOCATE 1,5
1060 PRINT "Trajectory of a charged Particle in & out of Magnetic Field""
1070  HC=1
1080 '
1090 FOR I=0 TO 2*RS               'loop to draw magnetic region
1100   XP=-RS+I*HC +XE
1110   YP=YE+SQR(RS*RS-(XP-XE)^2)
1120   ZP=YE-SQR(RS*RS-(XP-XE)^2)
1130   XP=XP*2.5                       'multiply by aspect ratio 2.5
1140   IF I=0 THEN 1170                 ' normalize the x & y scales
1150   LINE (XP0,YP0)-(XP,YP)
1160   LINE (XP0,ZP0)-(XP,ZP)
1170   XP0=XP: YP0=YP:ZP0=ZP
1180 NEXT I
1190 RETURN
1200 '
2000 ' subroutine to draw trajectory
2010 YG=YE-Y                'for present position
2020 XG=XE+X    : XG=XG*2.5
2030 IF T>0 THEN LINE -(XG,YG) ELSE PSET(XG,YG)  'draw trajectory
2040 RETURN
