10 CLS: KEY OFF        'clear screen
20 'This program describes motion of a charged particle
30 '  inside a magnetic field
40 PI = 3.141592#
50 DEF FNX(V) = MAGFAC*V      'define acceleration function
60 DEF FNY(V) = -MAGFAC*V
70 '
80  INPUT "Give charge & mass of the partcle ";CH,MASS
90  INPUT  "Give initial velocity of the particle";VI
100  INPUT  "Give angle of shooting  of the particle";TH
110 INPUT  "Give initial position x,y (-100 to 100)";XI,YI
120 INPUT "strength of the magnetic field ";MAG
130 INPUT "time max = ";TMAX
140 INPUT "time step ";H
150 '
160 'set parameters of the field etc. for graphics
170 RS=50                   'radius of magnetic region
180 LSPEED = 1              ' speed of light = 1
190 '
200 GOSUB 1020                   'to draw the magnetic region
210                             'main program begins
220 MAGFAC= CH*MAG/(MASS*LSPEED)  'useful factor
230 TH=TH*PI/180                'convert degree to radian
240 CVX=VI*COS(TH) :CVY=VI*SIN(TH)  ' find velocity components
250 X=XI:Y=YI    'initialization
260   T=0                          'initialize time
270 '
280 WHILE T < TMAX
290   VXH=CVX:VYH=CVY           'roll vel. components
300   R=SQR(X*X+Y*Y)          'find distance from centre
310   KE= .5*MASS*(CVX*CVX+CVY*CVY)   'find Kinetic energy
320   LOCATE 22,1       'print time & distance from centre
330   PRINT USING "t = ###.##  x = +###.###, y = +###.###  K.E. = ###.### ";T,X,Y,KE
340   GOSUB 2000               'draw energy graph
350 '                       gain energy only between D's
360   IF R > RS   THEN 410 'particle lies outside field
370   PVX=VXH+FNX(VYH)*H    'predictor formula
380   PVY=VYH+FNY(VXH)*H
390   CVX=VXH+.5*(FNX(VYH)+FNX(PVY))*H   'corrector formula
400   CVY=VYH+.5*(FNY(VXH)+FNY(PVX))*H
410   X=X+.5*(CVX+VXH)*H      'distance formula
420   Y=Y+.5*(CVY+VYH)*H
430   T=T+H                  'increment time
440 WEND
450 '
460 END
470 '
1000 ' subroutine to draw the magnetic field
1010 '
1020 CLS:SCREEN 2,0,0:WIDTH 80  'change screen
1030 'to choose center of screen as center of circle keep
1040 XE=120:YE=100: XM=0     'position of magnetic field fixed
1050  HC=1
1060 '
1070 FOR I=0 TO 2*RS               'loop to draw magnetic region
1080   XP=-RS+I*HC +XE
1090   YP=YE+SQR(RS*RS-(XP-XE)^2)
1100   ZP=YE-SQR(RS*RS-(XP-XE)^2)
1110   XP=XP*2.5                       'multiply by aspect ratio 2.5
1120   IF I=0 THEN 1150                 ' normalize the x & y scales
1130   LINE (XP0,YP0)-(XP,YP)
1140   LINE (XP0,ZP0)-(XP,ZP)
1150   XP0=XP: YP0=YP:ZP0=ZP
1160 NEXT I
1170 '
1180 RETURN
1190 '
2000 ' subroutine to draw trajectory
2010 YG=YE-Y                'for present position
2020 XG=XE+X    : XG=XG*2.5
2030 IF T>0 THEN LINE -(XG,YG) ELSE PSET(XG,YG) ' draw trajectory
2040 RETURN
