10 CLS :KEY OFF           'clear screen
20 'This program describes motion of a charged particle
30 '  within a cyclotron
40 'define functions for acceleration components
50 DEF FNX(V,T) = MAGFAC*V +AMP*SIN(WF*T)
60 DEF FNY(V,T) = -MAGFAC*V
70 '
80 INPUT "Give charge & mass of the partcle ";CH,MASS :PRINT
90 INPUT "strength of the magnetic field ";MAG
100 INPUT "Strength & freq. of the Electric Field";EL,WF
110 INPUT "maximum time of run  = ";TMAX
120 INPUT "time step (near 1 s) ";H
130 '
140 RS = 50                  'radius of D's
150 WID = 10                 'distance between D's
160 LSPEED = 1               ' speed of light = 1
170 '                       'energy limits for graphics
180 GOSUB 1000               'to draw the K.E. graph
190 MAGFAC= CH*MAG/(MASS*LSPEED) : EF=CH*EL/MASS
200 '                       'useful factors for calculation
210 T=0                      'initialize time
220 X=0:Y=0                  'initialize position
230 CVX=0: CVY=0             'initial velocity
240 '                        'motion starts here
250 WHILE (T < TMAX    AND X > -2*RS )
260   VXH=CVX:VYH=CVY           'roll vel. components
270   R=SQR(X*X+Y*Y)          'find distance from centre
280   KE= .5*MASS*(CVX*CVX+CVY*CVY)   'find Kinetic energy
290   LOCATE 22,1       'print time & distance from centre
300   PRINT USING "t = ###.##  r = ###.##,  K.E. = ###.### ";T,R,KE
310   GOSUB 2000              'draw energy graph
320 '                       gain energy only between D's
330   IF X <=.5*WID AND X >= -.5*WID THEN AMP=EF ELSE AMP=0
340   PVX=VXH+FNX(VYH,T)*H    'predictor formula
350   PVY=VYH+FNY(VXH,T)*H
360   CVX=VXH+.5*(FNX(VYH,T)+FNX(PVY,T))*H   'corrector formula
370   CVY=VYH+.5*(FNY(VXH,T)+FNY(PVX,T))*H
380   X=X+.5*(CVX+VXH)*H      'distance formula
390   Y=Y+.5*(CVY+VYH)*H
400   T=T+H                  'increment time
410 WEND
420 '
430 END
440 '
1000 ' Following program draws graph between velocity and time
1010 SCREEN 2,0,0:WIDTH 80              'change screen
1020 CLS: KEY OFF                       'clear screen
1030                           'screen max & min coordinates
1040 SXMIN=70:SXMAX=570
1050 SYMIN=50:SYMAX=150
1060 LINE (SXMIN,SYMAX)-(SXMAX,SYMAX)   'draw x-axis
1070 LINE (SXMIN,SYMIN)-(SXMIN,SYMAX)   'draw y-axis
1080 '
1090 LOCATE 2,10:PRINT "K.E. vs time in a cyclotron"
1100 LOCATE 12,5:  PRINT "K.E."         'K.E.  along y axis
1110 LOCATE 23,40:  PRINT "t"           'time along x-axis
1120                                    'find x & y scales
1130 YMIN = 0                     'energy limits for y-axis
1140 VMAX=CH*MAG*RS/(LSPEED*MASS) :YMAX=.5*MASS*VMAX*VMAX
1150 XMAX=TMAX : XMIN=0                'max & min on x-axis
1160 '          find coefficients for scale transformation
1170 K1=(SXMAX-SXMIN)/(XMAX-XMIN)
1180 K2=(SXMIN*XMAX-SXMAX*XMIN)/(XMAX-XMIN)
1190 K3=(SYMIN-SYMAX)/(YMAX-YMIN)
1200 K4=(SYMAX*YMAX-SYMIN*YMIN)/(YMAX-YMIN)
1210 RETURN
1220 '
2000 ' subroutine to draw garph of K.E. vs time
2010 '            scale transformation for  velocity & time
2020   X%=K1*T+K2
2030   Y%=K3*KE+K4
2040   IF T>0 THEN  LINE -(X%,Y%) ELSE PSET(X%,Y%)  'join successive points
2050 RETURN
