5 CLS
10 PI = 3.1415926#                                        'define constant pi
20                                                          'define functions
30 DEF FNI (W, L, C) = W * L - 1 / (W * C)
40 DEF FNRE (R1, R2, L1, L2) = (R2 * (R1 + R2) + L2 * (L1 + L2)) / ((R1 + R2) ^ 2 + (L1 + L2) ^ 2)
50    'real part of total impedance
60 DEF FNIM (R1, R2, L1, L2) = (R1 * L2 - R2 * L1) / ((R1 + R2) ^ 2 + (L1 + L2) ^ 2)
70    'imaginary part of total impedance
80 '
90 LOCATE 2, 10: PRINT "This program studies a Voltage Divider Circuit"
100 LOCATE 3, 10: PRINT "              involving 2 impedances"
110 LOCATE 4, 10: PRINT "----------------------------------------------"
120 '
130 LOCATE 6, 10: PRINT SPACE$(70)
140 LOCATE 6, 10: INPUT "Give R1, L1, C1 "; R1, L1, C1
150 LOCATE 8, 10: INPUT "Give R2, L2, C2 "; R2, L2, C2
160 LOCATE 10, 10: INPUT "Give amplitude & frequency of voltage"; VIN, FREQ
170 '
180 '
190 WF = 2 * PI * FREQ                          'convert to angular frequency
200 '
210 IF C1 > 0 THEN REACT1 = FNI(WF, L1, C1) ELSE REACT1 = WF * L1
220                                               'reactance in 1st impedance
230 IF C2 > 0 THEN REACT2 = FNI(WF, L2, C2) ELSE REACT2 = WF * L2
240                                               'reactance in 1st impedance
250 QR = FNRE(R1, R2, L1, L2)                   'real part of total impedance
260 QI = FNIM(R1, R2, L1, L2)              'imaginary part of total impedance
270 '
280 VOUT = VIN * (QR * QR + QL * QL) ^ .5                'find output voltage
290                     'find phase difference between output & input voltage
300 IF QR = 0 THEN PHASE = 90: GOTO 330             'if denominator vanishes
310 PHASE = ATN(QI / QR)
320 PHASE = PHASE * 180 / PI                              'convert to degrees
330 '
340 BEEP
350 LOCATE 12, 10
360  PRINT USING "Reactance of 1st impedance +###.###"; REACT1
370 LOCATE 14, 10
380  PRINT USING "Reactance of 2nd impedance +###.###"; REACT2
390 LOCATE 16, 10
400  PRINT USING "Output Voltage = +###.###"; VOUT
410 LOCATE 18, 10
420  PRINT USING "Phase difference = +###.### degree"; PHASE
430 '
440 END
450 LOCATE 16, 10
460  PRINT USING "Output Voltage = +###.###"; VOUT
470 LOCATE 18, 10
480  PRINT USING "Phase difference = +###.### degree"; PHASE
490 '
500 END
