10 CLS : KEY OFF
20 'This program shows Nonliearity in wave propagation"
30 DEF FNF (X, T) = AMPD * SIN(KVEC * X - WFRQ * T)'define function for wave
40 DEF FNNON (X) = (X + EPSI * X ^ POW) / (1 + EPSI)' and nonliearity
50 '
60 INPUT "Give amplitude, wave-vector, & angular frquency"; AMPD, KVEC, WFRQ
70 INPUT "Nonlinearity Parameters: elpsilon, power"; EPSI, POW
80 INPUT "tmax, xamx "; TMAX, XMAX
90 '
100 XMIN = 0: T = 0             'initialize position & time
110 H = .1: HT = .5             'step size
120 '
130 GOSUB 1000                   'draw axes
140 '
150 WHILE T < TMAX              'loop over time
160  LOCATE 4, 70: PRINT USING "t = ##.##"; T'print current time
170  X = XMIN                   'initialize position
180  GOSUB 2000                  'clear boxes
190  WHILE X < XMAX             'loop over space points
200    Y = FNF(X, T)            'find wave amplitude
210    Z = FNNON(Y)             'add nonliearity
220    GOSUB 3000                'draw the waves
230    X = X + H                'next space point
240  WEND
250  T = T + HT                 'increment time
260 WEND
270 '
280 END
290 '
1000 'subroutine to draw axes of the graph
1010 SCREEN 2, 0, 0: WIDTH 80: CLS   'change screen for graphics
1020 YMAX = 0: ZMAX = 0              'initialize upper limits
1030 YMAX = AMPD: ZMAX = FNNON(AMPD)
1040 XMIN = 0: YMIN = -YMAX: ZMIN = -ZMAX
1050 '
1060 XSCALE = 480 / (XMAX - XMIN)    'scales for x, y & z-axes
1070 YSCALE = 80 / (YMAX - YMIN)
1080 ZSCALE = 80 / (ZMAX - ZMIN)
1090 '
1100 LOCATE 1, 10: PRINT "Nonliear effects on incoming wave"
1110 LINE (64, 56)-(544, 56)         'draw upper line
1120 LINE (64, 144)-(544, 144)       'draw lower base line
1130 RETURN
1140 '
2000 'subroutine to clear the lower box
2010 LINE (64, 16)-(544, 55), 0, BF  'clear screen
2020 LINE (64, 57)-(544, 143), 0, BF
2030 LINE (64, 145)-(544, 184), 0, BF
2040 RETURN
2050 '
3000 'subroutine to draw waves in upper & lower boxes
3010 X2% = X * XSCALE + 64      'scale for incoming wave
3020 Y2% = (YMAX - Y) * YSCALE + 16
3030 IF X > XMIN THEN LINE (X1%, Y1%)-(X2%, Y2%)'draw curve
3040  '                         wave with nonliearity
3050 Z2% = (ZMAX - Z) * ZSCALE + 104
3060 IF X > XMIN THEN LINE (X1%, Z1%)-(X2%, Z2%)
3070 X1% = X2%: Z1% = Z2%: Y1% = Y2%    'roll the values
3080 RETURN

