10 CLS: KEY OFF           'clear screen
20 ' Power Analysis in an  LR - circuit
30 GOSUB 3010              'get inputs
40  GOSUB 1010
50 I0=II :T0=0   :WR=0: WL=0 :WT=0 'initialization
60 PV0=0:PL0=0:PR0=0
70 '
80 WHILE T <  TMAX           'loop over time starts
90    DI=(V-I0*R)/L          'di/dt
100    T=T0+H                 'find new time
110   I=I0+DI*H              'current  formula
120   PR=I*I*R               'power consumed R
130   PL=L*I*DI              'power across L
140   PV=V*I                 'power supplied by source
150   GOSUB 2010            'graphics
160   I0=I :T0=T :PR0=PR:PL0=PL:PV0=PV 'roll variables
170 WEND
180 '
190 END
200 '
1000 'subroutine to prepare boxes & scales etc.
1010 SCREEN 2,0,0:WIDTH 80        'change screen for graphics
1020 CLS                          'draw boxes for power
1030 LINE (70 ,1  )-(316,76 ),,B  'across inductance
1040 LINE (70 ,85 )-(316,160),,B  'across resistance
1050 LINE (324,85 )-(570,160),,B  'total power
1060 '`                           label the boxes
1070 LOCATE 2,12:  PRINT "Power in L"
1080 LOCATE 12,12: PRINT "Power in R"
1090 LOCATE 12,43: PRINT "Total Power"
1100 LOCATE 5,45:  PRINT "Power vs time"
1110 '                           set limits for graphics
1120 TMIN=0 : IMAX = V/R:IMIN=0 ::PMAX=V*V/R :PMIN=0
1130 PLMAX=V*V/R :PLMIN=0
1140  YSCALE=75/(PMAX-PMIN)       'find scales
1150  XSCALE=246/(TMAX-TMIN)
1160 RETURN
1170 '
2000 'subroutine for drawing power curves
2010 PL2=(PMAX-PL)*YSCALE+1
2020 PR2=(PMAX-PR)*YSCALE+85
2030 PV2=(PMAX-PV)*YSCALE+85
2040 PL1=(PMAX-PL0)*YSCALE+1
2050 PR1=(PMAX-PR0)*YSCALE+85
2060 PV1=(PMAX-PV0)*YSCALE+85
2070  T1=(T0-TMIN)*XSCALE+70
2080  T2=(T-TMIN)*XSCALE+70
2090    LINE (T1,PL1)-(T2,PL2)
2100    LINE (T1,PR1)-(T2,PR2)
2110    LINE (T1+254,PV1)-(T2+254,PV2)
2120 RETURN
2130 '
3000 'subroutine for  inputs in LR circuit
3010 PRINT "Please give LR-circuit parameters":PRINT
3020 INPUT "Value of Resistance R = ";R
3030 INPUT "Value of Inductance L = ";L
3040 INPUT "Voltage applied = ";V :PRINT
3050 INPUT "maximum time = ";TMAX
3060 INPUT "time step h = ";H
3070 '
3080 PV0=0:PL0=0:PR0=0
3090  II=0                      'initial conditions
3100 RETURN
3110 '
