10 CLS:KEY OFF
20 'This program analyzes a LCR circuit
30 DIM T(1505),I(1505),Q(1505)
40 PI=3.1415926#
50 '                                    'give circuit parameters
60  INPUT "Capacitance & Inductance of the circuit ";C,L
70  INPUT " initial charge on the Capacitor ";QI
80 INPUT " initial current ";I0 :PRINT
90 INPUT "time step  0 < t < 0.1  = ",H
100 INPUT "maximum time = ";TMAX :PRINT
110 '
120 N%=TMAX/H                         'find number of time steps
130 I(0)=I0 :T(0)=0 :Q(0)=QI          'initial conditions
140 IMAX=0:IMIN=0:QMAX=0:QMIN=0:TMIN=0 'intialize limits for graphics
150 LC =- L*C
160 FOR  J = 0 TO  N%                 'loop over time steps
170    T(J)=H*J                       'find current time
180   K1 = H*I(J)               'Runge-Kutta coefficients
190    P1 = H*Q(J)/LC
200   K2 = H*(I(J)+P1/2)
210    P2 = H*(Q(J)+K1/2)/LC
220   K3 = H*(I(J)+P2/2)
230    P3 = H*(Q(J)+K2/2)/LC
240   K4 = H*(I(J)+P3)
250    P4 = H*(Q(J)+K3)/LC
260   TE = .5*(Q(J)*Q(J)/C+L*I(J)*I(J))  'find total energy
270   I(J+1)=I(J)+(P1+2*P2+2*P3+P4)/6   'current  formula
280   Q(J+1)=Q(J)+(K1+2*K2+2*K3+K4)/6   'charge   formula
290   PRINT USING " ###.###   +###.####  +###.####  +###.####";T(J),Q(J),I(J),TE
300   '
310   IF I(J)> IMAX THEN IMAX=I(J)    'find limits for graphics
320   IF I(J)< IMIN THEN IMIN=I(J)
330   IF Q(J)< QMIN THEN QMIN=Q(J)
340   IF Q(J)> QMAX THEN QMAX=Q(J)
350 NEXT J
360 '
370 PRINT :PRINT "press any key to continue"  :PRINT
380 IF INKEY$="" THEN 380             'hold screen
390 GOSUB 1000                         'draw curves for q & i
400 END                               'main program ends here
410 '
1000 'subroutine to graph
1010 SCREEN 2,0,0:WIDTH 80       'change scren
1020 CLS
1030 LOCATE 5,1:PRINT "q vs. t"         'label the curves
1040 LOCATE 15,1:PRINT "i vs. t"
1050 LOCATE 22,10: PRINT "EM Oscillations in LCR circuit"
1060 '
1070 ZSCALE=75/(IMAX-IMIN)             'find scales
1080 YSCALE=75/(QMAX-QMIN)
1090 XSCALE=500/(TMAX-TMIN)
1100 '
1110 SC1=QMAX*YSCALE+5: VC1=IMAX*ZSCALE   'draw axes
1120 LINE (70,SC1)-(570,SC1)
1130 LINE (70,90+VC1)-(570,90+VC1)
1140 '
1150 FOR I%=0 TO N% 'scale transformations & draw curves
1160    I(I%)=(IMAX-I(I%))*ZSCALE+90
1170    Q(I%)=(QMAX-Q(I%))*YSCALE+5
1180    T(I%)=(T(I%)-TMIN)*XSCALE+70
1190 IF I%=0 THEN 1220
1200    LINE (T(I%-1),Q(I%-1))-(T(I%),Q(I%)) 'curve for q vs t
1210    LINE (T(I%-1),I(I%-1))-(T(I%),I(I%))  'curve f or i vs t
1220 NEXT I%
1230 '
1240 RETURN
